Package: maGUI
Type: Package
Title: A Graphical User Interface for Microarray Data Analysis and
        Annotation
Version: 4.0
Date: 2022-04-12
Author: Dhammapal Bharne
Maintainer: Dhammapal Bharne <dhammapalb@gmail.com>
Imports: tcltk, grDevices, utils, Biobase
SystemRequirements: Tktable (>= 2.10)
Suggests: tkrplot, gWidgets2, Rgraphviz, ssize, Biostrings,
        BiocManager, RSQLite, GEOquery, GEOmetadb, RBGL, WGCNA,
        KEGGREST, KEGGgraph, pdInfoBuilder, lumi, oligo, graph, affy,
        genefilter, beadarray, GOstats, GO.db, Category, annotate,
        impute, limma, graphics, methods, stats
Description: Provides a comprehensive graphical user interface for analysis of Affymetrix, Agilent, Illumina, Nimblegen and other microarray data. It can perform miscellaneous tasks such as gene set enrichment and test analyses, identifying gene symbols and building co-expression network. It can also estimate sample size for atleast two-fold expression change. The current version is its slenderized form for compatable and flexible implementation.
License: GPL-2
LazyLoad: yes
NeedsCompilation: no
Packaged: 2022-04-11 21:49:27 UTC; dhamma
Repository: CRAN
Date/Publication: 2022-04-11 22:22:28 UTC
Built: R 4.6.0; ; 2026-04-25 20:09:36 UTC; unix

dmo<-function(h,...){
	tonl_i<<-tonl_i+1
	w_imp1<-tktoplevel()
	tkwm.title(w_imp1,"Online Data")
	tkwm.resizable(w_imp1,0,0)
	frame1_imp1<-ttkframe(w_imp1,padding=c(3,3,12,12))
	tkpack(ttklabel(frame1_imp1,text='Enter a GSE number:'),side="left",padx=12)
	exp_file<-tclVar("")
	c1<-ttkentry(frame1_imp1,textvariable=exp_file,width=25)
	tkpack(c1,side="left",anchor="e")
	tkpack(frame1_imp1,expand=TRUE,fill="both",side="top")
	frame2_imp1<-ttkframe(w_imp1,padding=c(3,3,12,12))
	r_but1<-ttkbutton(frame2_imp1,text="Ok")
	tkpack(r_but1,side="top",anchor="e",pady=5)
	tkpack(frame2_imp1,expand=TRUE,fill="both",side="top")
	tkconfigure(r_but1,command=function(){
		tkwm.withdraw(w_imp1)
		if(length(grep("GSE",tclvalue(exp_file))!=0)){
			gse_no<-tclvalue(exp_file)
			folder<-tclvalue(tkchooseDirectory(title="Destination Folder"))
			folder_O[[tonl_i]]<<-folder
			setwd(folder)
			new_data.matrix_online=NULL;data.matrix_online=NULL
			try(({
pb_ma<-tkProgressBar(title="Pre-processing...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
				new_gse=NULL
				new_gse<-getGEO(gse_no,GSEMatrix=TRUE,destdir=folder_O[[tonl_i]])
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
				gse<-new_gse[[1]]
				ann_O[[tonl_i]]<<-annotation(gse)
				ORF<-featureData(gse)@data$ORF
				use_probe<-which(is.na(ORF)==F & match(ORF,"",nomatch=0)==0)
				new_data.matrix_online<-exprs(gse)[use_probe,]
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
				data.matrix_online<-new_data.matrix_online
				rownames(new_data.matrix_online)<-ORF[use_probe]
				if(length(new_data.matrix_online)!=0){data.matrix_online=NULL;data.matrix_online<-new_data.matrix_online}
		 	}),silent=TRUE)
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
			if(length(new_data.matrix_online)==0)tkmessageBox(title="Error",message="Could not load this type of data!",icon="error",type="ok")
		}
		if(length(data.matrix_online)!=0){
			if(length(new_data.matrix_online)!=0){
	
			prnt<-paste("Online-Data",tonl_i,sep="_")
			tree_prnts<<-c(tree_prnts,prnt)
			l_data.matrix_online[[tonl_i]]<<-data.matrix_online
p_enter<-tcl(treeview,"insert","","end",values=as.tclObj(prnt))
	
			autopa<-tkmessageBox(title="Confirm",message="Do you want to pre-process and analyze automatically!",icon="question",type="okcancel")
			if(tclvalue(autopa)=="ok"){
pb_ma<-tkProgressBar(title="Normalization...",label="",min=0,max=1,initial=0,width=500)
				Med<-median(data.matrix_online,na.rm=TRUE)
				if(Med>16)
				{
					data.matrix_onlineLog<-log2(data.matrix_online)
				} else {
					data.matrix_onlineLog<-data.matrix_online
				}
				l_data.matrix_onlineLog[[tonl_i]]<<-data.matrix_onlineLog
				na.length<-length(which(is.na(data.matrix_onlineLog)==TRUE))
				if(na.length > 0)l_data.matrix_onlineImp[[tonl_i]]<<-impute.knn(data.matrix_onlineLog,k=10,rowmax=0.5,colmax=0.3)$data
				if(na.length <= 0)l_data.matrix_onlineImp[[tonl_i]]<<-data.matrix_onlineLog
	
				data.matrix_onlineNorm=NULL;
				data.matrix_onlineNorm.m=NULL;use.data.matrix_onlineNorm.m=NULL;xf=NULL;data.matrix_onlineNorm.f=NULL;data.matrix_onlineNorm.s=NULL;
				design=NULL;design_O=NULL;ttx=NULL;DE_O=NULL;DE_O_2=NULL;use_DE_O=NULL;
				sample.dist_O=NULL;
#			pca_O=NULL;
#			sample.clust_O=NULL;	
#			clas_O=NULL;
				try(({data.matrix_onlineImp<-l_data.matrix_onlineImp[[tonl_i]];heatcol<-heatcol;}),silent=TRUE)
				if(length(data.matrix_onlineImp)!=0){
					data.matrix_onlineNorm<-normalizeBetweenArrays(data.matrix_onlineImp,method="quantile")
					tmp<-aggregate(data.matrix_onlineNorm,list(rownames(data.matrix_onlineNorm)),median)
					rownames(tmp)<-tmp[,1]
					data.matrix_onlineNorm.m<-as.matrix(tmp[,-1])
					try({
						if(length(rownames(data.matrix_onlineNorm.m))==0){
							rownames(data.matrix_onlineNorm.m)<-1:length(data.matrix_onlineNorm.m[,1])
						} else {
							rownames(data.matrix_onlineNorm.m)<-as.character(rownames(data.matrix_onlineNorm.m))
						}
					},silent=TRUE)
				}
				ta_onl_norm<-tclArray()
				for(i in 0:dim(data.matrix_onlineNorm.m)[1]){ for(j in 0:dim(data.matrix_onlineNorm.m)[2]){ 
					if(i==0){ ta_onl_norm[[i,j]]<-colnames(data.matrix_onlineNorm.m)[j] } else { 
					if(j==0){ ta_onl_norm[[i,j]]<-rownames(data.matrix_onlineNorm.m)[i] } else {
					tem<-data.matrix_onlineNorm.m[i,j]
					ta_onl_norm[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
#			data.matrix_onlineNorm.m<<-data.matrix_onlineNorm.m
				data.matrix_onlineNorm.m2[[tonl_i]]<<-data.matrix_onlineNorm.m
				
				ta_onl_norm2[[tonl_i]]<<-ta_onl_norm
#				
	
p_enter_norm<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Normalization"))
setTkProgressBar(pb_ma,0.3,title="QC...",label="")
					if(is.null(ma_img)==TRUE){
						try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
						try(tkwm.withdraw(w_legend),silent=TRUE)
						ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...)	{boxplot(data.matrix_onlineNorm.m)},hscale=1.7,vscale=1.07)
						ma_img2<<-ma_img
						tkpack(ma_img2)
					} else {
						ma_img2<<-tkrreplot(ma_img,function(...){boxplot(data.matrix_onlineNorm.m)},hscale=1.7,vscale=1.07)
					}
p_enter_qc<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...QC"))
setTkProgressBar(pb_ma,0.35,title="Filtering...",label="")
					use.data.matrix_onlineNorm.m<-data.matrix_onlineNorm.m
					try(({
						fff<-pOverA(A=1,p=0.05)
						i<-genefilter(use.data.matrix_onlineNorm.m,fff)
						dat.fo<-use.data.matrix_onlineNorm.m[i,]
						i<-genefilter(-use.data.matrix_onlineNorm.m,fff)
						dat.fu<-use.data.matrix_onlineNorm.m[i,]
						dat.f<-unique(rbind(dat.fo,dat.fu))
						fit<-lmFit(dat.f)
						fit2<-eBayes(fit)
						fit2_O[[tonl_i]]<<-fit2
						data.matrix_onlineNorm.f<-fit2
					}),silent=TRUE)
					if(length(data.matrix_onlineNorm.f)==0)
					{
						try(({
							rsd<-rowSds(use.data.matrix_onlineNorm.m)
							i<-rsd>=2
							dat.f<-use.data.matrix_onlineNorm.m[i,]
							fit<-lmFit(dat.f)
							fit2<-eBayes(fit)
							fit2_O[[tonl_i]]<<-fit2
							data.matrix_onlineNorm.f<-fit2
						}),silent=TRUE)
					}
					ps1<-as.data.frame(data.matrix_onlineNorm.f)	
					rownames(ps1)<-rownames(data.matrix_onlineNorm.f)
					data.matrix_onlineNorm.f2=NULL
					data.matrix_onlineNorm.f2<-ps1
					ta_onl_filt=NULL
					ta_onl_filt<-tclArray()
					for(i in 0:dim(data.matrix_onlineNorm.f2)[1]){ for(j in 0:dim(data.matrix_onlineNorm.f2)[2]){ 
						if(i==0){ ta_onl_filt[[i,j]]<-colnames(data.matrix_onlineNorm.f2)[j] } else { 
						if(j==0){ ta_onl_filt[[i,j]]<-rownames(data.matrix_onlineNorm.f2)[i] } else {
						tem<-data.matrix_onlineNorm.f2[i,j]
						ta_onl_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
						} }
					} }
					
					data.matrix_onlineNorm.f3[[tonl_i]]<<-data.matrix_onlineNorm.f2
					
					ta_onl_filt2[[tonl_i]]<<-ta_onl_filt
	
p_enter_filter<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Filtering"))
setTkProgressBar(pb_ma,0.55,title="Statistical_Significant...",label="")
					if(length(data.matrix_onlineNorm.f)!=0){
						err<-try({
							ttx<-topTable(data.matrix_onlineNorm.f,number=nrow(use.data.matrix_onlineNorm.m))
							rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_onlineNorm.m)==TRUE)]
							data.matrix_onlineNorm.s<-use.data.matrix_onlineNorm.m[rn,]
						},silent=TRUE)
						if(length(grep("Error",err))!=0)
						{
							ttx<-topTable(data.matrix_onlineNorm.f,number=nrow(use.data.matrix_onlineNorm.m))
							rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_onlineNorm.m)==TRUE)])
							data.matrix_onlineNorm.s<-data.matrix_onlineNorm.m[rownames(ttx)[ttx$P.Value<=0.01],]
						}
					}
					data.matrix_onlineNorm.s2=NULL
					data.matrix_onlineNorm.s2<-data.matrix_onlineNorm.s
					ta_onl_stat=NULL
					ta_onl_stat<-tclArray()
					for(i in 0:dim(data.matrix_onlineNorm.s2)[1]){ for(j in 0:dim(data.matrix_onlineNorm.s2)[2]){ 
						if(i==0){ ta_onl_stat[[i,j]]<-colnames(data.matrix_onlineNorm.s2)[j] } else { 
						if(j==0){ ta_onl_stat[[i,j]]<-rownames(data.matrix_onlineNorm.s2)[i] } else {
						tem<-data.matrix_onlineNorm.s2[i,j]
						ta_onl_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
						} }
					} }
					
					data.matrix_onlineNorm.s3[[tonl_i]]<<-data.matrix_onlineNorm.s2
					
					ta_onl_stat2[[tonl_i]]<<-ta_onl_stat
	
p_enter_stat_sign<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Statistical_Significant"))
setTkProgressBar(pb_ma,0.75,title="DGE...",label="")
					err<-try(DE_O<-topTable(data.matrix_onlineNorm.f),silent=TRUE)	
					err<-try(DE_OAll[[tonl_i]]<<-topTable(data.matrix_onlineNorm.f,number=nrow(data.matrix_onlineNorm.f)),silent=TRUE)
					ta_onl_dge=NULL
					ta_onl_dge<-tclArray()
					for(i in 0:dim(DE_O)[1]){ for(j in 0:dim(DE_O)[2]){ 
						if(i==0){ ta_onl_dge[[i,j]]<-colnames(DE_O)[j] } else { 
						if(j==0){ ta_onl_dge[[i,j]]<-rownames(DE_O)[i] } else {
						tem<-DE_O[i,j]
						ta_onl_dge[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
						} }
					} }
					
					DE_O_2[[tonl_i]]<<-DE_O
					
					ta_onl_dge2[[tonl_i]]<<-ta_onl_dge
	
p_enter_dge<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...DGE"))
setTkProgressBar(pb_ma,0.85,title="PCA...",label="")
					pca_O[[tonl_i]]<<-prcomp(t(data.matrix_onlineNorm.m))
					if(is.null(ma_img)==TRUE){
						try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
						try(tkwm.withdraw(w_legend),silent=TRUE)
						ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(pca_O[[tonl_i]])},hscale=1.7,vscale=1.07)
						ma_img2<<-ma_img
						tkpack(ma_img2)			
					} else {
						ma_img2<<-tkrreplot(ma_img,function(...){plot(pca_O[[tonl_i]])},hscale=1.7,vscale=1.07)
					}
	
p_enter_pca<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...PCA"))
setTkProgressBar(pb_ma,0.9,title="Clustering...",label="")
					sample.dist_c1<-dist(t(data.matrix_onlineNorm.m)) 
					sample.dist_O<-as.dist(1-cor(data.matrix_onlineNorm.m,method="pearson"))
					sample.clust_O[[tonl_i]]<<-hclust(sample.dist_O,method="complete")
					if(is.null(ma_img)==TRUE){
						try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
						try(tkwm.withdraw(w_legend),silent=TRUE)
						ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(sample.clust_O[[tonl_i]])},hscale=1.7,vscale=1.07)
						ma_img2<<-ma_img
						tkpack(ma_img2)			
					}else{
						ma_img2<<-tkrreplot(ma_img,function(...){plot(sample.clust_O[[tonl_i]])},hscale=1.7,vscale=1.07)
					}
p_enter_clust<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Clustering"))
setTkProgressBar(pb_ma,0.95,title="Classification...",label="")
					er_x<-try(use_DE_O<-as.matrix(DE_O),silent=TRUE)
					if(length(grep("Error",er_x))!=0)
					{
						rownames(DE_O)<-as.character(DE_O)
						use_DE_O<-as.matrix(DE_O)
					}
					rnames<-rownames(use_DE_O)
					clas_O[[tonl_i]]<<-as.matrix(data.matrix_onlineNorm.m[rnames,])
					if(is.null(ma_img)==TRUE){
						try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
						try(tkwm.withdraw(w_legend),silent=TRUE)
						ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){
							heatmap(clas_O[[tonl_i]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
						},hscale=1.7,vscale=1.07)
						ma_img2<<-ma_img
						tkpack(ma_img2)			
					}else{
						ma_img2<<-tkrreplot(ma_img,function(...){
							heatmap(clas_O[[tonl_i]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
						},hscale=1.7,vscale=1.07)
					}
p_enter_class<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Classification"))
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
				}
			}
		}
		
	})
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.1,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
if(!requireNamespace("BiocManager",quietly=TRUE)){install.packages("BiocManager");library(BiocManager)} else {library(BiocManager)}
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
if(!requireNamespace("genefilter",quietly=TRUE)){BiocManager::install("genefilter",ask=FALSE,update=FALSE);library(genefilter)} else {library(genefilter)}
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
if(!requireNamespace("limma",quietly=TRUE)){BiocManager::install("limma",ask=FALSE,update=FALSE);library(limma)} else {library(limma)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("GEOquery",quietly=TRUE)){BiocManager::install("GEOquery",ask=FALSE,update=FALSE);library(GEOquery)} else {library(GEOquery)}
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
if(!requireNamespace("impute",quietly=TRUE)){BiocManager::install("impute",ask=FALSE,update=FALSE);library(impute)} else {library(impute)}
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
if(!requireNamespace("stats",quietly=TRUE)){install.packages("stats",ask=FALSE,update=FALSE);library(stats)} else {library(stats)}
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
if(!requireNamespace("tcltk",quietly=TRUE)){install.packages("tcltk",ask=FALSE,update=FALSE);library(tcltk)} else {library(tcltk)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
dmo()

display_mod<-function(h,...){
	treeview<-treeview
	tree_w<<-NULL
	tree_mod_n<<-1
	tree_mods<<-rbind(c(tree_mod_n,"",""))
	tkbind(treeview,"<Button-3>",function(W,x,y){
		try(tkdestroy(tree_w),silent=TRUE)
		mapapa<-tcl(treeview,"parent",tkselect(treeview))
		mapapa_name<-as.character(tcl(treeview,"item",mapapa,"-values"))
		betabeti_name<-as.character(tcl(treeview,"item",tkselect(treeview),"-values"))
		tree_detdel<-function(h,...){
			tree_w<<-tktoplevel()
			tree_frame<-ttkframe(tree_w)
			tkpack(tree_frame,expand=TRUE,fill="both")
			detdelbut_frame<-ttkframe(tree_frame)
			tkpack(detdelbut_frame,anchor="ne",fill="both")
			detbut<-ttkbutton(detdelbut_frame,text="Remove")
				tkpack(detbut,side="top")
			tkconfigure(detbut,command=function(){
				d_p_affy<-tcl(treeview,"detach",tkselect(treeview))
				tree_mod_n<<-tree_mod_n+1
				tree_mods<<-rbind(tree_mods,c(tree_mod_n,mapapa_name,betabeti_name))
				tkdestroy(tree_w)
			})
			delbut<-ttkbutton(detdelbut_frame,text="Delete")
			tkpack(delbut,side="bottom")
			tkconfigure(delbut,command=function(){
				d_p_affy<-tcl(treeview,"delete",tkselect(treeview))
				tree_slc<-strsplit(mapapa_name[1],"_")
				ts_val<-as.numeric(tree_slc[[1]][2])
				if(!is.na(ts_val) && mapapa_name==paste("Affymetrix",ts_val,sep="_"))
				{
					if(betabeti_name=="...Normalization"){ ta_affy_norm2[[ts_val]]=NA; dat2Affy.m2[[ts_val]]=NA } else 
					if(betabeti_name=="...QC"){ } else 
					if(betabeti_name=="...Filtering"){ ta_affy_filt2[[ts_val]]=NA; dat2Affy.f3[[ts_val]]=NA } else 
					if(betabeti_name=="...Statistical_Significant"){ ta_affy_stat2[[ts_val]]=NA; dat2Affy.s3[[ts_val]]=NA } else 
					if(betabeti_name=="...DGE"){ ta_affy_dge2[[ts_val]]=NA; DE_Affy_2[[ts_val]]=NA } else 
					if(betabeti_name=="...PCA"){ pca_Affy[[ts_val]]=NA } else 
					if(betabeti_name=="...Clustering"){ sample.clust_Affy[[ts_val]]=NA } else 
					if(betabeti_name=="...Classification"){ clas_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP"){ ta_affy_gsea_gobp[[ts_val]]=NA;GOresultBP_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF"){ ta_affy_gsea_gomf[[ts_val]]=NA;GOresultMF_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC"){ ta_affy_gsea_gocc[[ts_val]]=NA;GOresultCC_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG"){ ta_affy_gsea_kegg[[ts_val]]=NA;KEGGresult_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP"){ ta_affy_gsta_gobp[[ts_val]]=NA;GOtable.outBP_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF"){ ta_affy_gsta_gomf[[ts_val]]=NA;GOtable.outMF_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC"){ ta_affy_gsta_gocc[[ts_val]]=NA;GOtable.outCC_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG"){ ta_affy_gsta_kegg[[ts_val]]=NA;KEGGtable.out_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP_Graph"){ graph_gsea_goBP_Affy[[ts_val]]=NA;ta_affy_legend_gsea_gobp[[ts_val]]=NA;legend_gsea_goBP_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF_Graph"){ graph_gsea_goMF_Affy[[ts_val]]=NA;ta_affy_legend_gsea_gomf[[ts_val]]=NA;legend_gsea_goMF_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC_Graph"){ graph_gsea_goCC_Affy[[ts_val]]=NA;ta_affy_legend_gsea_gocc[[ts_val]]=NA;legend_gsea_goCC_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG_Graph"){ graph_gsea_KEGG_Affy[[ts_val]]=NA;ta_affy_legend_gsea_kegg[[ts_val]]=NA;legend_gsea_KEGG_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP_Graph"){ graph_gsta_goBP_Affy[[ts_val]]=NA;ta_affy_legend_gsta_gobp[[ts_val]]=NA;legend_gsta_goBP_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF_Graph"){ graph_gsta_goMF_Affy[[ts_val]]=NA;ta_affy_legend_gsta_gomf[[ts_val]]=NA;legend_gsta_goMF_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC_Graph"){ graph_gsta_goCC_Affy[[ts_val]]=NA;ta_affy_legend_gsta_gocc[[ts_val]]=NA;legend_gsta_goCC_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG_Graph"){ graph_gsta_KEGG_Affy[[ts_val]]=NA;ta_affy_legend_gsta_kegg[[ts_val]]=NA;legend_gsta_KEGG_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...Gene_Symbol"){ ta_affy_genes[[ts_val]]=NA;genes_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...Coexprs_Network"){ myGraph_Affy[[ts_val]]=NA } else
					if(betabeti_name=="...SSE"){ ssize_Affy[[ts_val]]=NA } else {}
				} else 
				if(!is.na(ts_val) && mapapa_name==paste("Agilent-OneColor",ts_val,sep="_"))
				{
					if(betabeti_name=="...Normalization"){ ta_ag1_norm2[[ts_val]]=NA;datAgOne2.m2[[ts_val]]=NA } else 
					if(betabeti_name=="...QC"){ } else 
					if(betabeti_name=="...Filtering"){ ta_ag1_filt2[[ts_val]]=NA; datAgOne2.f3[[ts_val]]=NA } else 
					if(betabeti_name=="...Statistical_Significant"){ ta_ag1_stat2[[ts_val]]=NA; datAgOne2.s3[[ts_val]]=NA } else 
					if(betabeti_name=="...DGE"){ ta_ag1_dge2[[ts_val]]=NA; DE_Ag1_2[[ts_val]]=NA } else 
					if(betabeti_name=="...PCA"){ pca_Ag1[[ts_val]]=NA } else 
					if(betabeti_name=="...Clustering"){ sample.clust_Ag1[[ts_val]]=NA } else 
					if(betabeti_name=="...Classification"){ clas_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP"){ ta_ag1_gsea_gobp[[ts_val]]=NA;GOresultBP_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF"){ ta_ag1_gsea_gomf[[ts_val]]=NA;GOresultMF_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC"){ ta_ag1_gsea_gocc[[ts_val]]=NA;GOresultCC_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG"){ ta_ag1_gsea_kegg[[ts_val]]=NA;KEGGresult_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP"){ ta_ag1_gsta_gobp[[ts_val]]=NA;GOtable.outBP_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF"){ ta_ag1_gsta_gomf[[ts_val]]=NA;GOtable.outMF_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC"){ ta_ag1_gsta_gocc[[ts_val]]=NA;GOtable.outCC_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG"){ ta_ag1_gsta_kegg[[ts_val]]=NA;KEGGtable.out_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP_Graph"){ graph_gsea_goBP_Ag1[[ts_val]]=NA;ta_ag1_legend_gsea_gobp[[ts_val]]=NA;legend_gsea_goBP_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF_Graph"){ graph_gsea_goMF_Ag1[[ts_val]]=NA;ta_ag1_legend_gsea_gomf[[ts_val]]=NA;legend_gsea_goMF_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC_Graph"){ graph_gsea_goCC_Ag1[[ts_val]]=NA;ta_ag1_legend_gsea_gocc[[ts_val]]=NA;legend_gsea_goCC_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG_Graph"){ graph_gsea_KEGG_Ag1[[ts_val]]=NA;ta_ag1_legend_gsea_kegg[[ts_val]]=NA;legend_gsea_KEGG_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP_Graph"){ graph_gsta_goBP_Ag1[[ts_val]]=NA;ta_ag1_legend_gsta_gobp[[ts_val]]=NA;legend_gsta_goBP_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF_Graph"){ graph_gsta_goMF_Ag1[[ts_val]]=NA;ta_ag1_legend_gsta_gomf[[ts_val]]=NA;legend_gsta_goMF_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC_Graph"){ graph_gsta_goCC_Ag1[[ts_val]]=NA;ta_ag1_legend_gsta_gocc[[ts_val]]=NA;legend_gsta_goCC_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG_Graph"){ graph_gsta_KEGG_Ag1[[ts_val]]=NA;ta_ag1_legend_gsta_kegg[[ts_val]]=NA;legend_gsta_KEGG_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...Gene_Symbol"){ ta_ag1_genes[[ts_val]]=NA;genes_Ag1[[ts_val]]=NA }
					if(betabeti_name=="...Coexprs_Network"){ myGraph_Ag1[[ts_val]]=NA } else
					if(betabeti_name=="...SSE"){ ssize_Ag1[[ts_val]]=NA } else {}
				} else 
				if(!is.na(ts_val) && mapapa_name==paste("Agilent-TwoColor",ts_val,sep="_"))
				{
					if(betabeti_name=="...Normalization"){ ta_ag2_norm2[[ts_val]]=NA;datAgTwo2.m2[[ts_val]]=NA } else 
					if(betabeti_name=="...QC"){ } else 
					if(betabeti_name=="...Filtering"){ ta_ag2_filt2[[ts_val]]=NA; datAgTwo2.f3[[ts_val]]=NA } else 
					if(betabeti_name=="...Statistical_Significant"){ ta_ag2_stat2[[ts_val]]=NA; datAgTwo2.s3[[ts_val]]=NA } else 
					if(betabeti_name=="...DGE"){ ta_ag2_dge2[[ts_val]]=NA; DE_Ag2_2[[ts_val]]=NA } else 
					if(betabeti_name=="...PCA"){ pca_Ag2[[ts_val]]=NA } else 
					if(betabeti_name=="...Clustering"){ sample.clust_Ag2[[ts_val]]=NA } else 
					if(betabeti_name=="...Classification"){ clas_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP"){ ta_ag2_gsea_gobp[[ts_val]]=NA;GOresultBP_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF"){ ta_ag2_gsea_gomf[[ts_val]]=NA;GOresultMF_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC"){ ta_ag2_gsea_gocc[[ts_val]]=NA;GOresultCC_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG"){ ta_ag2_gsea_kegg[[ts_val]]=NA;KEGGresult_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP"){ ta_ag2_gsta_gobp[[ts_val]]=NA;GOtable.outBP_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF"){ ta_ag2_gsta_gomf[[ts_val]]=NA;GOtable.outMF_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC"){ ta_ag2_gsta_gocc[[ts_val]]=NA;GOtable.outCC_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG"){ ta_ag2_gsta_kegg[[ts_val]]=NA;KEGGtable.out_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP_Graph"){ graph_gsea_goBP_Ag2[[ts_val]]=NA;ta_ag2_legend_gsea_gobp[[ts_val]]=NA;legend_gsea_goBP_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF_Graph"){ graph_gsea_goMF_Ag2[[ts_val]]=NA;ta_ag2_legend_gsea_gomf[[ts_val]]=NA;legend_gsea_goMF_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC_Graph"){ graph_gsea_goCC_Ag2[[ts_val]]=NA;ta_ag2_legend_gsea_gocc[[ts_val]]=NA;legend_gsea_goCC_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG_Graph"){ graph_gsea_KEGG_Ag2[[ts_val]]=NA;ta_ag2_legend_gsea_kegg[[ts_val]]=NA;legend_gsea_KEGG_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP_Graph"){ graph_gsta_goBP_Ag2[[ts_val]]=NA;ta_ag2_legend_gsta_gobp[[ts_val]]=NA;legend_gsta_goBP_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF_Graph"){ graph_gsta_goMF_Ag2[[ts_val]]=NA;ta_ag2_legend_gsta_gomf[[ts_val]]=NA;legend_gsta_goMF_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC_Graph"){ graph_gsta_goCC_Ag2[[ts_val]]=NA;ta_ag2_legend_gsta_gocc[[ts_val]]=NA;legend_gsta_goCC_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG_Graph"){ graph_gsta_KEGG_Ag2[[ts_val]]=NA;ta_ag2_legend_gsta_kegg[[ts_val]]=NA;legend_gsta_KEGG_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...Gene_Symbol"){ ta_ag2_genes[[ts_val]]=NA;genes_Ag2[[ts_val]]=NA }
					if(betabeti_name=="...Coexprs_Network"){ myGraph_Ag2[[ts_val]]=NA } else
					if(betabeti_name=="...SSE"){ ssize_Ag2[[ts_val]]=NA } else {}
				} else 
				if(!is.na(ts_val) && mapapa_name==paste("Illumina-Beadarray",ts_val,sep="_"))
				{
					if(betabeti_name=="...Normalization"){ ta_ilb_norm2[[ts_val]]=NA;datIllBA2.m2[[ts_val]]=NA } else 
					if(betabeti_name=="...QC"){ } else 
					if(betabeti_name=="...Filtering"){ ta_ilb_filt2[[ts_val]]=NA; datIllBA2.f3[[ts_val]]=NA } else 
					if(betabeti_name=="...Statistical_Significant"){ ta_ilb_stat2[[ts_val]]=NA; datIllBA2.s3[[ts_val]]=NA } else 
					if(betabeti_name=="...DGE"){ ta_ilb_dge2[[ts_val]]=NA; DE_Il_B_2[[ts_val]]=NA } else 
					if(betabeti_name=="...PCA"){ pca_Il_B[[ts_val]]=NA } else 
					if(betabeti_name=="...Clustering"){ sample.clust_Il_B[[ts_val]]=NA } else 
					if(betabeti_name=="...Classification"){ clas_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP"){ ta_ilb_gsea_gobp[[ts_val]]=NA;GOresultBP_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF"){ ta_ilb_gsea_gomf[[ts_val]]=NA;GOresultMF_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC"){ ta_ilb_gsea_gocc[[ts_val]]=NA;GOresultCC_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG"){ ta_ilb_gsea_kegg[[ts_val]]=NA;KEGGresult_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP"){ ta_ilb_gsta_gobp[[ts_val]]=NA;GOtable.outBP_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF"){ ta_ilb_gsta_gomf[[ts_val]]=NA;GOtable.outMF_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC"){ ta_ilb_gsta_gocc[[ts_val]]=NA;GOtable.outCC_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG"){ ta_ilb_gsta_kegg[[ts_val]]=NA;KEGGtable.out_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP_Graph"){ graph_gsea_goBP_Il_B[[ts_val]]=NA;ta_ilb_legend_gsea_gobp[[ts_val]]=NA;legend_gsea_goBP_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF_Graph"){ graph_gsea_goMF_Il_B[[ts_val]]=NA;ta_ilb_legend_gsea_gomf[[ts_val]]=NA;legend_gsea_goMF_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC_Graph"){ graph_gsea_goCC_Il_B[[ts_val]]=NA;ta_ilb_legend_gsea_gocc[[ts_val]]=NA;legend_gsea_goCC_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG_Graph"){ graph_gsea_KEGG_Il_B[[ts_val]]=NA;ta_ilb_legend_gsea_kegg[[ts_val]]=NA;legend_gsea_KEGG_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP_Graph"){ graph_gsta_goBP_Il_B[[ts_val]]=NA;ta_ilb_legend_gsta_gobp[[ts_val]]=NA;legend_gsta_goBP_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF_Graph"){ graph_gsta_goMF_Il_B[[ts_val]]=NA;ta_ilb_legend_gsta_gomf[[ts_val]]=NA;legend_gsta_goMF_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC_Graph"){ graph_gsta_goCC_Il_B[[ts_val]]=NA;ta_ilb_legend_gsta_gocc[[ts_val]]=NA;legend_gsta_goCC_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG_Graph"){ graph_gsta_KEGG_Il_B[[ts_val]]=NA;ta_ilb_legend_gsta_kegg[[ts_val]]=NA;legend_gsta_KEGG_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...Gene_Symbol"){ ta_ilb_genes[[ts_val]]=NA;genes_Il_B[[ts_val]]=NA }
					if(betabeti_name=="...Coexprs_Network"){ myGraph_Il_B[[ts_val]]=NA } else
					if(betabeti_name=="...SSE"){ ssize_Il_B[[ts_val]]=NA } else {}
				} else 
				if(!is.na(ts_val) && mapapa_name==paste("Illumina-Lumi",ts_val,sep="_"))
				{
					if(betabeti_name=="...Normalization"){ ta_ill_norm2[[ts_val]]=NA;lumi_NQ.m2[[ts_val]]=NA } else 
					if(betabeti_name=="...QC"){ } else 
					if(betabeti_name=="...Filtering"){ ta_ill_filt2[[ts_val]]=NA; lumi_NQ.f3[[ts_val]]=NA } else 
					if(betabeti_name=="...Statistical_Significant"){ ta_ill_stat2[[ts_val]]=NA; lumi_NQ.s3[[ts_val]]=NA } else 
					if(betabeti_name=="...DGE"){ ta_ill_dge2[[ts_val]]=NA; DE_Il_L_2[[ts_val]]=NA } else 
					if(betabeti_name=="...PCA"){ pca_Il_L[[ts_val]]=NA } else 
					if(betabeti_name=="...Clustering"){ sample.clust_Il_L[[ts_val]]=NA } else 
					if(betabeti_name=="...Classification"){ clas_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP"){ ta_ill_gsea_gobp[[ts_val]]=NA;GOresultBP_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF"){ ta_ill_gsea_gomf[[ts_val]]=NA;GOresultMF_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC"){ ta_ill_gsea_gocc[[ts_val]]=NA;GOresultCC_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG"){ ta_ill_gsea_kegg[[ts_val]]=NA;KEGGresult_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP"){ ta_ill_gsta_gobp[[ts_val]]=NA;GOtable.outBP_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF"){ ta_ill_gsta_gomf[[ts_val]]=NA;GOtable.outMF_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC"){ ta_ill_gsta_gocc[[ts_val]]=NA;GOtable.outCC_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG"){ ta_ill_gsta_kegg[[ts_val]]=NA;KEGGtable.out_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP_Graph"){ graph_gsea_goBP_Il_L[[ts_val]]=NA;ta_ill_legend_gsea_gobp[[ts_val]]=NA;legend_gsea_goBP_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF_Graph"){ graph_gsea_goMF_Il_L[[ts_val]]=NA;ta_ill_legend_gsea_gomf[[ts_val]]=NA;legend_gsea_goMF_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC_Graph"){ graph_gsea_goCC_Il_L[[ts_val]]=NA;ta_ill_legend_gsea_gocc[[ts_val]]=NA;legend_gsea_goCC_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG_Graph"){ graph_gsea_KEGG_Il_L[[ts_val]]=NA;ta_ill_legend_gsea_kegg[[ts_val]]=NA;legend_gsea_KEGG_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP_Graph"){ graph_gsta_goBP_Il_L[[ts_val]]=NA;ta_ill_legend_gsta_gobp[[ts_val]]=NA;legend_gsta_goBP_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF_Graph"){ graph_gsta_goMF_Il_L[[ts_val]]=NA;ta_ill_legend_gsta_gomf[[ts_val]]=NA;legend_gsta_goMF_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC_Graph"){ graph_gsta_goCC_Il_L[[ts_val]]=NA;ta_ill_legend_gsta_gocc[[ts_val]]=NA;legend_gsta_goCC_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG_Graph"){ graph_gsta_KEGG_Il_L[[ts_val]]=NA;ta_ill_legend_gsta_kegg[[ts_val]]=NA;legend_gsta_KEGG_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...Gene_Symbol"){ ta_ill_genes[[ts_val]]=NA;genes_Il_L[[ts_val]]=NA }
					if(betabeti_name=="...Coexprs_Network"){ myGraph_Il_L[[ts_val]]=NA } else
					if(betabeti_name=="...SSE"){ ssize_Il_L[[ts_val]]=NA } else {}
				} else 
				if(!is.na(ts_val) && mapapa_name==paste("Nimblegen",ts_val,sep="_"))
				{
					if(betabeti_name=="...Normalization"){ ta_nbl_norm2[[ts_val]]=NA;data.matrix_Nimblegen2.m2[[ts_val]]=NA } else 
					if(betabeti_name=="...QC"){ } else 
					if(betabeti_name=="...Filtering"){ ta_nbl_filt2[[ts_val]]=NA; data.matrix_Nimblegen2.f3[[ts_val]]=NA } else 
					if(betabeti_name=="...Statistical_Significant"){ ta_nbl_stat2[[ts_val]]=NA; data.matrix_Nimblegen2.s3[[ts_val]]=NA } else 
					if(betabeti_name=="...DGE"){ ta_nbl_dge2[[ts_val]]=NA; DE_N_2[[ts_val]]=NA } else 
					if(betabeti_name=="...PCA"){ pca_N[[ts_val]]=NA } else 
					if(betabeti_name=="...Clustering"){ sample.clust_N[[ts_val]]=NA } else 
					if(betabeti_name=="...Classification"){ clas_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP"){ ta_nbl_gsea_gobp[[ts_val]]=NA;GOresultBP_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF"){ ta_nbl_gsea_gomf[[ts_val]]=NA;GOresultMF_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC"){ ta_nbl_gsea_gocc[[ts_val]]=NA;GOresultCC_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG"){ ta_nbl_gsea_kegg[[ts_val]]=NA;KEGGresult_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP"){ ta_nbl_gsta_gobp[[ts_val]]=NA;GOtable.outBP_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF"){ ta_nbl_gsta_gomf[[ts_val]]=NA;GOtable.outMF_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC"){ ta_nbl_gsta_gocc[[ts_val]]=NA;GOtable.outCC_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG"){ ta_nbl_gsta_kegg[[ts_val]]=NA;KEGGtable.out_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP_Graph"){ graph_gsea_goBP_N[[ts_val]]=NA;ta_nbl_legend_gsea_gobp[[ts_val]]=NA;legend_gsea_goBP_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF_Graph"){ graph_gsea_goMF_N[[ts_val]]=NA;ta_nbl_legend_gsea_gomf[[ts_val]]=NA;legend_gsea_goMF_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC_Graph"){ graph_gsea_goCC_N[[ts_val]]=NA;ta_nbl_legend_gsea_gocc[[ts_val]]=NA;legend_gsea_goCC_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG_Graph"){ graph_gsea_KEGG_N[[ts_val]]=NA;ta_nbl_legend_gsea_kegg[[ts_val]]=NA;legend_gsea_KEGG_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP_Graph"){ graph_gsta_goBP_N[[ts_val]]=NA;ta_nbl_legend_gsta_gobp[[ts_val]]=NA;legend_gsta_goBP_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF_Graph"){ graph_gsta_goMF_N[[ts_val]]=NA;ta_nbl_legend_gsta_gomf[[ts_val]]=NA;legend_gsta_goMF_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC_Graph"){ graph_gsta_goCC_N[[ts_val]]=NA;ta_nbl_legend_gsta_gocc[[ts_val]]=NA;legend_gsta_goCC_N[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG_Graph"){ graph_gsta_KEGG_N[[ts_val]]=NA;ta_nbl_legend_gsta_kegg[[ts_val]]=NA;legend_gsta_KEGG_N[[ts_val]]=NA } else
					if(betabeti_name=="...Gene_Symbol"){ ta_nbl_genes[[ts_val]]=NA;genes_N[[ts_val]]=NA }
					if(betabeti_name=="...Coexprs_Network"){ myGraph_N[[ts_val]]=NA } else
					if(betabeti_name=="...SSE"){ ssize_N[[ts_val]]=NA } else {}
				} else 
				if(!is.na(ts_val) && mapapa_name==paste("Series-Matrix",ts_val,sep="_"))
				{
					if(betabeti_name=="...Normalization"){ ta_smt_norm2[[ts_val]]=NA;data.matrixNorm.m2[[ts_val]]=NA } else 
					if(betabeti_name=="...QC"){ } else 
					if(betabeti_name=="...Filtering"){ ta_smt_filt2[[ts_val]]=NA; data.matrixNorm.f3[[ts_val]]=NA } else 
					if(betabeti_name=="...Statistical_Significant"){ ta_smt_stat2[[ts_val]]=NA; data.matrixNorm.s3[[ts_val]]=NA } else 
					if(betabeti_name=="...DGE"){ ta_smt_dge2[[ts_val]]=NA; DE_S_2[[ts_val]]=NA } else 
					if(betabeti_name=="...PCA"){ pca_S[[ts_val]]=NA } else 
					if(betabeti_name=="...Clustering"){ sample.clust_S[[ts_val]]=NA } else 
					if(betabeti_name=="...Classification"){ clas_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP"){ ta_smt_gsea_gobp[[ts_val]]=NA;GOresultBP_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF"){ ta_smt_gsea_gomf[[ts_val]]=NA;GOresultMF_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC"){ ta_smt_gsea_gocc[[ts_val]]=NA;GOresultCC_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG"){ ta_smt_gsea_kegg[[ts_val]]=NA;KEGGresult_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP"){ ta_smt_gsta_gobp[[ts_val]]=NA;GOtable.outBP_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF"){ ta_smt_gsta_gomf[[ts_val]]=NA;GOtable.outMF_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC"){ ta_smt_gsta_gocc[[ts_val]]=NA;GOtable.outCC_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG"){ ta_smt_gsta_kegg[[ts_val]]=NA;KEGGtable.out_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP_Graph"){ graph_gsea_goBP_S[[ts_val]]=NA;ta_smt_legend_gsea_gobp[[ts_val]]=NA;legend_gsea_goBP_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF_Graph"){ graph_gsea_goMF_S[[ts_val]]=NA;ta_smt_legend_gsea_gomf[[ts_val]]=NA;legend_gsea_goMF_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC_Graph"){ graph_gsea_goCC_S[[ts_val]]=NA;ta_smt_legend_gsea_gocc[[ts_val]]=NA;legend_gsea_goCC_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG_Graph"){ graph_gsea_KEGG_S[[ts_val]]=NA;ta_smt_legend_gsea_kegg[[ts_val]]=NA;legend_gsea_KEGG_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP_Graph"){ graph_gsta_goBP_S[[ts_val]]=NA;ta_smt_legend_gsta_gobp[[ts_val]]=NA;legend_gsta_goBP_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF_Graph"){ graph_gsta_goMF_S[[ts_val]]=NA;ta_smt_legend_gsta_gomf[[ts_val]]=NA;legend_gsta_goMF_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC_Graph"){ graph_gsta_goCC_S[[ts_val]]=NA;ta_smt_legend_gsta_gocc[[ts_val]]=NA;legend_gsta_goCC_S[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG_Graph"){ graph_gsta_KEGG_S[[ts_val]]=NA;ta_smt_legend_gsta_kegg[[ts_val]]=NA;legend_gsta_KEGG_S[[ts_val]]=NA } else
					if(betabeti_name=="...Gene_Symbol"){ ta_smt_genes[[ts_val]]=NA;genes_S[[ts_val]]=NA }
					if(betabeti_name=="...Coexprs_Network"){ myGraph_S[[ts_val]]=NA } else
					if(betabeti_name=="...SSE"){ ssize_S[[ts_val]]=NA } else {}
				} else 
				if(!is.na(ts_val) && mapapa_name==paste("Agilent-TwoColor",ts_val,sep="_"))
				{
					if(betabeti_name=="...Normalization"){ ta_onl_norm2[[ts_val]]=NA;data.matrix_onlineNorm.m2[[ts_val]]=NA } else 
					if(betabeti_name=="...QC"){ } else 
					if(betabeti_name=="...Filtering"){ ta_onl_filt2[[ts_val]]=NA; data.matrix_onlineNorm.f3[[ts_val]]=NA } else 
					if(betabeti_name=="...Statistical_Significant"){ ta_onl_stat2[[ts_val]]=NA; data.matrix_onlineNorm.s3[[ts_val]]=NA } else 
					if(betabeti_name=="...DGE"){ ta_onl_dge2[[ts_val]]=NA; DE_O_2[[ts_val]]=NA } else 
					if(betabeti_name=="...PCA"){ pca_O[[ts_val]]=NA } else 
					if(betabeti_name=="...Clustering"){ sample.clust_O[[ts_val]]=NA } else 
					if(betabeti_name=="...Classification"){ clas_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP"){ ta_onl_gsea_gobp[[ts_val]]=NA;GOresultBP_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF"){ ta_onl_gsea_gomf[[ts_val]]=NA;GOresultMF_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC"){ ta_onl_gsea_gocc[[ts_val]]=NA;GOresultCC_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG"){ ta_onl_gsea_kegg[[ts_val]]=NA;KEGGresult_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP"){ ta_onl_gsta_gobp[[ts_val]]=NA;GOtable.outBP_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF"){ ta_onl_gsta_gomf[[ts_val]]=NA;GOtable.outMF_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC"){ ta_onl_gsta_gocc[[ts_val]]=NA;GOtable.outCC_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG"){ ta_onl_gsta_kegg[[ts_val]]=NA;KEGGtable.out_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOBP_Graph"){ graph_gsea_goBP_O[[ts_val]]=NA;ta_onl_legend_gsea_gobp[[ts_val]]=NA;legend_gsea_goBP_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOMF_Graph"){ graph_gsea_goMF_O[[ts_val]]=NA;ta_onl_legend_gsea_gomf[[ts_val]]=NA;legend_gsea_goMF_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_GOCC_Graph"){ graph_gsea_goCC_O[[ts_val]]=NA;ta_onl_legend_gsea_gocc[[ts_val]]=NA;legend_gsea_goCC_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSEA_KEGG_Graph"){ graph_gsea_KEGG_O[[ts_val]]=NA;ta_onl_legend_gsea_kegg[[ts_val]]=NA;legend_gsea_KEGG_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOBP_Graph"){ graph_gsta_goBP_O[[ts_val]]=NA;ta_onl_legend_gsta_gobp[[ts_val]]=NA;legend_gsta_goBP_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOMF_Graph"){ graph_gsta_goMF_O[[ts_val]]=NA;ta_onl_legend_gsta_gomf[[ts_val]]=NA;legend_gsta_goMF_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_GOCC_Graph"){ graph_gsta_goCC_O[[ts_val]]=NA;ta_onl_legend_gsta_gocc[[ts_val]]=NA;legend_gsta_goCC_O[[ts_val]]=NA } else
					if(betabeti_name=="...GSTA_KEGG_Graph"){ graph_gsta_KEGG_O[[ts_val]]=NA;ta_onl_legend_gsta_kegg[[ts_val]]=NA;legend_gsta_KEGG_O[[ts_val]]=NA } else
					if(betabeti_name=="...Gene_Symbol"){ ta_onl_genes[[ts_val]]=NA;genes_O[[ts_val]]=NA }
					if(betabeti_name=="...Coexprs_Network"){ myGraph_O[[ts_val]]=NA } else
					if(betabeti_name=="...SSE"){ ssize_O[[ts_val]]=NA } else {}
				}
				tkdestroy(tree_w)
			})
		}

		tree_add<-function(h,...){
			if(dim(tree_mods)[1]>1){
				add_chksb=NULL
				chksb=NULL
				tree_mods2<<-NULL
				chksb_val=NULL
				tree_w<<-tktoplevel()
				tree_frame<-ttkframe(tree_w)
				tkpack(tree_frame,expand=TRUE,fill="both")
				chksbut<-ttkbutton(tree_frame,text="Add")
				tkpack(chksbut)
				tkconfigure(chksbut,command=function(){
					for(i in 1:length(chksb)){
						tree_rein<-tcl(treeview,"insert",tkselect(treeview),"end",values=chksb[i])
						tree_rein_n<-tree_mods2[(which(tree_mods2[,3]==chksb[i])),1]
						tree_mods<<-tree_mods[-(which(tree_mods[,1]==tree_rein_n)),]					
						tree_mods2<<-tree_mods2[-(which(tree_mods2[,3]==chksb[i])),]
					}
					tkdestroy(tree_w)
				})
				chksb_fun<-function(h,...){
					tkconfigure(h,command=function(){
						chksb_name<-tclvalue(tkcget(h,"-text"))
						chksb_status<-tclvalue(tkcget(h,"-variable"))
						if(tclvalue(chksb_status)==1)chksb<<-c(chksb,chksb_name)
					})
				}
				tree_part_name<-as.character(tcl(treeview,"item",tkselect(treeview),"-values"))
				tree_mods2<<-tree_mods[which(tree_mods[,2]==tree_part_name),]
				tree_mods2<<-rbind(c(1,"",""),tree_mods2)
				
				for(i in 2:dim(tree_mods2)[1]){
					chks_txt<-tclVar(tree_mods2[i,3])
					chksb_val[[i]]<-tclVar(FALSE)
					add_chksb[[i]]<-ttkcheckbutton(tree_frame,variable=chksb_val[[i]],textvariable=chks_txt)
					tkpack(add_chksb[[i]],anchor="sw")
				}
				for(i in 2:dim(tree_mods2)[1]){
					chksb_fun(add_chksb[[i]])
				}
			}
		}
		if(length(mapapa_name)!=0){try(tree_detdel(),silent=TRUE)}
		if(length(mapapa_name)==0){try(tree_add(),silent=TRUE)}
	})
}
if(!requireNamespace("tcltk",quietly=TRUE)){install.packages("tcltk");library(tcltk)} else {library(tcltk)}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
display_mod()

dge<-function(h,...){
	dge_params<-function(h,h2,h3,h4,...){
		ts_name<-h;ts_val<-h2;children<-h3;r_choice=h4;
		w_imp<-tktoplevel()
		tkwm.title(w_imp,"Select your data")
		tkwm.resizable(w_imp,0,0)
		frame1_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		tkpack(frame1_imp,expand=TRUE,fill="both",side="top")
		r1_imp<-c("Top genes","Gene lists")
		var1<-tclVar(r1_imp[1])
		sapply(r1_imp,function(i){
			r1_imp_vals<-ttkradiobutton(frame1_imp,variable=var1,text=i,value=i)
			tkpack(r1_imp_vals,side="left",anchor="w",padx=25)
		})
		tkpack(ttklabel(frame1_imp,text=''),side="bottom",pady=5)
		frame2_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		tkpack(ttklabel(frame2_imp,text='Gene names'),side="left",padx=12)
		gn_list<-tclVar("")
		tkpack(ttkentry(frame2_imp,textvariable=gn_list,width=30),side="left",anchor="e")
		tkpack(frame2_imp,expand=TRUE,fill="both",side="top")
		frame3_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		tkpack(ttklabel(frame3_imp,text='Number'),side="left",padx=12)
		numb_dge<-tclVar("all")
		tkpack(ttkentry(frame3_imp,textvariable=numb_dge,width=10),side="left",anchor="e",padx=30)
		tkpack(frame3_imp,expand=TRUE,fill="both",side="top")
		frame4_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		tkpack(ttklabel(frame4_imp,text='logFC'),side="left",padx=12)
		logFC_dge<-tclVar("2")
		tkpack(ttkentry(frame4_imp,textvariable=logFC_dge,width=10),side="left",anchor="e",padx=45)
		tkpack(frame4_imp,expand=TRUE,fill="both",side="top")
		frame5_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		tkpack(ttklabel(frame5_imp,text='P-value'),side="left",padx=12)
		p_list<-c(10,1,0.5,0.1,0.05,0.01,0.001,0.0001)
		p_value<-tclVar(p_list[2])
		p_comb<-ttkcombobox(frame5_imp,values=p_list,textvariable=p_value,state="normal",justify="left",width=7)
		tkpack(p_comb,side="left",padx=33)
		tkpack(frame5_imp,expand=TRUE,fill="both",side="top")
		frame6_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		tkpack(ttklabel(frame6_imp,text='Adjustment'),side="left",padx=12)
		adjust_list<-c("BH","BY","holm","hochberg","hommel","bonferroni","fdr","none")
		adjust_value<-tclVar(adjust_list[1])
		adjust_comb<-ttkcombobox(frame6_imp,values=adjust_list,textvariable=adjust_value,state="normal",justify="left",width=12)
		tkpack(adjust_comb,side="left",padx=6)
		tkpack(frame6_imp,expand=TRUE,fill="both",side="top")
		frame7_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		tkpack(ttklabel(frame7_imp,text='Sort by'),side="left",padx=12)
		sort_list<-c("B","F","P","p","t","logFC","AveExpr","none")
		sort_value<-tclVar(sort_list[4])
		sort_comb<-ttkcombobox(frame7_imp,values=sort_list,textvariable=sort_value,state="normal",justify="left",width=12)
		tkpack(sort_comb,side="left",padx=35)
		tkpack(frame7_imp,expand=TRUE,fill="both",side="top")
		frame6_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		r_but<-ttkbutton(frame6_imp,text="Ok")
		tkpack(r_but,side="right",padx=12)
		tkpack(frame6_imp,expand=TRUE,fill="both",side="top")
		tkconfigure(r_but,command=function(){
			tkwm.withdraw(w_imp)
			if(ts_name=="Affymetrix"){
				dat2Affy.f<-fit2_Affy[[ts_val]]
				DE_AffyAll[[ts_val]]<<-topTable(dat2Affy.f,
				number=nrow(dat2Affy.f),
				lfc=as.numeric(tclvalue(logFC_dge)),
				p.value=as.numeric(tclvalue(p_value)),
				adjust.method=tclvalue(adjust_value),
				sort.by=tclvalue(sort_value))
				if(tclvalue(var1)=="Top genes"){
					if(tclvalue(numb_dge)=="all"){
						DE_Affy<-DE_AffyAll[[ts_val]]
					} else {
						DE_Affy<-topTable(dat2Affy.f,
						number=as.numeric(tclvalue(numb_dge)),
						lfc=as.numeric(tclvalue(logFC_dge)),
						p.value=as.numeric(tclvalue(p_value)),
						adjust.method=tclvalue(adjust_value),
						sort.by=tclvalue(sort_value))
					}
				}
				if(tclvalue(var1)=="Gene lists"){
					xf<-strsplit(tclvalue(gn_list),",")
					new_dge<-matrix(,ncol=ncol(DE_AffyAll[[ts_val]]))
					colnames(new_dge)<-names(DE_AffyAll[[ts_val]])
					for(i in 1:length(unlist(xf))){
						new_dge<-rbind(new_dge,DE_AffyAll[[ts_val]][as.character(xf[[1]][i]),])
					}
					new_dge<-new_dge[-1,]
					DE_Affy<-new_dge
				}
				ta_affy_dge<-tclArray()
				for(i in 0:dim(DE_Affy)[1]){ for(j in 0:dim(DE_Affy)[2]){ 
					if(i==0){ ta_affy_dge[[i,j]]<-colnames(DE_Affy)[j] } else { 
					if(j==0){ ta_affy_dge[[i,j]]<-rownames(DE_Affy)[i] } else {
					tem<-DE_Affy[i,j]
					ta_affy_dge[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				DE_Affy_2[[ts_val]]<<-DE_Affy
				ta_affy_dge2[[ts_val]]<<-ta_affy_dge
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...DGE"))}
				}
			}
			if(ts_name=="Agilent-OneColor"){
				datAgOne2.f<-fit2_Ag1[[ts_val]]
				DE_Ag1All[[ts_val]]<<-topTable(datAgOne2.f,
				number=nrow(datAgOne2.f),
				lfc=as.numeric(tclvalue(logFC_dge)),
				p.value=as.numeric(tclvalue(p_value)),
				adjust.method=tclvalue(adjust_value),
				sort.by=tclvalue(sort_value))
				if(tclvalue(var1)=="Top genes"){
					if(tclvalue(numb_dge)=="all"){
						DE_Ag1<-DE_Ag1All[[ts_val]]
					} else {
						DE_Ag1<-topTable(datAgOne2.f,
						number=as.numeric(tclvalue(numb_dge)),
						lfc=as.numeric(tclvalue(logFC_dge)),
						p.value=as.numeric(tclvalue(p_value)),
						adjust.method=tclvalue(adjust_value),
						sort.by=tclvalue(sort_value))
					}
				}
				if(tclvalue(var1)=="Gene lists"){
					xf<-strsplit(tclvalue(gn_list),",")
					new_dge<-matrix(,ncol=ncol(DE_Ag1All[[ts_val]]))
					colnames(new_dge)<-names(DE_Ag1All[[ts_val]])
					for(i in 1:length(unlist(xf))){
						new_dge<-rbind(new_dge,DE_Ag1All[[ts_val]][as.character(xf[[1]][i]),])
					}
					new_dge<-new_dge[-1,]
					DE_Ag1<-new_dge
				}
				ta_ag1_dge<-tclArray()
				for(i in 0:dim(DE_Ag1)[1]){ for(j in 0:dim(DE_Ag1)[2]){ 
					if(i==0){ ta_ag1_dge[[i,j]]<-colnames(DE_Ag1)[j] } else { 
					if(j==0){ ta_ag1_dge[[i,j]]<-rownames(DE_Ag1)[i] } else {
					tem<-DE_Ag1[i,j]
					ta_ag1_dge[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				DE_Ag1_2[[ts_val]]<<-DE_Ag1
				ta_ag1_dge2[[ts_val]]<<-ta_ag1_dge
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...DGE"))
				}
			}
			if(ts_name=="Agilent-TwoColor"){
				datAgTwo2.f<-fit2_Ag2[[ts_val]]
				DE_Ag2All[[ts_val]]<<-topTable(datAgTwo2.f,
				number=nrow(datAgTwo2.f),
				lfc=as.numeric(tclvalue(logFC_dge)),
				p.value=as.numeric(tclvalue(p_value)),
				adjust.method=tclvalue(adjust_value),
				sort.by=tclvalue(sort_value))
				if(tclvalue(var1)=="Top genes"){
					if(tclvalue(numb_dge)=="all"){
						DE_Ag2<-DE_Ag2All[[ts_val]]
					} else {
						DE_Ag2<-topTable(datAgTwo2.f,
						number=as.numeric(tclvalue(numb_dge)),
						lfc=as.numeric(tclvalue(logFC_dge)),
						p.value=as.numeric(tclvalue(p_value)),
						adjust.method=tclvalue(adjust_value),
						sort.by=tclvalue(sort_value))
					}
				}
				if(tclvalue(var1)=="Gene lists"){
					xf<-strsplit(tclvalue(gn_list),",")
					new_dge<-matrix(,ncol=ncol(DE_Ag2All[[ts_val]]))
					colnames(new_dge)<-names(DE_Ag2All[[ts_val]])
					for(i in 1:length(unlist(xf))){
						new_dge<-rbind(new_dge,DE_Ag2All[[ts_val]][as.character(xf[[1]][i]),])
					}
					new_dge<-new_dge[-1,]
					DE_Ag2<-new_dge
				}
				ta_ag2_dge<-tclArray()
				for(i in 0:dim(DE_Ag2)[1]){ for(j in 0:dim(DE_Ag2)[2]){ 
					if(i==0){ ta_ag2_dge[[i,j]]<-colnames(DE_Ag2)[j] } else { 
					if(j==0){ ta_ag2_dge[[i,j]]<-rownames(DE_Ag2)[i] } else {
					tem<-DE_Ag2[i,j]
					ta_ag2_dge[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				DE_Ag2_2[[ts_val]]<<-DE_Ag2
				ta_ag2_dge2[[ts_val]]<<-ta_ag2_dge
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...DGE"))
				}
			}
			if(ts_name=="Illumina-Beadarray"){
				datIllBA2.f<-fit2_Il_B[[ts_val]]
				DE_Il_BAll[[ts_val]]<<-topTable(datIllBA2.f,
				number=nrow(datIllBA2.f),
				lfc=as.numeric(tclvalue(logFC_dge)),
				p.value=as.numeric(tclvalue(p_value)),
				adjust.method=tclvalue(adjust_value),
				sort.by=tclvalue(sort_value))
				if(tclvalue(var1)=="Top genes"){
					if(tclvalue(numb_dge)=="all"){
						DE_Il_B<-DE_Il_BAll[[ts_val]]
					} else {
						DE_Il_B<-topTable(datIllBA2.f,
						number=as.numeric(tclvalue(numb_dge)),
						lfc=as.numeric(tclvalue(logFC_dge)),
						p.value=as.numeric(tclvalue(p_value)),
						adjust.method=tclvalue(adjust_value),
						sort.by=tclvalue(sort_value))
					}
				}
				if(tclvalue(var1)=="Gene lists"){
					xf<-strsplit(tclvalue(gn_list),",")
					new_dge<-matrix(,ncol=ncol(DE_Il_BAll[[ts_val]]))
					colnames(new_dge)<-names(DE_Il_BAll[[ts_val]])
					for(i in 1:length(unlist(xf))){
						new_dge<-rbind(new_dge,DE_Il_BAll[[ts_val]][as.character(xf[[1]][i]),])
					}
					new_dge<-new_dge[-1,]
					DE_Il_B<-new_dge
				}
				ta_ilb_dge<-tclArray()
				for(i in 0:dim(DE_Il_B)[1]){ for(j in 0:dim(DE_Il_B)[2]){ 
					if(i==0){ ta_ilb_dge[[i,j]]<-colnames(DE_Il_B)[j] } else { 
					if(j==0){ ta_ilb_dge[[i,j]]<-rownames(DE_Il_B)[i] } else {
					tem<-DE_Il_B[i,j]
					ta_ilb_dge[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				DE_Il_B_2[[ts_val]]<<-DE_Il_B
				ta_ilb_dge2[[ts_val]]<<-ta_ilb_dge
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...DGE"))
				}
			}
			if(ts_name=="Illumina-Lumi"){
				lumi_NQ.f<-fit2_Il_L[[ts_val]]
				DE_Il_LAll[[ts_val]]<<-topTable(lumi_NQ.f,
				number=nrow(lumi_NQ.f),
				lfc=as.numeric(tclvalue(logFC_dge)),
				p.value=as.numeric(tclvalue(p_value)),
				adjust.method=tclvalue(adjust_value),
				sort.by=tclvalue(sort_value))
				if(tclvalue(var1)=="Top genes"){
					if(tclvalue(numb_dge)=="all"){
						DE_Il_L<-DE_Il_LAll[[ts_val]]
					} else {
						DE_Il_L<-topTable(lumi_NQ.f,
						number=as.numeric(tclvalue(numb_dge)),
						lfc=as.numeric(tclvalue(logFC_dge)),
						p.value=as.numeric(tclvalue(p_value)),
						adjust.method=tclvalue(adjust_value),
						sort.by=tclvalue(sort_value))
					}
				}
				if(tclvalue(var1)=="Gene lists"){
					xf<-strsplit(tclvalue(gn_list),",")
					new_dge<-matrix(,ncol=ncol(DE_Il_LAll[[ts_val]]))
					colnames(new_dge)<-names(DE_Il_LAll[[ts_val]])
					for(i in 1:length(unlist(xf))){
						new_dge<-rbind(new_dge,DE_Il_LAll[[ts_val]][as.character(xf[[1]][i]),])
					}
					new_dge<-new_dge[-1,]
					DE_Il_L<-new_dge
				}
				ta_ill_dge<-tclArray()
				for(i in 0:dim(DE_Il_L)[1]){ for(j in 0:dim(DE_Il_L)[2]){ 
					if(i==0){ ta_ill_dge[[i,j]]<-colnames(DE_Il_L)[j] } else { 
					if(j==0){ ta_ill_dge[[i,j]]<-rownames(DE_Il_L)[i] } else {
					tem<-DE_Il_L[i,j]
					ta_ill_dge[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				DE_Il_L_2[[ts_val]]<<-DE_Il_L
				ta_ill_dge2[[ts_val]]<<-ta_ill_dge
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...DGE"))
				}
			}
			if(ts_name=="Nimblegen"){
				data.matrix_Nimblegen2.f<-fit2_N[[ts_val]]
				DE_NAll[[ts_val]]<<-topTable(data.matrix_Nimblegen2.f,
				number=nrow(data.matrix_Nimblegen2.f),
				lfc=as.numeric(tclvalue(logFC_dge)),
				p.value=as.numeric(tclvalue(p_value)),
				adjust.method=tclvalue(adjust_value),
				sort.by=tclvalue(sort_value))
				if(tclvalue(var1)=="Top genes"){
					if(tclvalue(numb_dge)=="all"){
						DE_N<-DE_NAll[[ts_val]]
					} else {
						DE_N<-topTable(data.matrix_Nimblegen2.f,
						number=as.numeric(tclvalue(numb_dge)),
						lfc=as.numeric(tclvalue(logFC_dge)),
						p.value=as.numeric(tclvalue(p_value)),
						adjust.method=tclvalue(adjust_value),
						sort.by=tclvalue(sort_value))
					}
				}
				if(tclvalue(var1)=="Gene lists"){
					xf<-strsplit(tclvalue(gn_list),",")
					new_dge<-matrix(,ncol=ncol(DE_NAll[[ts_val]]))
					colnames(new_dge)<-names(DE_NAll[[ts_val]])
					for(i in 1:length(unlist(xf))){
						new_dge<-rbind(new_dge,DE_NAll[[ts_val]][as.character(xf[[1]][i]),])
					}
					new_dge<-new_dge[-1,]
					DE_N<-new_dge
				}
				ta_nbl_dge<-tclArray()
				for(i in 0:dim(DE_N)[1]){ for(j in 0:dim(DE_N)[2]){ 
					if(i==0){ ta_nbl_dge[[i,j]]<-colnames(DE_N)[j] } else { 
					if(j==0){ ta_nbl_dge[[i,j]]<-rownames(DE_N)[i] } else {
					tem<-DE_N[i,j]
					ta_nbl_dge[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				DE_N_2[[ts_val]]<<-DE_N
				ta_nbl_dge2[[ts_val]]<<-ta_nbl_dge
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...DGE"))
				}
			}
			if(ts_name=="Series-Matrix"){
				data.matrixNorm.f<-fit2_S[[ts_val]]
				DE_SAll[[ts_val]]<<-topTable(data.matrixNorm.f,
				number=nrow(data.matrixNorm.f),
				lfc=as.numeric(tclvalue(logFC_dge)),
				p.value=as.numeric(tclvalue(p_value)),
				adjust.method=tclvalue(adjust_value),
				sort.by=tclvalue(sort_value))
				if(tclvalue(var1)=="Top genes"){
					if(tclvalue(numb_dge)=="all"){
						DE_S<-DE_SAll[[ts_val]]
					} else {
						DE_S<-topTable(data.matrixNorm.f,
						number=as.numeric(tclvalue(numb_dge)),
						lfc=as.numeric(tclvalue(logFC_dge)),
						p.value=as.numeric(tclvalue(p_value)),
						adjust.method=tclvalue(adjust_value),
						sort.by=tclvalue(sort_value))
					}
				}
				if(tclvalue(var1)=="Gene lists"){
					xf<-strsplit(tclvalue(gn_list),",")
					new_dge<-matrix(,ncol=ncol(DE_SAll[[ts_val]]))
					colnames(new_dge)<-names(DE_SAll[[ts_val]])
					for(i in 1:length(unlist(xf))){
						new_dge<-rbind(new_dge,DE_SAll[[ts_val]][as.character(xf[[1]][i]),])
					}
					new_dge<-new_dge[-1,]
					DE_S<-new_dge
				}
				ta_smt_dge<-tclArray()
				for(i in 0:dim(DE_S)[1]){ for(j in 0:dim(DE_S)[2]){ 
					if(i==0){ ta_smt_dge[[i,j]]<-colnames(DE_S)[j] } else { 
					if(j==0){ ta_smt_dge[[i,j]]<-rownames(DE_S)[i] } else {
					tem<-DE_S[i,j]
					ta_smt_dge[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				DE_S_2[[ts_val]]<<-DE_S
				ta_smt_dge2[[ts_val]]<<-ta_smt_dge
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...DGE"))
				}
			}
			if(ts_name=="Online-Data"){
				data.matrix_onlineNorm.f<-fit2_O[[ts_val]]
				DE_OAll[[ts_val]]<<-topTable(data.matrix_onlineNorm.f,
				number=nrow(data.matrix_onlineNorm.f),
				lfc=as.numeric(tclvalue(logFC_dge)),
				p.value=as.numeric(tclvalue(p_value)),
				adjust.method=tclvalue(adjust_value),
				sort.by=tclvalue(sort_value))
				if(tclvalue(var1)=="Top genes"){
					if(tclvalue(numb_dge)=="all"){
						DE_O<-DE_OAll[[ts_val]]
					} else {
						DE_O<-topTable(data.matrix_onlineNorm.f,
						number=as.numeric(tclvalue(numb_dge)),
						lfc=as.numeric(tclvalue(logFC_dge)),
						p.value=as.numeric(tclvalue(p_value)),
						adjust.method=tclvalue(adjust_value),
						sort.by=tclvalue(sort_value))
					}
				}
				if(tclvalue(var1)=="Gene lists"){
					xf<-strsplit(tclvalue(gn_list),",")
					new_dge<-matrix(,ncol=ncol(DE_OAll[[ts_val]]))
					colnames(new_dge)<-names(DE_OAll[[ts_val]])
					for(i in 1:length(unlist(xf))){
						new_dge<-rbind(new_dge,DE_OAll[[ts_val]][as.character(xf[[1]][i]),])
					}
					new_dge<-new_dge[-1,]
					DE_O<-new_dge
				}
				ta_onl_dge<-tclArray()
				for(i in 0:dim(DE_O)[1]){ for(j in 0:dim(DE_O)[2]){ 
					if(i==0){ ta_onl_dge[[i,j]]<-colnames(DE_O)[j] } else { 
					if(j==0){ ta_onl_dge[[i,j]]<-rownames(DE_O)[i] } else {
					tem<-DE_O[i,j]
					ta_onl_dge[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				DE_O_2[[ts_val]]<<-DE_O
				ta_onl_dge2[[ts_val]]<<-ta_onl_dge
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...DGE"))
				}
			}
		})
	}
	r_choice="._."
	children<-as.character(tcl(treeview,"children",""))
	w_analz<-tktoplevel()
	w_analz_frame<-ttkframe(w_analz,padding=c(3,3,50,20),borderwidth=1,relief="groove")
	tkpack(w_analz_frame,expand=TRUE,fill="both",side="left")
	var<-tclVar(tree_prnts[1])
	sapply(tree_prnts,function(i){
		r_but_vals<-ttkradiobutton(w_analz_frame,variable=var,text=i,value=i)
		tkpack(r_but_vals,side="top",anchor="w")
	})
	tkpack(ttklabel(w_analz_frame,text=''))
	tkpack(ttklabel(w_analz_frame,text=''))
	r_but<-ttkbutton(w_analz_frame,text="Ok")
	tkpack(r_but,pady=2)
	tkconfigure(r_but,command=function(){
		r_choice<-tclvalue(var)
		tkwm.withdraw(w_analz)
		tree_slc<-strsplit(r_choice[1],"_")
		ts_name<-tree_slc[[1]][1]
		ts_val<-as.numeric(tree_slc[[1]][2])
		dge_params(ts_name,ts_val,children,r_choice)
	})
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
dge()

prep_knn<-function(h,...){
	r_choice="._."
	treeview<-treeview
	children<-as.character(tcl(treeview,"children",""))
	w_analz<-tktoplevel()
	w_analz_frame<-ttkframe(w_analz,padding=c(3,3,50,20),borderwidth=1,relief="groove")
	tkpack(w_analz_frame,expand=TRUE,fill="both",side="left")
	tree_prnts_smo=NULL
	for(i in 1:length(tree_prnts)){
		tree_slc<-strsplit(tree_prnts[i],"_")
		if(tree_slc[[1]][1]=="Series-Matrix" || tree_slc[[1]][1]=="Online-Data"){
			tree_prnts_smo<-c(tree_prnts_smo,tree_prnts[i])
		}
	}
	var<-tclVar(tree_prnts_smo[1])
	sapply(tree_prnts_smo,function(i){
		r_but_vals<-ttkradiobutton(w_analz_frame,variable=var,text=i,value=i)
		tkpack(r_but_vals,side="top",anchor="w")
	})
	tkpack(ttklabel(w_analz_frame,text=''))
	tkpack(ttklabel(w_analz_frame,text=''))
	r_but<-ttkbutton(w_analz_frame,text="Ok")
	tkpack(r_but,pady=2)
	tkconfigure(r_but,command=function(){
		r_choice<-tclvalue(var)
		tkdestroy(w_analz)
		tree_slc<-strsplit(r_choice[1],"_")
		ts_name<-tree_slc[[1]][1]
		ts_val<-as.numeric(tree_slc[[1]][2])
	
		if(ts_name=="Series-Matrix"){
			na.length=0
			data.matrixLog<-l_data.matrixLog[[ts_val]]
			if(length(data.matrixLog)!=0){
				na.length<-length(which(is.na(data.matrixLog)==T))
			}
			if(na.length>0){
				w_imp<-tktoplevel(height=500,width=1000)
				tkwm.title(w_imp,"KNN-Imputation")
				tkwm.resizable(w_imp,0,0)
				frame1_imp<-ttkframe(w_imp)
				tkpack(frame1_imp,expand=TRUE,fill="both",side="left")
				tkpack(ttklabel(frame1_imp,text='KNN'))
				r1_imp<-c(2,5,10,50)
				var1<-tclVar(r1_imp[1])
				sapply(r1_imp,function(i){
					r1_imp_vals<-ttkradiobutton(frame1_imp,variable=var1,text=i,value=i)
					tkpack(r1_imp_vals,side="top",anchor="w")
				})
				frame2_imp<-ttkframe(w_imp)
				tkpack(frame2_imp,expand=TRUE,fill="both",side="left")
				tkpack(ttklabel(frame2_imp,text='Row Max'),padx=25)
				r2_imp<-c(0.3,0.5,0.8)
				var2<-tclVar(r2_imp[2])
				sapply(r2_imp,function(i){
					r2_imp_vals<-ttkradiobutton(frame2_imp,variable=var2,text=i,value=i)
					tkpack(r2_imp_vals,side="top",anchor="w",padx=25)
				})
				frame3_imp<-ttkframe(w_imp)
				tkpack(frame3_imp,expand=TRUE,fill="both",side="left")
				tkpack(ttklabel(frame3_imp,text='Col Max'))
				r3_imp<-c(0.3,0.5,0.8)
				var3<-tclVar(r3_imp[3])
				sapply(r3_imp,function(i){
					r3_imp_vals<-ttkradiobutton(frame3_imp,variable=var3,text=i,value=i)
					tkpack(r3_imp_vals,side="top",anchor="w")
				})
				tkpack(ttklabel(frame2_imp,text=''))
				tkpack(ttklabel(frame2_imp,text=''))
				r_but<-ttkbutton(frame2_imp,text="Ok")
				tkpack(r_but)
				tkconfigure(r_but,command=function(){
					tkdestroy(w_imp)
pb_ma<-tkProgressBar(title="KNN Imputation...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
					l_data.matrixImp[[ts_val]]<<-impute.knn(data.matrixLog,k=as.numeric(tclvalue(var1)),rowmax=as.numeric(tclvalue(var2)),colmax=as.numeric(tclvalue(var3)))$data
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
				})
			} else {
				l_data.matrixImp[[ts_val]]<<-data.matrixLog
			}			
		}
		if(ts_name=="Online-Data"){
			na.length=0
			data.matrix_onlineLog<-l_data.matrix_onlineLog[[ts_val]]
			if(length(data.matrix_onlineLog)!=0){
				na.length<-length(which(is.na(data.matrix_onlineLog)==T))
			}
			if(na.length>0){
				w_imp<-tktoplevel()
				tkwm.title(w_imp,"KNN-Imputation")
				tkwm.resizable(w_imp,0,0)
				frame1_imp<-ttkframe(w_imp)
				tkpack(frame1_imp,expand=TRUE,fill="both",side="left")
				tkpack(ttklabel(frame1_imp,text='KNN'))
				r1_imp<-c(2,5,10,50)
				var1<-tclVar(r1_imp[1])
				sapply(r1_imp,function(i){
					r1_imp_vals<-ttkradiobutton(frame1_imp,variable=var1,text=i,value=i)
					tkpack(r1_imp_vals,side="top",anchor="w")
				})
				frame2_imp<-ttkframe(w_imp)
				tkpack(frame2_imp,expand=TRUE,fill="both",side="left")
				tkpack(ttklabel(frame2_imp,text='Row Max'),padx=25)
				r2_imp<-c(0.3,0.5,0.8)
				var2<-tclVar(r2_imp[2])
				sapply(r2_imp,function(i){
					r2_imp_vals<-ttkradiobutton(frame2_imp,variable=var2,text=i,value=i)
					tkpack(r2_imp_vals,side="top",anchor="w",padx=25)
				})
				frame3_imp<-ttkframe(w_imp)
				tkpack(frame3_imp,expand=TRUE,fill="both",side="left")
				tkpack(ttklabel(frame3_imp,text='Col Max'))
				r3_imp<-c(0.3,0.5,0.8)
				var3<-tclVar(r3_imp[3])
				sapply(r3_imp,function(i){
					r3_imp_vals<-ttkradiobutton(frame3_imp,variable=var3,text=i,value=i)
					tkpack(r3_imp_vals,side="top",anchor="w")
				})
#				tkpack(frame3_imp,expand=TRUE,fill="both",side="left")
				tkpack(ttklabel(frame2_imp,text=''))
				tkpack(ttklabel(frame2_imp,text=''))
				r_but<-ttkbutton(frame2_imp,text="Ok")
				tkpack(r_but)
				tkconfigure(r_but,command=function(){
					tkwm.withdraw(w_imp)
pb_ma<-tkProgressBar(title="KNN Imputation...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
					l_data.matrix_onlineImp[[ts_val]]<<-impute.knn(data.matrix_onlineLog,k=as.numeric(tclvalue(var1)),rowmax=as.numeric(tclvalue(var2)),colmax=as.numeric(tclvalue(var3)))$data
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
				})
			} else {
				l_data.matrix_onlineImp[[ts_val]]<<-data.matrix_onlineLog
			}
		}
	})
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("BiocManager",quietly=TRUE)){install.packages("BiocManager");library(BiocManager)} else {library(BiocManager)}
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
if(!requireNamespace("impute",quietly=TRUE)){BiocManager::install("impute",ask=FALSE,update=FALSE);library(impute)} else {library(impute)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
prep_knn()

filter_sp<-function(h,...){
	sp_filt<-function(h,h2,h3,h4,...){
		ts_name<-h;ts_val<-h2;children<-h3;r_choice=h4
		w_imp2<-tktoplevel()
		tkwm.title(w_imp2,"Groups")
		tkwm.resizable(w_imp2,0,0)
		frame1_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
		tkpack(ttklabel(frame1_imp2,text="Controls"),side="left",padx=60)
		tkpack(ttklabel(frame1_imp2,text="Tests"),side="left",padx=100)
		tkpack(frame1_imp2,expand=TRUE,fill="both",side="top")
		frame2_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12),height=40,width=50,borderwidth=1,relief="groove")
		tkpack(frame2_imp2,expand=TRUE,fill="both",side="left")
		frame3_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12),height=40,width=50,borderwidth=1,relief="groove")
		tkpack(frame3_imp2,expand=TRUE,fill="both",side="right")		
		controls<-NULL;tests<-NULL;add_i=NULL;
		frame2_1_imp2<-ttkframe(frame2_imp2,padding=c(3,3,12,12),height=30,width=50,borderwidth=1,relief="groove")
		tkpack(frame2_1_imp2,expand=TRUE,fill="both",side="top")
		c1<-ttkentry(frame2_1_imp2,textvariable=tclVar(""),width=25)
		tkpack(c1,side="left",anchor="e")
		controls<-c(controls,c1)
		t1<-ttkentry(frame2_1_imp2,textvariable=tclVar(""),width=25)
		tkpack(t1,side="right",anchor="e")
		tests<-c(tests,t1)
		add_i=1
		r_but_add<-ttkbutton(frame3_imp2,text="Add")
		tkpack(r_but_add,side="top",anchor="e",pady=5)
		r_but_ok<-ttkbutton(frame3_imp2,text="Ok")
		tkpack(r_but_ok,side="top",anchor="e",pady=5)
		tkpack(frame3_imp2,expand=TRUE,fill="both",side="top")
		tkconfigure(r_but_add,command=function(){
			frame2_2_imp2<-ttkframe(frame2_imp2,padding=c(3,3,12,12),height=30,width=50,borderwidth=1,relief="groove")
			tkpack(frame2_2_imp2,expand=TRUE,fill="both",side="top")
			c2<-ttkentry(frame2_2_imp2,textvariable=tclVar(""),width=25)
			tkpack(c2,side="left",anchor="e")
			controls<<-c(controls,c2)
			t2<-ttkentry(frame2_2_imp2,textvariable=tclVar(""),width=25)
			tkpack(t2,side="right",anchor="e")
			tests<<-c(tests,t2)
			add_i<<-add_i+2
		})
		tkconfigure(r_but_ok,command=function(){
			i=1
			groups<<-c()
			samp<<-c()
			while(i<=add_i){
				xf<-strsplit(tclvalue(tkget(as.tclObj(controls[i]$ID))),",");
				yf<-strsplit(tclvalue(tkget(as.tclObj(tests[i]$ID))),",");
				if(i>2){
					groups<<-c(groups,rep(paste("T",i,sep=""),length(yf[[1]])))
					samp<<-c(samp,yf[[1]])
				} else {
					groups<<-c(groups,rep(paste("C",i,sep=""),length(xf[[1]])),rep(paste("T",i,sep=""),length(yf[[1]])))
					samp<<-c(samp,xf[[1]],yf[[1]])
				}
				i=i+2
			}	
			tkwm.withdraw(w_imp2)
			groups<-as.factor(groups);
			design<-model.matrix(~groups);
			if(ts_name=="Affymetrix"){
				dat2Affy.m<-dat2Affy.m2[[ts_val]];fit<-lmFit(dat2Affy.m[,samp],design);print(fit)
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
				err<-try(fit<-lmFit(dat2Affy.m[,samp],design),silent=TRUE)
				if(length(grep("incompatible dimensions",err))!=0)tkmessageBox(title="Error Comparison",message="Incompatible dimensions or wrong group comparisons",icon="error",type="ok")
				fit2<-eBayes(fit)
				fit2_Affy[[ts_val]]<<-fit2
				dat2Affy.f<-fit2
#				groups_Affy<<-groups
#				design_Affy<<-design
				samp_Affy[[ts_val]]<<-samp
				ps1<-as.data.frame(dat2Affy.f)
				rownames(ps1)<-rownames(fit2)
				dat2Affy.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
				ta_affy_filt<-tclArray()
				for(i in 0:dim(dat2Affy.f2)[1]){ for(j in 0:dim(dat2Affy.f2)[2]){ 
					if(i==0){ ta_affy_filt[[i,j]]<-colnames(dat2Affy.f2)[j] } else { 
					if(j==0){ ta_affy_filt[[i,j]]<-rownames(dat2Affy.f2)[i] } else {
					tem<-dat2Affy.f2[i,j]
					ta_affy_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				dat2Affy.f3[[ts_val]]<<-dat2Affy.f2
				ta_affy_filt2[[ts_val]]<<-ta_affy_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
				}
				if(length(dat2Affy.f)!=0){
					err<-try({
						ttx<-topTable(dat2Affy.f,number=nrow(dat2Affy.m))
						rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(dat2Affy.m)==TRUE)]
					dat2Affy.s<-dat2Affy.m[rn,]
					},silent=TRUE)
					if(length(grep("Error",err))!=0)
					{
						ttx<-topTable(dat2Affy.f,number=nrow(dat2Affy.m))
						rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(dat2Affy.m)==TRUE)])
						dat2Affy.s<-dat2Affy.m[rownames(ttx)[ttx$P.Value<=0.01],]
					}
				}
				dat2Affy.s2<-dat2Affy.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
				ta_affy_stat<-tclArray()
				for(i in 0:dim(dat2Affy.s2)[1]){ for(j in 0:dim(dat2Affy.s2)[2]){ 
					if(i==0){ ta_affy_stat[[i,j]]<-colnames(dat2Affy.s2)[j] } else { 
					if(j==0){ ta_affy_stat[[i,j]]<-rownames(dat2Affy.s2)[i] } else {
					tem<-dat2Affy.s2[i,j]
					ta_affy_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }			
				dat2Affy.s3[[ts_val]]<<-dat2Affy.s2			
				ta_affy_stat2[[ts_val]]<<-ta_affy_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
				}
			}
			if(ts_name=="Agilent-OneColor"){
				datAgOne2.m<-datAgOne2.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
				err<-try(fit<-lmFit(datAgOne2.m[,samp],design),silent=TRUE)
				if(length(grep("incompatible dimensions",err))!=0)tkmessageBox(title="Error Comparison",message="Incompatible dimensions or wrong group comparisons",icon="error",type="ok")
				fit2<-eBayes(fit)
				fit2_Ag1[[ts_val]]<<-fit2
				datAgOne2.f<-fit2
#				groups_Affy<<-groups
#				design_Affy<<-design
				samp_Ag1[[ts_val]]<<-samp
				ps1<-as.data.frame(datAgOne2.f)	
				rownames(ps1)<-rownames(fit2)
				datAgOne2.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
				ta_ag1_filt<-tclArray()
				for(i in 0:dim(datAgOne2.f2)[1]){ for(j in 0:dim(datAgOne2.f2)[2]){ 
					if(i==0){ ta_ag1_filt[[i,j]]<-colnames(datAgOne2.f2)[j] } else { 
					if(j==0){ ta_ag1_filt[[i,j]]<-rownames(datAgOne2.f2)[i] } else {
						tem<-datAgOne2.f2[i,j]
					ta_ag1_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				datAgOne2.f3[[ts_val]]<<-datAgOne2.f2
				ta_ag1_filt2[[ts_val]]<<-ta_ag1_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
						if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
				}
				if(length(datAgOne2.f)!=0){
					err<-try({
						ttx<-topTable(datAgOne2.f,number=nrow(datAgOne2.m))
						rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(datAgOne2.m)==TRUE)]
						datAgOne2.s<-datAgOne2.m[rn,]
					},silent=TRUE)
					if(length(grep("Error",err))!=0)
					{
						ttx<-topTable(datAgOne2.f,number=nrow(datAgOne2.m))
						rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(datAgOne2.m)==TRUE)])
						datAgOne2.s<-datAgOne2.m[rownames(ttx)[ttx$P.Value<=0.01],]
					}
				}
				datAgOne2.s2<-datAgOne2.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
				ta_ag1_stat<-tclArray()
				for(i in 0:dim(datAgOne2.s2)[1]){ for(j in 0:dim(datAgOne2.s2)[2]){ 
					if(i==0){ ta_ag1_stat[[i,j]]<-colnames(datAgOne2.s2)[j] } else { 
					if(j==0){ ta_ag1_stat[[i,j]]<-rownames(datAgOne2.s2)[i] } else {
					tem<-datAgOne2.s2[i,j]
					ta_ag1_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }			
				datAgOne2.s3[[ts_val]]<<-datAgOne2.s2			
				ta_ag1_stat2[[ts_val]]<<-ta_ag1_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
				}	
			}
			if(ts_name=="Agilent-TwoColor"){
				datAgTwo2.m<-datAgTwo2.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
				err<-try(fit<-lmFit(datAgTwo2.m[,samp],design),silent=TRUE)
				if(length(grep("incompatible dimensions",err))!=0)tkmessageBox(title="Error Comparison",message="Incompatible dimensions or wrong group comparisons",icon="error",type="ok")
				fit2<-eBayes(fit)
				fit2_Ag2[[ts_val]]<<-fit2
				datAgTwo2.f<-fit2
#				groups_Affy<<-groups
#				design_Affy<<-design
				samp_Ag2[[ts_val]]<<-samp
				ps1<-as.data.frame(datAgTwo2.f)	
				rownames(ps1)<-rownames(fit2)
				datAgTwo2.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
				ta_ag2_filt<-tclArray()
				for(i in 0:dim(datAgTwo2.f2)[1]){ for(j in 0:dim(datAgTwo2.f2)[2]){ 
					if(i==0){ ta_ag2_filt[[i,j]]<-colnames(datAgTwo2.f2)[j] } else { 
					if(j==0){ ta_ag2_filt[[i,j]]<-rownames(datAgTwo2.f2)[i] } else {
					tem<-datAgTwo2.f2[i,j]
					ta_ag2_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				datAgTwo2.f3[[ts_val]]<<-datAgTwo2.f2
				ta_ag2_filt2[[ts_val]]<<-ta_ag2_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
				}
				if(length(datAgTwo2.f)!=0){
					err<-try({
							ttx<-topTable(datAgTwo2.f,number=nrow(datAgTwo2.m))
							rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(datAgTwo2.m)==TRUE)]
							datAgTwo2.s<-datAgTwo2.m[rn,]
						},silent=TRUE)
					if(length(grep("Error",err))!=0)
					{
						ttx<-topTable(datAgTwo2.f,number=nrow(datAgTwo2.m))
						rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(datAgTwo2.m)==TRUE)])
						datAgTwo2.s<-datAgTwo2.m[rownames(ttx)[ttx$P.Value<=0.01],]
					}
				}
				datAgTwo2.s2<-datAgTwo2.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
				ta_ag2_stat<-tclArray()
				for(i in 0:dim(datAgTwo2.s2)[1]){ for(j in 0:dim(datAgTwo2.s2)[2]){ 
					if(i==0){ ta_ag2_stat[[i,j]]<-colnames(datAgTwo2.s2)[j] } else { 
					if(j==0){ ta_ag2_stat[[i,j]]<-rownames(datAgTwo2.s2)[i] } else {
					tem<-datAgTwo2.s2[i,j]
					ta_ag2_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }			
				datAgTwo2.s3[[ts_val]]<<-datAgTwo2.s2			
				ta_ag2_stat2[[ts_val]]<<-ta_ag2_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
				}
			}
			if(ts_name=="Illumina-Beadarray"){
				datIllBA2.m<-datIllBA2.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
				err<-try(fit<-lmFit(datIllBA2.m[,samp],design),silent=TRUE)
				if(length(grep("incompatible dimensions",err))!=0)tkmessageBox(title="Error Comparison",message="Incompatible dimensions or wrong group comparisons",icon="error",type="ok")
				fit2<-eBayes(fit)
				fit2_Il_B[[ts_val]]<<-fit2
				datIllBA2.f<-fit2
#				groups_Affy<<-groups
#				design_Affy<<-design
				samp_Il_B[[ts_val]]<<-samp
				datIllBA2.f<-fit2
				ps1<-as.data.frame(datIllBA2.f)	
				rownames(ps1)<-rownames(fit2)
				datIllBA2.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
				ta_ilb_filt<-tclArray()
				for(i in 0:dim(datIllBA2.f2)[1]){ for(j in 0:dim(datIllBA2.f2)[2]){ 
					if(i==0){ ta_ilb_filt[[i,j]]<-colnames(datIllBA2.f2)[j] } else { 
					if(j==0){ ta_ilb_filt[[i,j]]<-rownames(datIllBA2.f2)[i] } else {
					tem<-datIllBA2.f2[i,j]
					ta_ilb_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				datIllBA2.f3[[ts_val]]<<-datIllBA2.f2
				ta_ilb_filt2[[ts_val]]<<-ta_ilb_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
				}
				if(length(datIllBA2.f)!=0){
					err<-try({
							ttx<-topTable(datIllBA2.f,number=nrow(datIllBA2.m))
							rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(datIllBA2.m1)==TRUE)]
							datIllBA2.s<-datIllBA2.m[rn,]
						},silent=TRUE)
					if(length(grep("Error",err))!=0)
					{
						ttx<-topTable(datIllBA2.f,number=nrow(datIllBA2.m))
						rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(datIllBA2.m1)==TRUE)])
						datIllBA2.s<-datIllBA2.m1[rownames(ttx)[ttx$P.Value<=0.01],]
					}
				}
				datIllBA2.s2<-datIllBA2.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
				ta_ilb_stat<-tclArray()
				for(i in 0:dim(datIllBA2.s2)[1]){ for(j in 0:dim(datIllBA2.s2)[2]){ 
					if(i==0){ ta_ilb_stat[[i,j]]<-colnames(datIllBA2.s2)[j] } else { 
					if(j==0){ ta_ilb_stat[[i,j]]<-rownames(datIllBA2.s2)[i] } else {
					tem<-datIllBA2.s2[i,j]
					ta_ilb_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }			
				datIllBA2.s3[[ts_val]]<<-datIllBA2.s2			
				ta_ilb_stat2[[ts_val]]<<-ta_ilb_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
				}
			}
			if(ts_name=="Illumina-Lumi"){
				lumi_NQ.m<-lumi_NQ.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
				err<-try(fit<-lmFit(lumi_NQ.m[,samp],design),silent=TRUE)
				if(length(grep("incompatible dimensions",err))!=0)tkmessageBox(title="Error Comparison",message="Incompatible dimensions or wrong group comparisons",icon="error",type="ok")
				fit2<-eBayes(fit)
				fit2_Il_L[[ts_val]]<<-fit2
				lumi_NQ.f<-fit2
#				groups_Affy<<-groups
#				design_Affy<<-design
				samp_Il_L[[ts_val]]<<-samp
				ps1<-as.data.frame(lumi_NQ.f)	
				rownames(ps1)<-rownames(fit2)
				lumi_NQ.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
				ta_ill_filt<-tclArray()
				for(i in 0:dim(lumi_NQ.f2)[1]){ for(j in 0:dim(lumi_NQ.f2)[2]){ 
					if(i==0){ ta_ill_filt[[i,j]]<-colnames(lumi_NQ.f2)[j] } else { 
					if(j==0){ ta_ill_filt[[i,j]]<-rownames(lumi_NQ.f2)[i] } else {
					tem<-lumi_NQ.f2[i,j]
					ta_ill_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				lumi_NQ.f3[[ts_val]]<<-lumi_NQ.f2
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
				ta_ill_filt2[[ts_val]]<<-ta_ill_filt
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
				}
				if(length(lumi_NQ.f)!=0){
					err<-try({
							ttx<-topTable(lumi_NQ.f,number=nrow(lumi_NQ.m))
							rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(lumi_NQ.m)==TRUE)]
							lumi_NQ.s<-lumi_NQ.m[rn,]
						},silent=TRUE)
					if(length(grep("Error",err))!=0)
					{
						ttx<-topTable(lumi_NQ.f,number=nrow(lumi_NQ.m))
						rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(lumi_NQ.m)==TRUE)])
						lumi_NQ.s<-lumi_NQ.m[rownames(ttx)[ttx$P.Value<=0.01],]
					}
				}
				lumi_NQ.s2<-lumi_NQ.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
				ta_ill_stat<-tclArray()
				for(i in 0:dim(lumi_NQ.s2)[1]){ for(j in 0:dim(lumi_NQ.s2)[2]){ 
					if(i==0){ ta_ill_stat[[i,j]]<-colnames(lumi_NQ.s2)[j] } else { 
					if(j==0){ ta_ill_stat[[i,j]]<-rownames(lumi_NQ.s2)[i] } else {
					tem<-lumi_NQ.s2[i,j]
					ta_ill_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }			
				lumi_NQ.s3[[ts_val]]<<-lumi_NQ.s2			
				ta_ill_stat2[[ts_val]]<<-ta_ill_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
				}
			}
			if(ts_name=="Nimblegen"){
				data.matrix_Nimblegen2.m<-data.matrix_Nimblegen2.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
				err<-try(fit<-lmFit(data.matrix_Nimblegen2.m[,samp],design),silent=TRUE)
				if(length(grep("incompatible dimensions",err))!=0)tkmessageBox(title="Error Comparison",message="Incompatible dimensions or wrong group comparisons",icon="error",type="ok")
				fit2<-eBayes(fit)
				fit2_N[[ts_val]]<<-fit2
				data.matrix_Nimblegen2.f<-fit2
#				groups_Affy<<-groups
#				design_Affy<<-design
				samp_N[[ts_val]]<<-samp
				ps1<-as.data.frame(data.matrix_Nimblegen2.f)	
				rownames(ps1)<-rownames(fit2)
				data.matrix_Nimblegen2.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
				ta_nbl_filt<-tclArray()
				for(i in 0:dim(data.matrix_Nimblegen2.f2)[1]){ for(j in 0:dim(data.matrix_Nimblegen2.f2)[2]){ 
					if(i==0){ ta_nbl_filt[[i,j]]<-colnames(data.matrix_Nimblegen2.f2)[j] } else { 
					if(j==0){ ta_nbl_filt[[i,j]]<-rownames(data.matrix_Nimblegen2.f2)[i] } else {
					tem<-data.matrix_Nimblegen2.f2[i,j]
					ta_nbl_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				data.matrix_Nimblegen2.f3[[ts_val]]<<-data.matrix_Nimblegen2.f2
				ta_nbl_filt2[[ts_val]]<<-ta_nbl_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
				}
				if(length(data.matrix_Nimblegen2.f)!=0){
					err<-try({
							ttx<-topTable(data.matrix_Nimblegen2.f,number=nrow(data.matrix_Nimblegen2.m))
							rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_Nimblegen2.m)==TRUE)]
							data.matrix_Nimblegen2.s<-data.matrix_Nimblegen2.m[rn,]
						},silent=TRUE)
					if(length(grep("Error",err))!=0)
					{
						ttx<-topTable(data.matrix_Nimblegen2.f,number=nrow(data.matrix_Nimblegen2.m))
						rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_Nimblegen2.m)==TRUE)])
						data.matrix_Nimblegen2.s<-data.matrix_Nimblegen2.m[rownames(ttx)[ttx$P.Value<=0.01],]
					}
				}
				data.matrix_Nimblegen2.s2<-data.matrix_Nimblegen2.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
				ta_nbl_stat<-tclArray()
				for(i in 0:dim(data.matrix_Nimblegen2.s2)[1]){ for(j in 0:dim(data.matrix_Nimblegen2.s2)[2]){ 
					if(i==0){ ta_nbl_stat[[i,j]]<-colnames(data.matrix_Nimblegen2.s2)[j] } else { 
					if(j==0){ ta_nbl_stat[[i,j]]<-rownames(data.matrix_Nimblegen2.s2)[i] } else {
					tem<-data.matrix_Nimblegen2.s2[i,j]
					ta_nbl_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }			
				data.matrix_Nimblegen2.s3[[ts_val]]<<-data.matrix_Nimblegen2.s2			
				ta_nbl_stat2[[ts_val]]<<-ta_nbl_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
				}
			}
			if(ts_name=="Series-Matrix"){
				data.matrixNorm.m<-data.matrixNorm.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
				err<-try(fit<-lmFit(data.matrixNorm.m[,samp],design),silent=TRUE)
				if(length(grep("incompatible dimensions",err))!=0)tkmessageBox(title="Error Comparison",message="Incompatible dimensions or wrong group comparisons",icon="error",type="ok")
				fit2<-eBayes(fit)
				fit2_S[[ts_val]]<<-fit2
				data.matrixNorm.f<-fit2
#				groups_Affy<<-groups
#				design_Affy<<-design
				samp_S[[ts_val]]<<-samp
				ps1<-as.data.frame(data.matrixNorm.f)	
				rownames(ps1)<-rownames(fit2)
				data.matrixNorm.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
				ta_smt_filt<-tclArray()
				for(i in 0:dim(data.matrixNorm.f2)[1]){ for(j in 0:dim(data.matrixNorm.f2)[2]){ 
					if(i==0){ ta_smt_filt[[i,j]]<-colnames(data.matrixNorm.f2)[j] } else { 
					if(j==0){ ta_smt_filt[[i,j]]<-rownames(data.matrixNorm.f2)[i] } else {
					tem<-data.matrixNorm.f2[i,j]
					ta_smt_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				data.matrixNorm.f3[[ts_val]]<<-data.matrixNorm.f2
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
				ta_smt_filt2[[ts_val]]<<-ta_smt_filt
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
				}
				if(length(data.matrixNorm.f)!=0){
					err<-try({
						ttx<-topTable(data.matrixNorm.f,number=nrow(data.matrixNorm.m))
						rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrixNorm.m)==TRUE)]
						data.matrixNorm.s<-data.matrixNorm.m[rn,]
					},silent=TRUE)
					if(length(grep("Error",err))!=0)
					{
						ttx<-topTable(data.matrixNorm.f,number=nrow(data.matrixNorm.m))
						rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrixNorm.m)==TRUE)])
						data.matrixNorm.s<-data.matrixNorm.m[rownames(ttx)[ttx$P.Value<=0.01],]
					}
				}
				data.matrixNorm.s2<-data.matrixNorm.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
				ta_smt_stat<-tclArray()
				for(i in 0:dim(data.matrixNorm.s2)[1]){ for(j in 0:dim(data.matrixNorm.s2)[2]){ 
					if(i==0){ ta_smt_stat[[i,j]]<-colnames(data.matrixNorm.s2)[j] } else { 
					if(j==0){ ta_smt_stat[[i,j]]<-rownames(data.matrixNorm.s2)[i] } else {
					tem<-data.matrixNorm.s2[i,j]
					ta_smt_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }			
				data.matrixNorm.s3[[ts_val]]<<-data.matrixNorm.s2			
				ta_smt_stat2[[ts_val]]<<-ta_smt_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
				}
			}
			if(ts_name=="Online-Data"){
				data.matrix_onlineNorm.m<-data.matrix_onlineNorm.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
				err<-try(fit<-lmFit(data.matrix_onlineNorm.m[,samp],design),silent=TRUE)
				if(length(grep("incompatible dimensions",err))!=0)tkmessageBox(title="Error Comparison",message="Incompatible dimensions or wrong group comparisons",icon="error",type="ok")
				fit2<-eBayes(fit)
				fit2_O[[ts_val]]<<-fit2
				data.matrix_onlineNorm.f<-fit2
#				groups_Affy<<-groups
#				design_Affy<<-design
				samp_O[[ts_val]]<<-samp
				ps1<-as.data.frame(data.matrix_onlineNorm.f)	
				rownames(ps1)<-rownames(fit2)
				data.matrix_onlineNorm.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
				ta_onl_filt<-tclArray()
				for(i in 0:dim(data.matrix_onlineNorm.f2)[1]){ for(j in 0:dim(data.matrix_onlineNorm.f2)[2]){ 
					if(i==0){ ta_onl_filt[[i,j]]<-colnames(data.matrix_onlineNorm.f2)[j] } else { 
					if(j==0){ ta_onl_filt[[i,j]]<-rownames(data.matrix_onlineNorm.f2)[i] } else {
					tem<-data.matrix_onlineNorm.f2[i,j]
					ta_onl_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				data.matrix_onlineNorm.f3[[ts_val]]<<-data.matrix_onlineNorm.f2
				ta_onl_filt2[[ts_val]]<<-ta_onl_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
				}
				if(length(data.matrix_onlineNorm.f)!=0){
					err<-try({
						ttx<-topTable(data.matrix_onlineNorm.f,number=nrow(data.matrix_onlineNorm.m))
						rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_onlineNorm.m)==TRUE)]
						data.matrix_onlineNorm.s<-data.matrix_onlineNorm.m[rn,]
					},silent=TRUE)
					if(length(grep("Error",err))!=0)
					{
						ttx<-topTable(data.matrix_onlineNorm.f,number=nrow(data.matrix_onlineNorm.m))
						rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_onlineNorm.m)==TRUE)])
						data.matrix_onlineNorm.s<-data.matrix_onlineNorm.m[rownames(ttx)[ttx$P.Value<=0.01],]
					}
				}
				data.matrix_onlineNorm.s2<-data.matrix_onlineNorm.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
				ta_onl_stat<-tclArray()
				for(i in 0:dim(data.matrix_onlineNorm.s2)[1]){ for(j in 0:dim(data.matrix_onlineNorm.s2)[2]){ 
					if(i==0){ ta_onl_stat[[i,j]]<-colnames(data.matrix_onlineNorm.s2)[j] } else { 
					if(j==0){ ta_onl_stat[[i,j]]<-rownames(data.matrix_onlineNorm.s2)[i] } else {
					tem<-data.matrix_onlineNorm.s2[i,j]
					ta_onl_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }			
				data.matrix_onlineNorm.s3[[ts_val]]<<-data.matrix_onlineNorm.s2			
				ta_onl_stat2[[ts_val]]<<-ta_onl_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
				}
			}	
		})
	}

	r_choice="._."
	children<-as.character(tcl(treeview,"children",""))
	w_analz<-tktoplevel()
	w_analz_frame<-ttkframe(w_analz,padding=c(3,3,50,20),borderwidth=1,relief="groove")
	tkpack(w_analz_frame,expand=TRUE,fill="both",side="left")
	var<-tclVar(tree_prnts[1])
	sapply(tree_prnts,function(i){
		r_but_vals<-ttkradiobutton(w_analz_frame,variable=var,text=i,value=i)
		tkpack(r_but_vals,side="top",anchor="w")
	})
	tkpack(ttklabel(w_analz_frame,text=''))
	tkpack(ttklabel(w_analz_frame,text=''))
	r_but<-ttkbutton(w_analz_frame,text="Ok")
	tkpack(r_but,pady=2)
	tkconfigure(r_but,command=function(){
		r_choice<-tclvalue(var)
		tkwm.withdraw(w_analz)
		tree_slc<-strsplit(r_choice[1],"_")
		ts_name<-tree_slc[[1]][1]
		ts_val<-as.numeric(tree_slc[[1]][2])
		sp_filt(ts_name,ts_val,children,r_choice)
	})
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
filter_sp()

nimblg<-function(h,...){
	folder<-tclvalue(tkchooseDirectory(title="Select the folder"))
	tnbl_i<<-tnbl_i+1
	folder_N[[tnbl_i]]<<-folder
	new_data.matrix_Nimblegen<<-NULL
	if(folder_N[[tnbl_i]]==""){
		folder_N[[tnbl_i]]<-NULL
	} else {
		try(({
pb_ma<-tkProgressBar(title="Pre-processing...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			setwd(folder_N[[tnbl_i]])
			pair2xys(list.files(pattern='\\.pair$'))
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
			ndf<-list.files(pattern=".ndf")
			seed<-new("NgsExpressionPDInfoPkgSeed",ndfFile=ndf,xysFile=list.files(pattern='xys$')[1])
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ndf2=gsub(".ndf","",ndf)
			ndf3=gsub("_",".",ndf2)
			pkg=paste("pd",ndf3,sep=".")
			pkg2<-tolower(pkg)
			if(length(dir(pkg2))==0)makePdInfoPackage(seed,destDir=".")	
			install.packages(pkg2,type='source',repos=NULL)
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
			pkg3<-pkg2
			xys=list.xysfiles()
			new_rawData<-read.xysfiles(xys,pkgname=pkg3)
			if(length(new_rawData)!=0){rawData=NULL;rawData<-new_rawData}
			z<-annotation(rawData)
			z1<-strsplit(z,"\\.")
			zz<-z1[[1]][2]
			ann_N[[tnbl_i]]<<-toupper(zz)
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
			try(
			({
				res<-rma(rawData)
				new_data.matrix_Nimblegen<-exprs(res)
			}),silent=TRUE)
			if(length(new_data.matrix_Nimblegen)==0)
			{
				new_data.matrix_Nimblegen<-exprs(rawData)
			}
			if(length(new_data.matrix_Nimblegen)!=0){data.matrix_Nimblegen=NULL;data.matrix_Nimblegen<-new_data.matrix_Nimblegen}
		 }),silent=TRUE)
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
		if(length(new_data.matrix_Nimblegen)==0)tkmessageBox(title="Error",message="Could not load this type of data! Try Series_matrix or Online_Data",icon="error",type="ok")
	}
	if(length(data.matrix_Nimblegen)!=0){
		if(length(new_data.matrix_Nimblegen)!=0){

		prnt<-paste("Nimblegen",tnbl_i,sep="_")
		tree_prnts<<-c(tree_prnts,prnt)
		l_data.matrix_Nimblegen[[tnbl_i]]<<-data.matrix_Nimblegen
p_enter<-tcl(treeview,"insert","","end",values=as.tclObj(prnt))

			autopa<-tkmessageBox(title="Confirm",message="Do you want to pre-process and analyze automatically!",icon="question",type="okcancel")
			if(tclvalue(autopa)=="ok"){
pb_ma<-tkProgressBar(title="Normalization...",label="",min=0,max=1,initial=0,width=500)
				data.matrix_Nimblegen2.m=NULL;use.data.matrix_Nimblegen2.m=NULL;xf=NULL;data.matrix_Nimblegen2.f=NULL;data.matrix_Nimblegen2.s=NULL;
				design=NULL;design_N=NULL;ttx=NULL;DE_N=NULL;DE_N_2=NULL;use_DE_N=NULL;
				sample.dist_N=NULL;
#				pca_N=NULL;
#				sample.clust_N=NULL;
#				clas_N=NULL;
				try(({folder_N[[tnbl_i]]<-folder_N[[tnbl_i]];data.matrix_Nimblegen<-data.matrix_Nimblegen;heatcol<-heatcol; }),silent=TRUE)
				setwd(folder_N[[tnbl_i]])	
setTkProgressBar(pb_ma,0.1,title=NULL,label="")
				data.matrix_Nimblegen2<-normalizeBetweenArrays(data.matrix_Nimblegen,method="quantile")
				data.matrix_Nimblegen2.m<-normalizeBetweenArrays(data.matrix_Nimblegen2,method="quantile")
				data.matrix_Nimblegen2.m<-as.matrix(data.matrix_Nimblegen2.m)
				try({
					if(length(rownames(data.matrix_Nimblegen2.m))==0){
						rownames(data.matrix_Nimblegen2.m)<-1:length(data.matrix_Nimblegen2.m[,1])
					} else {
						rownames(data.matrix_Nimblegen2.m)<-as.character(rownames(data.matrix_Nimblegen2.m))
					}
				},silent=TRUE)
				ta_nbl_norm<-tclArray()
				for(i in 0:dim(data.matrix_Nimblegen2.m)[1]){ for(j in 0:dim(data.matrix_Nimblegen2.m)[2]){ 
					if(i==0){ ta_nbl_norm[[i,j]]<-colnames(data.matrix_Nimblegen2.m)[j] } else { 
					if(j==0){ ta_nbl_norm[[i,j]]<-rownames(data.matrix_Nimblegen2.m)[i] } else {
					tem<-data.matrix_Nimblegen2.m[i,j]
					ta_nbl_norm[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }

#				data.matrix_Nimblegen2.m<<-data.matrix_Nimblegen2.m
				data.matrix_Nimblegen2.m2[[tnbl_i]]<<-data.matrix_Nimblegen2.m
				
				ta_nbl_norm2[[tnbl_i]]<<-ta_nbl_norm
#				

p_enter_norm<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Normalization"))
setTkProgressBar(pb_ma,0.3,title="QC...",label="")
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){boxplot(data.matrix_Nimblegen2.m)},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)
				} else {
					ma_img2<<-tkrreplot(ma_img,function(...){boxplot(data.matrix_Nimblegen2.m)},hscale=1.7,vscale=1.07)
				}
p_enter_qc<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...QC"))
setTkProgressBar(pb_ma,0.35,title="Filtering...",label="")
				use.data.matrix_Nimblegen2.m<-data.matrix_Nimblegen2.m
				try(({
					fff<-pOverA(A=1,p=0.05)
					i<-genefilter(use.data.matrix_Nimblegen2.m,fff)
					dat.fo<-use.data.matrix_Nimblegen2.m[i,]
					i<-genefilter(-use.data.matrix_Nimblegen2.m,fff)
					dat.fu<-use.data.matrix_Nimblegen2.m[i,]
					dat.f<-unique(rbind(dat.fo,dat.fu))
					fit<-lmFit(dat.f)
					fit2<-eBayes(fit)
					fit2_N[[tnbl_i]]<<-fit2
					data.matrix_Nimblegen2.f<-fit2
				}),silent=TRUE)
				if(length(data.matrix_Nimblegen2.f)==0)
				{
					try(({
						rsd<-rowSds(use.data.matrix_Nimblegen2.m)
						i<-rsd>=2
						dat.f<-use.data.matrix_Nimblegen2.m[i,]
						fit<-lmFit(dat.f)
						fit2<-eBayes(fit)
						fit2_N[[tnbl_i]]<<-fit2
						data.matrix_Nimblegen2.f<-fit2
					}),silent=TRUE)
				}
				ps1<-as.data.frame(data.matrix_Nimblegen2.f)	
				rownames(ps1)<-rownames(data.matrix_Nimblegen2.f)
				data.matrix_Nimblegen2.f2=NULL
				data.matrix_Nimblegen2.f2<-ps1
				ta_nbl_filt=NULL
				ta_nbl_filt<-tclArray()
				for(i in 0:dim(data.matrix_Nimblegen2.f2)[1]){ for(j in 0:dim(data.matrix_Nimblegen2.f2)[2]){ 
					if(i==0){ ta_nbl_filt[[i,j]]<-colnames(data.matrix_Nimblegen2.f2)[j] } else { 
					if(j==0){ ta_nbl_filt[[i,j]]<-rownames(data.matrix_Nimblegen2.f2)[i] } else {
					tem<-data.matrix_Nimblegen2.f2[i,j]
					ta_nbl_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				
				data.matrix_Nimblegen2.f3[[tnbl_i]]<<-data.matrix_Nimblegen2.f2
				
				ta_nbl_filt2[[tnbl_i]]<<-ta_nbl_filt

p_enter_filter<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Filtering"))
setTkProgressBar(pb_ma,0.55,title="Statistical_Significant...",label="")
				if(length(data.matrix_Nimblegen2.f)!=0){
					err<-try({
							ttx<-topTable(data.matrix_Nimblegen2.f,number=nrow(use.data.matrix_Nimblegen2.m))
							rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_Nimblegen2.m)==TRUE)]
							data.matrix_Nimblegen2.s<-use.data.matrix_Nimblegen2.m[rn,]
						},silent=TRUE)
					if(length(grep("Error",err))!=0)
					{
						ttx<-topTable(data.matrix_Nimblegen2.f,number=nrow(use.data.matrix_Nimblegen2.m))
						rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_Nimblegen2.m)==TRUE)])
						data.matrix_Nimblegen2.s<-data.matrix_Nimblegen2.m[rownames(ttx)[ttx$P.Value<=0.01],]
					}
				}
				data.matrix_Nimblegen2.s2=NULL
				data.matrix_Nimblegen2.s2<-data.matrix_Nimblegen2.s
				ta_nbl_stat=NULL
				ta_nbl_stat<-tclArray()
				for(i in 0:dim(data.matrix_Nimblegen2.s2)[1]){ for(j in 0:dim(data.matrix_Nimblegen2.s2)[2]){ 
					if(i==0){ ta_nbl_stat[[i,j]]<-colnames(data.matrix_Nimblegen2.s2)[j] } else { 
					if(j==0){ ta_nbl_stat[[i,j]]<-rownames(data.matrix_Nimblegen2.s2)[i] } else {
					tem<-data.matrix_Nimblegen2.s2[i,j]
					ta_nbl_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				
				data.matrix_Nimblegen2.s3[[tnbl_i]]<<-data.matrix_Nimblegen2.s2
				
				ta_nbl_stat2[[tnbl_i]]<<-ta_nbl_stat

p_enter_stat_sign<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Statistical_Significant"))
setTkProgressBar(pb_ma,0.75,title="DGE...",label="")
				err<-try(DE_N<-topTable(data.matrix_Nimblegen2.f),silent=TRUE)	
				err<-try(DE_NAll[[tnbl_i]]<<-topTable(data.matrix_Nimblegen2.f,number=nrow(data.matrix_Nimblegen2.f)),silent=TRUE)
				ta_nbl_dge=NULL
				ta_nbl_dge<-tclArray()
				for(i in 0:dim(DE_N)[1]){ for(j in 0:dim(DE_N)[2]){ 
					if(i==0){ ta_nbl_dge[[i,j]]<-colnames(DE_N)[j] } else { 
					if(j==0){ ta_nbl_dge[[i,j]]<-rownames(DE_N)[i] } else {
					tem<-DE_N[i,j]
					ta_nbl_dge[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				
				DE_N_2[[tnbl_i]]<<-DE_N
				
				ta_nbl_dge2[[tnbl_i]]<<-ta_nbl_dge

p_enter_dge<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...DGE"))
setTkProgressBar(pb_ma,0.85,title="PCA...",label="")
				pca_N[[tnbl_i]]<<-prcomp(t(data.matrix_Nimblegen2.m))
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(pca_N[[tnbl_i]])},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)			
				} else {
					ma_img2<<-tkrreplot(ma_img,function(...){plot(pca_N[[tnbl_i]])},hscale=1.7,vscale=1.07)
				}

p_enter_pca<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...PCA"))
setTkProgressBar(pb_ma,0.9,title="Clustering...",label="")
				sample.dist_c1<-dist(t(data.matrix_Nimblegen2.m)) 
				sample.dist_N<-as.dist(1-cor(data.matrix_Nimblegen2.m,method="pearson"))
				sample.clust_N[[tnbl_i]]<<-hclust(sample.dist_N,method="complete")
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(sample.clust_N[[tnbl_i]])},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)			
				}else{
					ma_img2<<-tkrreplot(ma_img,function(...){plot(sample.clust_N[[tnbl_i]])},hscale=1.7,vscale=1.07)
				}
p_enter_clust<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Clustering"))
setTkProgressBar(pb_ma,0.95,title="Classification...",label="")
				er_x<-try(use_DE_N<-as.matrix(DE_N),silent=TRUE)
				if(length(grep("Error",er_x))!=0)
				{
					rownames(DE_N)<-as.character(DE_N)
					use_DE_N<-as.matrix(DE_N)
				}
				rnames<-rownames(use_DE_N)
				clas_N[[tnbl_i]]<<-as.matrix(data.matrix_Nimblegen2.m[rnames,])
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){
						heatmap(clas_N[[tnbl_i]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
					},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)			
				}else{
					ma_img2<<-tkrreplot(ma_img,function(...){
						heatmap(clas_N[[tnbl_i]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
					},hscale=1.7,vscale=1.07)
				}
p_enter_class<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Classification"))
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
			}
		}
	}
	display()
	
}

pair2xys<-function(pairFiles,outdir=getwd(),verbose=TRUE){
	if(verbose)message('Output directory:',outdir)
	for(pairFile in pairFiles)
	{
		if(verbose)message('Processing',basename(pairFile))
		header<-readLines(pairFile,n=1)
		pair<-read.delim(pairFile,header=TRUE,sep='\t',stringsAsFactors=FALSE,comment.char='#')
		maxX<-max(pair$X)
		maxY<-max(pair$Y)
		xys<-expand.grid(X=1:maxX,Y=1:maxY)
		xys<-merge(xys,pair[,c('X','Y','PM')],all.x=TRUE)
		xys<-pair[,c('X','Y','PM')]
		names(xys)<-c('X','Y','SIGNAL')
		xys$COUNT<-ifelse(is.na(xys$SIGNAL),NA_integer_,1L)
		xys<-xys[with(xys,order(Y,X)),]
		rownames(xys)<-NULL
		xysFile<-file.path(outdir,gsub('\\.pair$','\\.xys',basename(pairFile)))
		if(verbose)message('Writing',basename(xysFile))
		writeLines(header,con=xysFile)
		suppressWarnings(write.table(xys,file=xysFile,sep='\t',row.names=FALSE,quote=FALSE,append=TRUE))
	}
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.1,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
if(!requireNamespace("BiocManager",quietly=TRUE)){install.packages("BiocManager");library(BiocManager)} else {library(BiocManager)}
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
if(!requireNamespace("oligo",quietly=TRUE)){BiocManager::install("oligo",ask=FALSE,update=FALSE);library(oligo)} else {library(oligo)}
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
if(!requireNamespace("pdInfoBuilder",quietly=TRUE)){BiocManager::install("pdInfoBuilder",ask=FALSE,update=FALSE);library(pdInfoBuilder)} else {library(pdInfoBuilder)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("genefilter",quietly=TRUE)){BiocManager::install("genefilter",ask=FALSE,update=FALSE);library(genefilter)} else {library(genefilter)}
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
if(!requireNamespace("limma",quietly=TRUE)){BiocManager::install("limma",ask=FALSE,update=FALSE);library(limma)} else {library(limma)}
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
if(!requireNamespace("stats",quietly=TRUE)){install.packages("stats",ask=FALSE,update=FALSE);library(stats)} else {library(stats)}
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
if(!requireNamespace("tcltk",quietly=TRUE)){install.packages("tcltk",ask=FALSE,update=FALSE);library(tcltk)} else {library(tcltk)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
nimblg()

graph_gsta_gomf<-function(h,...){

	graph_gsta_goMF_params<-function(h,h2,h3,h4,h5,h6,h7,...){
		ts_name=h;ts_val=h2;gomf<-h3;p_v_1<-h4;p_v_2<-h5;children=h6;r_choice=h7;
pb_ma<-tkProgressBar(title="Graph GSTA GO Molecular Function...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.1,title=NULL,label="")
		p1<-rownames(gomf)[gomf$'p-value'>=p_v_1]
		p2<-rownames(gomf)[gomf$'p-value'<=p_v_2]
		p<-p2[match(p1,p2)]
		GO.vec<-p[!is.na(p)==TRUE]
		g<-GOGraph(GO.vec,GOMFPARENTS)
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
		g<-removeNode("all",g)
		nodes<-buildNodeList(g)
		focusnode<-sapply(nodes,name) %in% GO.vec
		names(focusnode)<-names(nodes)
		nodefill<-ifelse(focusnode,"yellow","white")
		nAttrs<-list()
		nAttrs$fillcolor<-nodefill
		graph_gsta_goMF<-plot(g,nodeAttrs=nAttrs)
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
		terms<-getGOTerm(nodes(g))
		legend<-data.frame(terms)
		g_colrs<-data.frame(nodefill)
		legend_gsta_goMF<-data.frame(g_colrs,legend)
		colnames(legend_gsta_goMF)<-c("Node_Color","MF")
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
		ta_legend_gsta_gomf<-tclArray()
		for(i in 0:dim(legend_gsta_goMF)[1]){ for(j in 0:dim(legend_gsta_goMF)[2]){ 
			if(i==0){ ta_legend_gsta_gomf[[i,j]]<-colnames(legend_gsta_goMF)[j] } else { 
			if(j==0){ ta_legend_gsta_gomf[[i,j]]<-rownames(legend_gsta_goMF)[i] } else {
			tem<-legend_gsta_goMF[i,j]
			ta_legend_gsta_gomf[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
			} }
		} }
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
		if(ts_name=="Affymetrix"){
			graph_gsta_goMF_Affy[[ts_val]]<<-g
			nodefill_gsta_goMF_Affy[[ts_val]]<<-nodefill
			legend_gsta_goMF_Affy[[ts_val]]<<-legend_gsta_goMF
			ta_affy_legend_gsta_gomf[[ts_val]]<<-ta_legend_gsta_gomf
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsta_goMF_Affy[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsta_goMF_Affy[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOMF_Graph"))
			}
			legend_tab(ta_affy_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_Affy[[ts_val]]),ncol(legend_gsta_goMF_Affy[[ts_val]]),"GSTA_GOMF_Graph_Legend")
		}
		if(ts_name=="Agilent-OneColor"){
			graph_gsta_goMF_Ag1[[ts_val]]<<-g
			nodefill_gsta_goMF_Ag1[[ts_val]]<<-nodefill
			legend_gsta_goMF_Ag1[[ts_val]]<<-legend_gsta_goMF
			ta_ag1_legend_gsta_gomf[[ts_val]]<<-ta_legend_gsta_gomf
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsta_goMF_Ag1[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsta_goMF_Ag1[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOMF_Graph"))
			}
			legend_tab(ta_ag1_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_Ag1[[ts_val]]),ncol(legend_gsta_goMF_Ag1[[ts_val]]),"GSTA_GOMF_Graph_Legend")
		}
		if(ts_name=="Agilent-TwoColor"){
			graph_gsta_goMF_Ag2[[ts_val]]<<-g
			nodefill_gsta_goMF_Ag2[[ts_val]]<<-nodefill
			legend_gsta_goMF_Ag2[[ts_val]]<<-legend_gsta_goMF
			ta_ag2_legend_gsta_gomf[[ts_val]]<<-ta_legend_gsta_gomf
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsta_goMF_Ag2[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsta_goMF_Ag2[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOMF_Graph"))
			}
			legend_tab(ta_ag2_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_Ag2[[ts_val]]),ncol(legend_gsta_goMF_Ag2[[ts_val]]),"GSTA_GOMF_Graph_Legend")
		}
		if(ts_name=="Illumina-Beadarray"){
			graph_gsta_goMF_Il_B[[ts_val]]<<-g
			nodefill_gsta_goMF_Il_B[[ts_val]]<<-nodefill
			legend_gsta_goMF_Il_B[[ts_val]]<<-legend_gsta_goMF
			ta_ilb_legend_gsta_gomf[[ts_val]]<<-ta_legend_gsta_gomf
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsta_goMF_Il_B[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsta_goMF_Il_B[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOMF_Graph"))
			}
			legend_tab(ta_ilb_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_Il_B[[ts_val]]),ncol(legend_gsta_goMF_Il_B[[ts_val]]),"GSTA_GOMF_Graph_Legend")
		}
		if(ts_name=="Illumina-Lumi"){
			graph_gsta_goMF_Il_L[[ts_val]]<<-g
			nodefill_gsta_goMF_Il_L[[ts_val]]<<-nodefill
			legend_gsta_goMF_Il_L[[ts_val]]<<-legend_gsta_goMF
			ta_ill_legend_gsta_gomf[[ts_val]]<<-ta_legend_gsta_gomf
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsta_goMF_Il_L[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsta_goMF_Il_L[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOMF_Graph"))
			}
			legend_tab(ta_ill_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_Il_L[[ts_val]]),ncol(legend_gsta_goMF_Il_L[[ts_val]]),"GSTA_GOMF_Graph_Legend")
		}
		if(ts_name=="Nimblegen"){
			graph_gsta_goMF_N[[ts_val]]<<-g
			nodefill_gsta_goMF_N[[ts_val]]<<-nodefill
			legend_gsta_goMF_N[[ts_val]]<<-legend_gsta_goMF
			ta_nbl_legend_gsta_gomf[[ts_val]]<<-ta_legend_gsta_gomf
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsta_goMF_N[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsta_goMF_N[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOMF_Graph"))
			}
			legend_tab(ta_nbl_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_N[[ts_val]]),ncol(legend_gsta_goMF_N[[ts_val]]),"GSTA_GOMF_Graph_Legend")
		}
		if(ts_name=="Series-Matrix"){
			graph_gsta_goMF_S[[ts_val]]<<-g
			nodefill_gsta_goMF_S[[ts_val]]<<-nodefill
			legend_gsta_goMF_S[[ts_val]]<<-legend_gsta_goMF
			ta_smt_legend_gsta_gomf[[ts_val]]<<-ta_legend_gsta_gomf
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsta_goMF_S[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsta_goMF_S[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOMF_Graph"))
			}
			legend_tab(ta_smt_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_S[[ts_val]]),ncol(legend_gsta_goMF_S[[ts_val]]),"GSTA_GOMF_Graph_Legend")
		}
		if(ts_name=="Online-Data"){
			graph_gsta_goMF_O[[ts_val]]<<-g
			nodefill_gsta_goMF_O[[ts_val]]<<-nodefill
			legend_gsta_goMF_O[[ts_val]]<<-legend_gsta_goMF
			ta_onl_legend_gsta_gomf[[ts_val]]<<-ta_legend_gsta_gomf
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsta_goMF_O[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsta_goMF_O[[ts_val]],nodeAttrs=nAttrs)},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOMF_Graph"))
			}
			legend_tab(ta_onl_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_O[[ts_val]]),ncol(legend_gsta_goMF_O[[ts_val]]),"GSTA_GOMF_Graph_Legend")
		}
	}

	r_choice="._."
	children<-as.character(tcl(treeview,"children",""))
	w_analz<-tktoplevel()
	w_analz_frame<-ttkframe(w_analz,padding=c(3,3,50,20),borderwidth=1,relief="groove")
	tkpack(w_analz_frame,expand=TRUE,fill="both",side="left")
	var<-tclVar(tree_prnts[1])
	sapply(tree_prnts,function(i){
		r_but_vals<-ttkradiobutton(w_analz_frame,variable=var,text=i,value=i)
		tkpack(r_but_vals,side="top",anchor="w")
	})
	tkpack(ttklabel(w_analz_frame,text=''))
	tkpack(ttklabel(w_analz_frame,text=''))
	r_but<-ttkbutton(w_analz_frame,text="Ok")
	tkpack(r_but,pady=2)
	tkconfigure(r_but,command=function(){
		r_choice<-tclvalue(var)
		tkwm.withdraw(w_analz)
		tree_slc<-strsplit(r_choice[1],"_")
		ts_name<-tree_slc[[1]][1]
		ts_val<-as.numeric(tree_slc[[1]][2])
		w_imp<-tktoplevel()
		tkwm.title(w_imp,"Select P-values")
		tkwm.resizable(w_imp,0,0)
		frame_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		tkpack(ttklabel(frame_imp,text='Lower limit'),side="left",padx=30)
		tkpack(ttklabel(frame_imp,text='Upper limit'),side="left",padx=30)
		tkpack(frame_imp,expand=TRUE,fill="both",side="top")
		frame2_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		p_list<-c(1,0.5,0.1,0.05,0.01,0.001,0.0001,0.00001,0.0000000001,0)
		p_value1<-tclVar(p_list[5])
		p_comb1<-ttkcombobox(frame2_imp,values=p_list,textvariable=p_value1,state="normal",justify="left",width=10)
		tkpack(p_comb1,side="left",padx=25)
		p_value2<-tclVar(p_list[4])
		p_comb2<-ttkcombobox(frame2_imp,values=p_list,textvariable=p_value2,state="normal",justify="left",width=10)
		tkpack(p_comb2,side="left",padx=12)
		tkpack(frame2_imp,expand=TRUE,fill="both",side="top")
		frame3_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		r_but<-ttkbutton(frame3_imp,text="Ok")
		tkpack(r_but,side="right",padx=12)
		tkpack(frame3_imp,expand=TRUE,fill="both",side="top")
		tkconfigure(r_but,command=function(){
			tkwm.withdraw(w_imp)
			p_v_1<-as.numeric(tclvalue(p_value1))
			p_v_2<-as.numeric(tclvalue(p_value2))
			if(ts_name=="Affymetrix"){
				graph_gsta_goMF_params(ts_name,ts_val,GOtable.outMF_Affy[[ts_val]],p_v_1,p_v_2,children,r_choice)
			}
			if(ts_name=="Agilent-OneColor"){
				graph_gsta_goMF_params(ts_name,ts_val,GOtable.outMF_Ag1[[ts_val]],p_v_1,p_v_2,children,r_choice)
			}
			if(ts_name=="Agilent-TwoColor"){
				graph_gsta_goMF_params(ts_name,ts_val,GOtable.outMF_Ag2[[ts_val]],p_v_1,p_v_2,children,r_choice)
			}
			if(ts_name=="Illumina-Beadarray"){
				graph_gsta_goMF_params(ts_name,ts_val,GOtable.outMF_Il_B[[ts_val]],p_v_1,p_v_2,children,r_choice)
			}
			if(ts_name=="Illumina-Lumi"){
				graph_gsta_goMF_params(ts_name,ts_val,GOtable.outMF_Il_L[[ts_val]],p_v_1,p_v_2,children,r_choice)
			}
			if(ts_name=="Nimblegen"){
				graph_gsta_goMF_params(ts_name,ts_val,GOtable.outMF_N[[ts_val]],p_v_1,p_v_2,children,r_choice)
			}
			if(ts_name=="Series-Matrix"){
				graph_gsta_goMF_params(ts_name,ts_val,GOtable.outMF_S[[ts_val]],p_v_1,p_v_2,children,r_choice)
			}
			if(ts_name=="Online-Data"){
				graph_gsta_goMF_params(ts_name,ts_val,GOtable.outMF_O[[ts_val]],p_v_1,p_v_2,children,r_choice)
			}
		})
	})
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.1,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
if(!requireNamespace("BiocManager",quietly=TRUE)){install.packages("BiocManager");library(BiocManager)} else {library(BiocManager)}
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
if(!requireNamespace("annotate",quietly=TRUE)){BiocManager::install("annotate",ask=FALSE,update=FALSE);library(annotate)} else {library(annotate)}
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
if(!requireNamespace("GO.db",quietly=TRUE)){BiocManager::install("GO.db",ask=FALSE,update=FALSE);library(GO.db)} else {library(GO.db)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("GOstats",quietly=TRUE)){BiocManager::install("GOstats",ask=FALSE,update=FALSE);library(GOstats)} else {library(GOstats)}
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
if(!requireNamespace("graph",quietly=TRUE)){BiocManager::install("graph",ask=FALSE,update=FALSE);library(graph)} else {library(graph)}
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
if(!requireNamespace("Rgraphviz",quietly=TRUE)){install.packages("Rgraphviz",ask=FALSE,update=FALSE);library(Rgraphviz)} else {library(Rgraphviz)}
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
if(!requireNamespace("tcltk",quietly=TRUE)){install.packages("tcltk",ask=FALSE,update=FALSE);library(tcltk)} else {library(tcltk)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
graph_gsta_gomf()

ma_export<<-function(h,...){
	ma_tab<<-function(h1,...){
		w_imp1<-tktoplevel()
		tkwm.title(w_imp1,'Export table')
		tkwm.resizable(w_imp1,0,0)
		frame1_imp1<-ttkframe(w_imp1,padding=c(3,3,12,12))
		tkpack(ttklabel(frame1_imp1,text='Give a name:'),side='left',padx=12)
		exp_file<-tclVar('')
		c1<-ttkentry(frame1_imp1,textvariable=exp_file,width=25)
		tkpack(c1,side='left',anchor='e')
		tkpack(frame1_imp1,expand=TRUE,fill='both',side='top')
		frame2_imp1<-ttkframe(w_imp1,padding=c(3,3,12,12))
		r_but1<-ttkbutton(frame2_imp1,text='Ok')
		tkpack(r_but1,side='top',anchor='e',pady=5)
		tkpack(frame2_imp1,expand=TRUE,fill='both',side='top')
		tkconfigure(r_but1,command=function(){
			tkwm.withdraw(w_imp1)
			out_name<-paste(tclvalue(exp_file),'txt',sep='.')
			folder<-tclvalue(tkchooseDirectory(title='Destination Folder'))
			setwd(folder)
			write.table(h1,file=out_name,sep='\t',quote=FALSE)
		})
	}
	ma_fig<<-function(h2,h3,h4,...){
		w_imp1<-tktoplevel()
		tkwm.title(w_imp1,'Export figure')
		tkwm.resizable(w_imp1,0,0)
		frame1_imp1<-ttkframe(w_imp1,padding=c(3,3,12,12))
		tkpack(ttklabel(frame1_imp1,text='Give a name:'),side='left',padx=12)
		exp_file<-tclVar('')
		c1<-ttkentry(frame1_imp1,textvariable=exp_file,width=25)
		tkpack(c1,side='left',anchor='e')
		tkpack(frame1_imp1,expand=TRUE,fill='both',side='top')
		frame2_imp1<-ttkframe(w_imp1,padding=c(3,3,12,12))
		r_but1<-ttkbutton(frame2_imp1,text='Ok')
		tkpack(r_but1,side='top',anchor='e',pady=5)
		tkpack(frame2_imp1,expand=TRUE,fill='both',side='top')
		tkconfigure(r_but1,command=function(){
			tkwm.withdraw(w_imp1)
			out_name<-paste(tclvalue(exp_file),'png',sep='.')
			folder<-tclvalue(tkchooseDirectory(title='Destination Folder'))
			setwd(folder)
			if(h3=='QC'){
				png(out_name,width=750,height=750)
				boxplot(h2)
				dev.off()
								
			} else 
			if(h3=='PCA'){
				png(out_name,width=750,height=750)
				plot(h2)
				dev.off()
				
			} else
			if(h3=='Clustered_Data'){
				png(out_name,width=750,height=750)
				plot(h2)
				dev.off()
				
			} else
			if(h3=='Classification_Data'){
				png(out_name,width=750,height=750)
				heatmap(h2,Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				dev.off()
				
			} else
			if(h3=='Graph_GSEA_Data_GO_BP'){
				png(out_name,width=750,height=750)
				nAttrs<-list()
				nAttrs$fillcolor<-h4
				plot(h2,nodeAttrs=nAttrs)
				dev.off()
				
			} else 
			if(h3=='Graph_GSEA_Data_GO_MF'){
				png(out_name,width=750,height=750)
				nAttrs<-list()
				nAttrs$fillcolor<-h4
				plot(h2,nodeAttrs=nAttrs)
				dev.off()
				
			} else 
			if(h3=='Graph_GSEA_Data_GO_CC'){
				png(out_name,width=750,height=750)
				nAttrs<-list()
				nAttrs$fillcolor<-h4
				plot(h2,nodeAttrs=nAttrs)
				dev.off()
				
			} else 
			if(h3=='Graph_GSEA_Data_KEGG_Pathways'){
				png(out_name,width=750,height=750)
				nA<-makeNodeAttrs(h2,fillcolor=h4,width=10,height=1.2)
				oldpar<-par(no.readonly=TRUE)
				on.exit(par(oldpar))
				par(mar=c(3,5,0,5),mgp=c(0,0,0))
				layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
				plot(h2,'dot',nodeAttrs=nA)
				ar<-18
				cols<-colorRampPalette(c('Green', 'Red'))(ar)
				image(as.matrix(seq(1,ar)),col=cols,yaxt='n',xaxt='n')
				mtext('down-regulation',side=1,at=0,line=1)
				mtext('up-regulation',side=1,at=1,line=1)
				dev.off()
				
			} else 
			if(h3=='Graph_GSTA_Data_GO_BP'){
				png(out_name,width=750,height=750)
				nAttrs<-list()
				nAttrs$fillcolor<-h4
				plot(h2,nodeAttrs=nAttrs)
				dev.off()
				
			} else 
			if(h3=='Graph_GSTA_Data_GO_MF'){
				png(out_name,width=750,height=750)
				nAttrs<-list()
				nAttrs$fillcolor<-h4
				plot(h2,nodeAttrs=nAttrs)
				dev.off()
				
			} else 
			if(h3=='Graph_GSTA_Data_GO_CC'){
				png(out_name,width=750,height=750)
				nAttrs<-list()
				nAttrs$fillcolor<-h4
				plot(h2,nodeAttrs=nAttrs)
				dev.off()
				
			} else 
			if(h3=='Graph_GSTA_Data_KEGG_Pathways'){
				png(out_name,width=750,height=750)
				nA<-makeNodeAttrs(h2,fillcolor=h4,width=10,height=1.2)
				oldpar<-par(no.readonly=TRUE)
				on.exit(par(oldpar))
				par(mar=c(3,5,0,5),mgp=c(0,0,0))
				layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
				plot(h2,'dot',nodeAttrs=nA)
				ar<-18
				cols<-colorRampPalette(c('Green', 'Red'))(ar)
				image(as.matrix(seq(1,ar)),col=cols,yaxt='n',xaxt='n')
				mtext('down-regulation',side=1,at=0,line=1)
				mtext('up-regulation',side=1,at=1,line=1)
				dev.off()
				
			} else 
			if(h3=='Co-expression_Network_Data'){
				png(out_name,width=750,height=750)
				plot(h2,nodeAttrs=makeNodeAttrs(h2,fontsize=18,fillcolor='grey'))
				dev.off()
				
			} else 
			if(h3=='SSE_Data'){
				png(out_name,width=750,height=750)
				ssize.plot(h2,xlim=c(0,20),main=paste('Sample size to detect 2-fold change',sep=''))
				dev.off()
				
			} else {}

		})
	}
	export_data<-h
	r_choice='._.'
	children<-as.character(tcl(treeview,'children',''))
	w_analz<-tktoplevel()
	w_analz_frame<-ttkframe(w_analz,padding=c(3,3,50,20),borderwidth=1,relief='groove')
	tkpack(w_analz_frame,expand=TRUE,fill='both',side='left')
	var<-tclVar(tree_prnts[1])
	sapply(tree_prnts,function(i){
		r_but_vals<-ttkradiobutton(w_analz_frame,variable=var,text=i,value=i)
		tkpack(r_but_vals,side='top',anchor='w')
	})
	tkpack(ttklabel(w_analz_frame,text=''))
	tkpack(ttklabel(w_analz_frame,text=''))
	r_but<-ttkbutton(w_analz_frame,text='Ok')
	tkpack(r_but,pady=2)
	tkconfigure(r_but,command=function(){
		r_choice<-tclvalue(var)
		tkwm.withdraw(w_analz)
		tree_slc<-strsplit(r_choice[1],'_')
		ts_name<-tree_slc[[1]][1]
		ts_val<-as.numeric(tree_slc[[1]][2])
		if(ts_name=='Affymetrix'){
			if(export_data=='Normalized_Data'){
				ma_tab(dat2Affy.m2[[ts_val]])
			} else 
			if(export_data=='QC_Plot'){
				ma_fig(dat2Affy.m2[[ts_val]],'QC','')
			} else 
			if(export_data=='Filtered_Data'){
				ma_tab(dat2Affy.f3[[ts_val]])
			} else 
			if(export_data=='Stat_Sign_Data'){
				ma_tab(dat2Affy.s3[[ts_val]])
			} else 
			if(export_data=='DGE_Data'){
				ma_tab(DE_Affy_2[[ts_val]])
			} else 
			if(export_data=='PCA_Data'){
				ma_fig(pca_Affy[[ts_val]],'PCA','')
			} else 
			if(export_data=='Clustered_Data'){
				ma_fig(sample.clust_Affy[[ts_val]],'Clustered_Data','')
			} else 
			if(export_data=='Classification_Data'){
				ma_fig(clas_Affy[[ts_val]],'Classification_Data','')
			} else 
			if(export_data=='GSEA_Data_GO_BP'){
				ma_tab(GOresultBP_Affy[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_MF'){
				ma_tab(GOresultMF_Affy[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_CC'){
				ma_tab(GOresultCC_Affy[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_KEGG_Pathways'){
				ma_tab(KEGGresult_Affy[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_BP'){
				ma_tab(GOtable.outBP_Affy[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_MF'){
				ma_tab(GOtable.outMF_Affy[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_CC'){
				ma_tab(GOtable.outCC_Affy[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_KEGG_Pathways'){
				ma_tab(KEGGtable.out_Affy[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_BP'){
				ma_fig(graph_gsea_goBP_Affy[[ts_val]],'Graph_GSEA_Data_GO_BP',nodefill_gsea_goBP_Affy[[ts_val]])
				ma_tab(legend_gsea_goBP_Affy[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_MF'){
				ma_fig(graph_gsea_goMF_Affy[[ts_val]],'Graph_GSEA_Data_GO_MF',nodefill_gsea_goMF_Affy[[ts_val]])
				ma_tab(legend_gsea_goMF_Affy[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_CC'){
				ma_fig(graph_gsea_goCC_Affy[[ts_val]],'Graph_GSEA_Data_GO_CC',nodefill_gsea_goCC_Affy[[ts_val]])
				ma_tab(legend_gsea_goCC_Affy[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_KEGG_Pathways'){
				ma_fig(graph_gsea_KEGG_Affy[[ts_val]],'Graph_GSEA_Data_KEGG_Pathways',nodefill_gsea_KEGG_Affy[[ts_val]])
				ma_tab(legend_gsea_KEGG_Affy[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_BP'){
				ma_fig(graph_gsta_goBP_Affy[[ts_val]],'Graph_GSTA_Data_GO_BP',nodefill_gsta_goBP_Affy[[ts_val]])
				ma_tab(legend_gsta_goBP_Affy[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_MF'){
				ma_fig(graph_gsta_goMF_Affy[[ts_val]],'Graph_GSTA_Data_GO_MF',nodefill_gsta_goMF_Affy[[ts_val]])
				ma_tab(legend_gsta_goMF_Affy[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_CC'){
				ma_fig(graph_gsta_goCC_Affy[[ts_val]],'Graph_GSTA_Data_GO_CC',nodefill_gsta_goCC_Affy[[ts_val]])
				ma_tab(legend_gsta_goCC_Affy[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_KEGG_Pathways'){
				ma_fig(graph_gsta_KEGG_Affy[[ts_val]],'Graph_GSTA_Data_KEGG_Pathways',nodefill_gsta_KEGG_Affy[[ts_val]])
				ma_tab(legend_gsta_KEGG_Affy[[ts_val]])
			} else 
			if(export_data=='Gene_Symbol_Data'){
				ma_tab(genes_Affy[[ts_val]])
			} else 
			if(export_data=='Co-expression_Network_Data'){
				ma_fig(myGraph_Affy[[ts_val]],'Co-expression_Network_Data','')
			} else 
			if(export_data=='SSE_Data'){
				ma_fig(ssize_Affy[[ts_val]],'SSE_Data','')
			} else {}
		}		
		if(ts_name=='Agilent-OneColor'){
			if(export_data=='Normalized_Data'){
				ma_tab(datAgOne2.m2[[ts_val]])
			} else 
			if(export_data=='QC_Plot'){
				ma_fig(datAgOne2.m2[[ts_val]],'QC','')
			} else 
			if(export_data=='Filtered_Data'){
				ma_tab(datAgOne2.f3[[ts_val]])
			} else 
			if(export_data=='Stat_Sign_Data'){
				ma_tab(datAgOne2.s3[[ts_val]])
			} else 
			if(export_data=='DGE_Data'){
				ma_tab(DE_Ag1_2[[ts_val]])
			} else 
			if(export_data=='PCA_Data'){
				ma_fig(pca_Ag1[[ts_val]],'PCA','')
			} else 
			if(export_data=='Clustered_Data'){
				ma_fig(sample.clust_Ag1[[ts_val]],'Clustered_Data','')
			} else 
			if(export_data=='Classification_Data'){
				ma_fig(clas_Ag1[[ts_val]],'Classification_Data','')
			} else 
			if(export_data=='GSEA_Data_GO_BP'){
				ma_tab(GOresultBP_Ag1[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_MF'){
				ma_tab(GOresultMF_Ag1[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_CC'){
				ma_tab(GOresultCC_Ag1[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_KEGG_Pathways'){
				ma_tab(KEGGresult_Ag1[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_BP'){
				ma_tab(GOtable.outBP_Ag1[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_MF'){
				ma_tab(GOtable.outMF_Ag1[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_CC'){
				ma_tab(GOtable.outCC_Ag1[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_KEGG_Pathways'){
				ma_tab(KEGGtable.out_Ag1[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_BP'){
				ma_fig(graph_gsea_goBP_Ag1[[ts_val]],'Graph_GSEA_Data_GO_BP',nodefill_gsea_goBP_Ag1[[ts_val]])
				ma_tab(legend_gsea_goBP_Ag1[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_MF'){
				ma_fig(graph_gsea_goMF_Ag1[[ts_val]],'Graph_GSEA_Data_GO_MF',nodefill_gsea_goMF_Ag1[[ts_val]])
				ma_tab(legend_gsea_goMF_Ag1[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_CC'){
				ma_fig(graph_gsea_goCC_Ag1[[ts_val]],'Graph_GSEA_Data_GO_CC',nodefill_gsea_goCC_Ag1[[ts_val]])
				ma_tab(legend_gsea_goCC_Ag1[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_KEGG_Pathways'){
				ma_fig(graph_gsea_KEGG_Ag1[[ts_val]],'Graph_GSEA_Data_KEGG_Pathways',nodefill_gsea_KEGG_Ag1[[ts_val]])
				ma_tab(legend_gsea_KEGG_Ag1[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_BP'){
				ma_fig(graph_gsta_goBP_Ag1[[ts_val]],'Graph_GSTA_Data_GO_BP',nodefill_gsta_goBP_Ag1[[ts_val]])
				ma_tab(legend_gsta_goBP_Ag1[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_MF'){
				ma_fig(graph_gsta_goMF_Ag1[[ts_val]],'Graph_GSTA_Data_GO_MF',nodefill_gsta_goMF_Ag1[[ts_val]])
				ma_tab(legend_gsta_goMF_Ag1[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_CC'){
				ma_fig(graph_gsta_goCC_Ag1[[ts_val]],'Graph_GSTA_Data_GO_CC',nodefill_gsta_goCC_Ag1[[ts_val]])
				ma_tab(legend_gsta_goCC_Ag1[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_KEGG_Pathways'){
				ma_fig(graph_gsta_KEGG_Ag1[[ts_val]],'Graph_GSTA_Data_KEGG_Pathways',nodefill_gsta_KEGG_Ag1[[ts_val]])
				ma_tab(legend_gsta_KEGG_Ag1[[ts_val]])
			} else 
			if(export_data=='Gene_Symbol_Data'){
				ma_tab(genes_Ag1[[ts_val]])
			} else 
			if(export_data=='Co-expression_Network_Data'){
				ma_fig(myGraph_Ag1[[ts_val]],'Co-expression_Network_Data','')
			} else 
			if(export_data=='SSE_Data'){
				ma_fig(ssize_Ag1[[ts_val]],'SSE_Data','')
			} else {}
		}		
		if(ts_name=='Agilent-TwoColor'){
			if(export_data=='Normalized_Data'){
				ma_tab(datAgTwo2.m2[[ts_val]])
			} else 
			if(export_data=='QC_Plot'){
				ma_fig(datAgTwo2.m2[[ts_val]],'QC','')
			} else 
			if(export_data=='Filtered_Data'){
				ma_tab(datAgTwo2.f3[[ts_val]])
			} else 
			if(export_data=='Stat_Sign_Data'){
				ma_tab(datAgTwo2.s3[[ts_val]])
			} else 
			if(export_data=='DGE_Data'){
				ma_tab(DE_Ag2_2[[ts_val]])
			} else 
			if(export_data=='PCA_Data'){
				ma_fig(pca_Ag2[[ts_val]],'PCA','')
			} else 
			if(export_data=='Clustered_Data'){
				ma_fig(sample.clust_Ag2[[ts_val]],'Clustered_Data','')
			} else 
			if(export_data=='Classification_Data'){
				ma_fig(clas_Ag2[[ts_val]],'Classification_Data','')
			} else 
			if(export_data=='GSEA_Data_GO_BP'){
				ma_tab(GOresultBP_Ag2[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_MF'){
				ma_tab(GOresultMF_Ag2[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_CC'){
				ma_tab(GOresultCC_Ag2[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_KEGG_Pathways'){
				ma_tab(KEGGresult_Ag2[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_BP'){
				ma_tab(GOtable.outBP_Ag2[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_MF'){
				ma_tab(GOtable.outMF_Ag2[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_CC'){
				ma_tab(GOtable.outCC_Ag2[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_KEGG_Pathways'){
				ma_tab(KEGGtable.out_Ag2[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_BP'){
				ma_fig(graph_gsea_goBP_Ag2[[ts_val]],'Graph_GSEA_Data_GO_BP',nodefill_gsea_goBP_Ag2[[ts_val]])
				ma_tab(legend_gsea_goBP_Ag2[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_MF'){
				ma_fig(graph_gsea_goMF_Ag2[[ts_val]],'Graph_GSEA_Data_GO_MF',nodefill_gsea_goMF_Ag2[[ts_val]])
				ma_tab(legend_gsea_goMF_Ag2[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_CC'){
				ma_fig(graph_gsea_goCC_Ag2[[ts_val]],'Graph_GSEA_Data_GO_CC',nodefill_gsea_goCC_Ag2[[ts_val]])
				ma_tab(legend_gsea_goCC_Ag2[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_KEGG_Pathways'){
				ma_fig(graph_gsea_KEGG_Ag2[[ts_val]],'Graph_GSEA_Data_KEGG_Pathways',nodefill_gsea_KEGG_Ag2[[ts_val]])
				ma_tab(legend_gsea_KEGG_Ag2[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_BP'){
				ma_fig(graph_gsta_goBP_Ag2[[ts_val]],'Graph_GSTA_Data_GO_BP',nodefill_gsta_goBP_Ag2[[ts_val]])
				ma_tab(legend_gsta_goBP_Ag2[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_MF'){
				ma_fig(graph_gsta_goMF_Ag2[[ts_val]],'Graph_GSTA_Data_GO_MF',nodefill_gsta_goMF_Ag2[[ts_val]])
				ma_tab(legend_gsta_goMF_Ag2[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_CC'){
				ma_fig(graph_gsta_goCC_Ag2[[ts_val]],'Graph_GSTA_Data_GO_CC',nodefill_gsta_goCC_Ag2[[ts_val]])
				ma_tab(legend_gsta_goCC_Ag2[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_KEGG_Pathways'){
				ma_fig(graph_gsta_KEGG_Ag2[[ts_val]],'Graph_GSTA_Data_KEGG_Pathways',nodefill_gsta_KEGG_Ag2[[ts_val]])
				ma_tab(legend_gsta_KEGG_Ag2[[ts_val]])
			} else 
			if(export_data=='Gene_Symbol_Data'){
				ma_tab(genes_Ag2[[ts_val]])
			} else 
			if(export_data=='Co-expression_Network_Data'){
				ma_fig(myGraph_Ag2[[ts_val]],'Co-expression_Network_Data','')
			} else 
			if(export_data=='SSE_Data'){
				ma_fig(ssize_Ag2[[ts_val]],'SSE_Data','')
			} else {}
		}		
		if(ts_name=='Illumina-Beadarray'){
			if(export_data=='Normalized_Data'){
				ma_tab(datIllBA2.m2[[ts_val]])
			} else 
			if(export_data=='QC_Plot'){
				ma_fig(datIllBA2.m2[[ts_val]],'QC','')
			} else 
			if(export_data=='Filtered_Data'){
				ma_tab(datIllBA2.f3[[ts_val]])
			} else 
			if(export_data=='Stat_Sign_Data'){
				ma_tab(datIllBA2.s3[[ts_val]])
			} else 
			if(export_data=='DGE_Data'){
				ma_tab(DE_Il_B_2[[ts_val]])
			} else 
			if(export_data=='PCA_Data'){
				ma_fig(pca_Il_B[[ts_val]],'PCA','')
			} else 
			if(export_data=='Clustered_Data'){
				ma_fig(sample.clust_Il_B[[ts_val]],'Clustered_Data','')
			} else 
			if(export_data=='Classification_Data'){
				ma_fig(clas_Il_B[[ts_val]],'Classification_Data','')
			} else 
			if(export_data=='GSEA_Data_GO_BP'){
				ma_tab(GOresultBP_Il_B[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_MF'){
				ma_tab(GOresultMF_Il_B[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_CC'){
				ma_tab(GOresultCC_Il_B[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_KEGG_Pathways'){
				ma_tab(KEGGresult_Il_B[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_BP'){
				ma_tab(GOtable.outBP_Il_B[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_MF'){
				ma_tab(GOtable.outMF_Il_B[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_CC'){
				ma_tab(GOtable.outCC_Il_B[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_KEGG_Pathways'){
				ma_tab(KEGGtable.out_Il_B[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_BP'){
				ma_fig(graph_gsea_goBP_Il_B[[ts_val]],'Graph_GSEA_Data_GO_BP',nodefill_gsea_goBP_Il_B[[ts_val]])
				ma_tab(legend_gsea_goBP_Il_B[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_MF'){
				ma_fig(graph_gsea_goMF_Il_B[[ts_val]],'Graph_GSEA_Data_GO_MF',nodefill_gsea_goMF_Il_B[[ts_val]])
				ma_tab(legend_gsea_goMF_Il_B[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_CC'){
				ma_fig(graph_gsea_goCC_Il_B[[ts_val]],'Graph_GSEA_Data_GO_CC',nodefill_gsea_goCC_Il_B[[ts_val]])
				ma_tab(legend_gsea_goCC_Il_B[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_KEGG_Pathways'){
				ma_fig(graph_gsea_KEGG_Il_B[[ts_val]],'Graph_GSEA_Data_KEGG_Pathways',nodefill_gsea_KEGG_Il_B[[ts_val]])
				ma_tab(legend_gsea_KEGG_Il_B[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_BP'){
				ma_fig(graph_gsta_goBP_Il_B[[ts_val]],'Graph_GSTA_Data_GO_BP',nodefill_gsta_goBP_Il_B[[ts_val]])
				ma_tab(legend_gsta_goBP_Il_B[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_MF'){
				ma_fig(graph_gsta_goMF_Il_B[[ts_val]],'Graph_GSTA_Data_GO_MF',nodefill_gsta_goMF_Il_B[[ts_val]])
				ma_tab(legend_gsta_goMF_Il_B[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_CC'){
				ma_fig(graph_gsta_goCC_Il_B[[ts_val]],'Graph_GSTA_Data_GO_CC',nodefill_gsta_goCC_Il_B[[ts_val]])
				ma_tab(legend_gsta_goCC_Il_B[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_KEGG_Pathways'){
				ma_fig(graph_gsta_KEGG_Il_B[[ts_val]],'Graph_GSTA_Data_KEGG_Pathways',nodefill_gsta_KEGG_Il_B[[ts_val]])
				ma_tab(legend_gsta_KEGG_Il_B[[ts_val]])
			} else 
			if(export_data=='Gene_Symbol_Data'){
				ma_tab(genes_Il_B[[ts_val]])
			} else 
			if(export_data=='Co-expression_Network_Data'){
				ma_fig(myGraph_Il_B[[ts_val]],'Co-expression_Network_Data','')
			} else 
			if(export_data=='SSE_Data'){
				ma_fig(ssize_Il_B[[ts_val]],'SSE_Data','')
			} else {}
		}		
		if(ts_name=='Illumina-Lumi'){
			if(export_data=='Normalized_Data'){
				ma_tab(lumi_NQ.m2[[ts_val]])
			} else 
			if(export_data=='QC_Plot'){
				ma_fig(lumi_NQ.m2[[ts_val]],'QC','')
			} else 
			if(export_data=='Filtered_Data'){
				ma_tab(lumi_NQ.f3[[ts_val]])
			} else 
			if(export_data=='Stat_Sign_Data'){
				ma_tab(lumi_NQ.s3[[ts_val]])
			} else 
			if(export_data=='DGE_Data'){
				ma_tab(DE_Il_L_2[[ts_val]])
			} else 
			if(export_data=='PCA_Data'){
				ma_fig(pca_Il_L[[ts_val]],'PCA','')
			} else 
			if(export_data=='Clustered_Data'){
				ma_fig(sample.clust_Il_L[[ts_val]],'Clustered_Data','')
			} else 
			if(export_data=='Classification_Data'){
				ma_fig(clas_Il_L[[ts_val]],'Classification_Data','')
			} else 
			if(export_data=='GSEA_Data_GO_BP'){
				ma_tab(GOresultBP_Il_L[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_MF'){
				ma_tab(GOresultMF_Il_L[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_CC'){
				ma_tab(GOresultCC_Il_L[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_KEGG_Pathways'){
				ma_tab(KEGGresult_Il_L[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_BP'){
				ma_tab(GOtable.outBP_Il_L[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_MF'){
				ma_tab(GOtable.outMF_Il_L[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_CC'){
				ma_tab(GOtable.outCC_Il_L[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_KEGG_Pathways'){
				ma_tab(KEGGtable.out_Il_L[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_BP'){
				ma_fig(graph_gsea_goBP_Il_L[[ts_val]],'Graph_GSEA_Data_GO_BP',nodefill_gsea_goBP_Il_L[[ts_val]])
				ma_tab(legend_gsea_goBP_Il_L[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_MF'){
				ma_fig(graph_gsea_goMF_Il_L[[ts_val]],'Graph_GSEA_Data_GO_MF',nodefill_gsea_goMF_Il_L[[ts_val]])
				ma_tab(legend_gsea_goMF_Il_L[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_CC'){
				ma_fig(graph_gsea_goCC_Il_L[[ts_val]],'Graph_GSEA_Data_GO_CC',nodefill_gsea_goCC_Il_L[[ts_val]])
				ma_tab(legend_gsea_goCC_Il_L[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_KEGG_Pathways'){
				ma_fig(graph_gsea_KEGG_Il_L[[ts_val]],'Graph_GSEA_Data_KEGG_Pathways',nodefill_gsea_KEGG_Il_L[[ts_val]])
				ma_tab(legend_gsea_KEGG_Il_L[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_BP'){
				ma_fig(graph_gsta_goBP_Il_L[[ts_val]],'Graph_GSTA_Data_GO_BP',nodefill_gsta_goBP_Il_L[[ts_val]])
				ma_tab(legend_gsta_goBP_Il_L[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_MF'){
				ma_fig(graph_gsta_goMF_Il_L[[ts_val]],'Graph_GSTA_Data_GO_MF',nodefill_gsta_goMF_Il_L[[ts_val]])
				ma_tab(legend_gsta_goMF_Il_L[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_CC'){
				ma_fig(graph_gsta_goCC_Il_L[[ts_val]],'Graph_GSTA_Data_GO_CC',nodefill_gsta_goCC_Il_L[[ts_val]])
				ma_tab(legend_gsta_goCC_Il_L[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_KEGG_Pathways'){
				ma_fig(graph_gsta_KEGG_Il_L[[ts_val]],'Graph_GSTA_Data_KEGG_Pathways',nodefill_gsta_KEGG_Il_L[[ts_val]])
				ma_tab(legend_gsta_KEGG_Il_L[[ts_val]])
			} else 
			if(export_data=='Gene_Symbol_Data'){
				ma_tab(genes_Il_L[[ts_val]])
			} else 
			if(export_data=='Co-expression_Network_Data'){
				ma_fig(myGraph_Il_L[[ts_val]],'Co-expression_Network_Data','')
			} else 
			if(export_data=='SSE_Data'){
				ma_fig(ssize_Il_L[[ts_val]],'SSE_Data','')
			} else {}
		}		
		if(ts_name=='Nimblegen'){
			if(export_data=='Normalized_Data'){
				ma_tab(data.matrix_Nimblegen2.m2[[ts_val]])
			} else 
			if(export_data=='QC_Plot'){
				ma_fig(data.matrix_Nimblegen2.m2[[ts_val]],'QC','')
			} else 
			if(export_data=='Filtered_Data'){
				ma_tab(data.matrix_Nimblegen2.f3[[ts_val]])
			} else 
			if(export_data=='Stat_Sign_Data'){
				ma_tab(data.matrix_Nimblegen2.s3[[ts_val]])
			} else 
			if(export_data=='DGE_Data'){
				ma_tab(DE_N_2[[ts_val]])
			} else 
			if(export_data=='PCA_Data'){
				ma_fig(pca_N[[ts_val]],'PCA','')
			} else 
			if(export_data=='Clustered_Data'){
				ma_fig(sample.clust_N[[ts_val]],'Clustered_Data','')
			} else 
			if(export_data=='Classification_Data'){
				ma_fig(clas_N[[ts_val]],'Classification_Data','')
			} else 
			if(export_data=='GSEA_Data_GO_BP'){
				ma_tab(GOresultBP_N[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_MF'){
				ma_tab(GOresultMF_N[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_CC'){
				ma_tab(GOresultCC_N[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_KEGG_Pathways'){
				ma_tab(KEGGresult_N[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_BP'){
				ma_tab(GOtable.outBP_N[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_MF'){
				ma_tab(GOtable.outMF_N[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_CC'){
				ma_tab(GOtable.outCC_N[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_KEGG_Pathways'){
				ma_tab(KEGGtable.out_N[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_BP'){
				ma_fig(graph_gsea_goBP_N[[ts_val]],'Graph_GSEA_Data_GO_BP',nodefill_gsea_goBP_N[[ts_val]])
				ma_tab(legend_gsea_goBP_N[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_MF'){
				ma_fig(graph_gsea_goMF_N[[ts_val]],'Graph_GSEA_Data_GO_MF',nodefill_gsea_goMF_N[[ts_val]])
				ma_tab(legend_gsea_goMF_N[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_CC'){
				ma_fig(graph_gsea_goCC_N[[ts_val]],'Graph_GSEA_Data_GO_CC',nodefill_gsea_goCC_N[[ts_val]])
				ma_tab(legend_gsea_goCC_N[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_KEGG_Pathways'){
				ma_fig(graph_gsea_KEGG_N[[ts_val]],'Graph_GSEA_Data_KEGG_Pathways',nodefill_gsea_KEGG_N[[ts_val]])
				ma_tab(legend_gsea_KEGG_N[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_BP'){
				ma_fig(graph_gsta_goBP_N[[ts_val]],'Graph_GSTA_Data_GO_BP',nodefill_gsta_goBP_N[[ts_val]])
				ma_tab(legend_gsta_goBP_N[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_MF'){
				ma_fig(graph_gsta_goMF_N[[ts_val]],'Graph_GSTA_Data_GO_MF',nodefill_gsta_goMF_N[[ts_val]])
				ma_tab(legend_gsta_goMF_N[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_CC'){
				ma_fig(graph_gsta_goCC_N[[ts_val]],'Graph_GSTA_Data_GO_CC',nodefill_gsta_goCC_N[[ts_val]])
				ma_tab(legend_gsta_goCC_N[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_KEGG_Pathways'){
				ma_fig(graph_gsta_KEGG_N[[ts_val]],'Graph_GSTA_Data_KEGG_Pathways',nodefill_gsta_KEGG_N[[ts_val]])
				ma_tab(legend_gsta_KEGG_N[[ts_val]])
			} else 
			if(export_data=='Gene_Symbol_Data'){
				ma_tab(genes_N[[ts_val]])
			} else 
			if(export_data=='Co-expression_Network_Data'){
				ma_fig(myGraph_N[[ts_val]],'Co-expression_Network_Data','')
			} else 
			if(export_data=='SSE_Data'){
				ma_fig(ssize_N[[ts_val]],'SSE_Data','')
			} else {}
		}		
		if(ts_name=='Series-Matrix'){
			if(export_data=='Normalized_Data'){
				ma_tab(data.matrixNorm.m2[[ts_val]])
			} else 
			if(export_data=='QC_Plot'){
				ma_fig(data.matrixNorm.m2[[ts_val]],'QC','')
			} else 
			if(export_data=='Filtered_Data'){
				ma_tab(data.matrixNorm.f3[[ts_val]])
			} else 
			if(export_data=='Stat_Sign_Data'){
				ma_tab(data.matrixNorm.s3[[ts_val]])
			} else 
			if(export_data=='DGE_Data'){
				ma_tab(DE_S_2[[ts_val]])
			} else 
			if(export_data=='PCA_Data'){
				ma_fig(pca_S[[ts_val]],'PCA','')
			} else 
			if(export_data=='Clustered_Data'){
				ma_fig(sample.clust_S[[ts_val]],'Clustered_Data','')
			} else 
			if(export_data=='Classification_Data'){
				ma_fig(clas_S[[ts_val]],'Classification_Data','')
			} else 
			if(export_data=='GSEA_Data_GO_BP'){
				ma_tab(GOresultBP_S[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_MF'){
				ma_tab(GOresultMF_S[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_CC'){
				ma_tab(GOresultCC_S[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_KEGG_Pathways'){
				ma_tab(KEGGresult_S[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_BP'){
				ma_tab(GOtable.outBP_S[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_MF'){
				ma_tab(GOtable.outMF_S[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_CC'){
				ma_tab(GOtable.outCC_S[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_KEGG_Pathways'){
				ma_tab(KEGGtable.out_S[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_BP'){
				ma_fig(graph_gsea_goBP_S[[ts_val]],'Graph_GSEA_Data_GO_BP',nodefill_gsea_goBP_S[[ts_val]])
				ma_tab(legend_gsea_goBP_S[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_MF'){
				ma_fig(graph_gsea_goMF_S[[ts_val]],'Graph_GSEA_Data_GO_MF',nodefill_gsea_goMF_S[[ts_val]])
				ma_tab(legend_gsea_goMF_S[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_CC'){
				ma_fig(graph_gsea_goCC_S[[ts_val]],'Graph_GSEA_Data_GO_CC',nodefill_gsea_goCC_S[[ts_val]])
				ma_tab(legend_gsea_goCC_S[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_KEGG_Pathways'){
				ma_fig(graph_gsea_KEGG_S[[ts_val]],'Graph_GSEA_Data_KEGG_Pathways',nodefill_gsea_KEGG_S[[ts_val]])
				ma_tab(legend_gsea_KEGG_S[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_BP'){
				ma_fig(graph_gsta_goBP_S[[ts_val]],'Graph_GSTA_Data_GO_BP',nodefill_gsta_goBP_S[[ts_val]])
				ma_tab(legend_gsta_goBP_S[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_MF'){
				ma_fig(graph_gsta_goMF_S[[ts_val]],'Graph_GSTA_Data_GO_MF',nodefill_gsta_goMF_S[[ts_val]])
				ma_tab(legend_gsta_goMF_S[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_CC'){
				ma_fig(graph_gsta_goCC_S[[ts_val]],'Graph_GSTA_Data_GO_CC',nodefill_gsta_goCC_S[[ts_val]])
				ma_tab(legend_gsta_goCC_S[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_KEGG_Pathways'){
				ma_fig(graph_gsta_KEGG_S[[ts_val]],'Graph_GSTA_Data_KEGG_Pathways',nodefill_gsta_KEGG_S[[ts_val]])
				ma_tab(legend_gsta_KEGG_S[[ts_val]])
			} else 
			if(export_data=='Gene_Symbol_Data'){
				ma_tab(genes_S[[ts_val]])
			} else 
			if(export_data=='Co-expression_Network_Data'){
				ma_fig(myGraph_S[[ts_val]],'Co-expression_Network_Data','')
			} else 
			if(export_data=='SSE_Data'){
				ma_fig(ssize_S[[ts_val]],'SSE_Data','')
			} else {}
		}		
		if(ts_name=='Online-Data'){
			if(export_data=='Normalized_Data'){
				ma_tab(data.matrix_onlineNorm.m2[[ts_val]])
			} else 
			if(export_data=='QC_Plot'){
				ma_fig(data.matrix_onlineNorm.m2[[ts_val]],'QC','')
			} else 
			if(export_data=='Filtered_Data'){
				ma_tab(data.matrix_onlineNorm.f3[[ts_val]])
			} else 
			if(export_data=='Stat_Sign_Data'){
				ma_tab(data.matrix_onlineNorm.s3[[ts_val]])
			} else 
			if(export_data=='DGE_Data'){
				ma_tab(DE_O_2[[ts_val]])
			} else 
			if(export_data=='PCA_Data'){
				ma_fig(pca_O[[ts_val]],'PCA','')
			} else 
			if(export_data=='Clustered_Data'){
				ma_fig(sample.clust_O[[ts_val]],'Clustered_Data','')
			} else 
			if(export_data=='Classification_Data'){
				ma_fig(clas_O[[ts_val]],'Classification_Data','')
			} else 
			if(export_data=='GSEA_Data_GO_BP'){
				ma_tab(GOresultBP_O[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_MF'){
				ma_tab(GOresultMF_O[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_GO_CC'){
				ma_tab(GOresultCC_O[[ts_val]])
			} else 
			if(export_data=='GSEA_Data_KEGG_Pathways'){
				ma_tab(KEGGresult_O[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_BP'){
				ma_tab(GOtable.outBP_O[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_MF'){
				ma_tab(GOtable.outMF_O[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_GO_CC'){
				ma_tab(GOtable.outCC_O[[ts_val]])
			} else 
			if(export_data=='GSTA_Data_KEGG_Pathways'){
				ma_tab(KEGGtable.out_O[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_BP'){
				ma_fig(graph_gsea_goBP_O[[ts_val]],'Graph_GSEA_Data_GO_BP',nodefill_gsea_goBP_O[[ts_val]])
				ma_tab(legend_gsea_goBP_O[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_MF'){
				ma_fig(graph_gsea_goMF_O[[ts_val]],'Graph_GSEA_Data_GO_MF',nodefill_gsea_goMF_O[[ts_val]])
				ma_tab(legend_gsea_goMF_O[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_GO_CC'){
				ma_fig(graph_gsea_goCC_O[[ts_val]],'Graph_GSEA_Data_GO_CC',nodefill_gsea_goCC_O[[ts_val]])
				ma_tab(legend_gsea_goCC_O[[ts_val]])
			} else 
			if(export_data=='Graph_GSEA_Data_KEGG_Pathways'){
				ma_fig(graph_gsea_KEGG_O[[ts_val]],'Graph_GSEA_Data_KEGG_Pathways',nodefill_gsea_KEGG_O[[ts_val]])
				ma_tab(legend_gsea_KEGG_O[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_BP'){
				ma_fig(graph_gsta_goBP_O[[ts_val]],'Graph_GSTA_Data_GO_BP',nodefill_gsta_goBP_O[[ts_val]])
				ma_tab(legend_gsta_goBP_O[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_MF'){
				ma_fig(graph_gsta_goMF_O[[ts_val]],'Graph_GSTA_Data_GO_MF',nodefill_gsta_goMF_O[[ts_val]])
				ma_tab(legend_gsta_goMF_O[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_GO_CC'){
				ma_fig(graph_gsta_goCC_O[[ts_val]],'Graph_GSTA_Data_GO_CC',nodefill_gsta_goCC_O[[ts_val]])
				ma_tab(legend_gsta_goCC_O[[ts_val]])
			} else 
			if(export_data=='Graph_GSTA_Data_KEGG_Pathways'){
				ma_fig(graph_gsta_KEGG_O[[ts_val]],'Graph_GSTA_Data_KEGG_Pathways',nodefill_gsta_KEGG_O[[ts_val]])
				ma_tab(legend_gsta_KEGG_O[[ts_val]])
			} else 
			if(export_data=='Gene_Symbol_Data'){
				ma_tab(genes_O[[ts_val]])
			} else 
			if(export_data=='Co-expression_Network_Data'){
				ma_fig(myGraph_O[[ts_val]],'Co-expression_Network_Data','')
			} else 
			if(export_data=='SSE_Data'){
				ma_fig(ssize_O[[ts_val]],'SSE_Data','')
			} else {}
		}		
	})
}
pb_ma<-tkProgressBar(title='Loading packages...',label='',min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label='')
if(!requireNamespace('gWidgets2tcltk',quietly=TRUE)){install.packages('gWidgets2tcltk');library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.3,title=NULL,label='')
if(!requireNamespace('graph',quietly=TRUE)){install.packages('graph');library(graph)} else {library(graph)}
setTkProgressBar(pb_ma,0.5,title=NULL,label='')
if(!requireNamespace('Rgraphviz',quietly=TRUE)){install.packages('Rgraphviz');library(Rgraphviz)} else {library(Rgraphviz)}
setTkProgressBar(pb_ma,0.8,title=NULL,label='')
if(!requireNamespace('tkrplot',quietly=TRUE)){install.packages('tkrplot');library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,1,title='Done...',label='')				
close(pb_ma)
ma_export()

normlz<-function(h,...){
	r_choice="._."
	treeview<-treeview
	children<-as.character(tcl(treeview,"children",""))
	w_analz<-tktoplevel()
	w_analz_frame<-ttkframe(w_analz,padding=c(3,3,50,20),borderwidth=1,relief="groove")
	tkpack(w_analz_frame,expand=TRUE,fill="both",side="left")
	var<-tclVar(tree_prnts[1])
	sapply(tree_prnts,function(i){
		r_but_vals<-ttkradiobutton(w_analz_frame,variable=var,text=i,value=i)
		tkpack(r_but_vals,side="top",anchor="w")
	})
	tkpack(ttklabel(w_analz_frame,text=''))
	tkpack(ttklabel(w_analz_frame,text=''))
	r_but<-ttkbutton(w_analz_frame,text="Ok")
	tkpack(r_but,pady=2)
	tkconfigure(r_but,command=function(){
		r_choice<-tclvalue(var)
		tkwm.withdraw(w_analz)
		tree_slc<-strsplit(r_choice,"_")
		ts_name<-tree_slc[[1]][1]
		ts_val<-as.numeric(tree_slc[[1]][2])

		if(ts_name=="Affymetrix"){
			try(({foldAffy<-folder_Affy[[ts_val]];}),silent=TRUE)
			setwd(foldAffy)
pb_ma<-tkProgressBar(title="Normalization...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
			dat2Affy<-justRMA()
			dat2Affy.m<-exprs(dat2Affy)
			dat2Affy.m<-as.matrix(dat2Affy.m)
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
			try({
				if(length(rownames(dat2Affy.m))==0){
					rownames(dat2Affy.m)<-1:length(dat2Affy.m[,1])
				} else {
					rownames(dat2Affy.m)<-as.character(rownames(dat2Affy.m))
				}
			},silent=TRUE)
			ta_affy_norm=NULL
			ta_affy_norm<-tclArray()
			for(i in 0:dim(dat2Affy.m)[1]){ for(j in 0:dim(dat2Affy.m)[2]){ 
				if(i==0){ ta_affy_norm[[i,j]]<-colnames(dat2Affy.m)[j] } else { 
				if(j==0){ ta_affy_norm[[i,j]]<-rownames(dat2Affy.m)[i] } else {
					tem<-dat2Affy.m[i,j]
					ta_affy_norm[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			dat2Affy.m2[[ts_val]]<<-dat2Affy.m
			ta_affy_norm2[[ts_val]]<<-ta_affy_norm
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Normalization"))
			}			
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
				
		}
		if(ts_name=="Agilent-OneColor"){
			w_imp<-tktoplevel()
			tkwm.title(w_imp,"Methods")
			tkwm.resizable(w_imp,0,0)
			frame1_imp<-ttkframe(w_imp,padding=c(3,3,50,20),borderwidth=1,relief="groove")
			tkpack(frame1_imp,expand=TRUE,fill="both",side="left")
			r1_imp<-c("none","scale","quantile","cyclicloess")
			var1<-tclVar(r1_imp[1])
			sapply(r1_imp,function(i){
				r1_imp_vals<-ttkradiobutton(frame1_imp,variable=var1,text=i,value=i)
				tkpack(r1_imp_vals,side="top",anchor="w")
			})
			tkpack(ttklabel(frame1_imp,text=''))
			tkpack(ttklabel(frame1_imp,text=''))
			r_but<-ttkbutton(frame1_imp,text="Ok")
			tkpack(r_but,pady=3)
			tkconfigure(r_but,command=function(){
				tkwm.withdraw(w_imp)
				try(({foldAg1<-folder_Ag1[[ts_val]];datAgOne<-l_datAgOne[[ts_val]]; }),silent=TRUE)
				setwd(foldAg1)	
pb_ma<-tkProgressBar(title="Normalization...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
				try(datAgOne2<-backgroundCorrect(datAgOne,"normexp"),silent=TRUE)
				if(length(datAgOne2)==0)datAgOne2<-datAgOne
				datAgOne2<-normalizeBetweenArrays(datAgOne2$R,method=tclvalue(var1))
				datAgOne2<-log(datAgOne2)
				datAgOne2.m<-datAgOne2
				datAgOne2.m<-as.matrix(datAgOne2.m)
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
				try({
					if(length(rownames(datAgOne2.m))==0){
						rownames(datAgOne2.m)<-1:length(datAgOne2.m[,1])
					} else {
						rownames(datAgOne2.m)<-as.character(rownames(datAgOne2.m))
					}
				},silent=TRUE)
				ta_ag1_norm<-tclArray()
				for(i in 0:dim(datAgOne2.m)[1]){ for(j in 0:dim(datAgOne2.m)[2]){ 
					if(i==0){ ta_ag1_norm[[i,j]]<-colnames(datAgOne2.m)[j] } else { 
					if(j==0){ ta_ag1_norm[[i,j]]<-rownames(datAgOne2.m)[i] } else {
						tem<-datAgOne2.m[i,j]
						ta_ag1_norm[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }		
				datAgOne2.m2[[ts_val]]<<-datAgOne2.m
				ta_ag1_norm2[[ts_val]]<<-ta_ag1_norm
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Normalization"))
				}
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			
			})
		}
		if(ts_name=="Agilent-TwoColor"){
			w_imp<-tktoplevel()
			tkwm.title(w_imp,"Methods")
			tkwm.resizable(w_imp,0,0)
			frame1_imp<-ttkframe(w_imp,padding=c(3,3,50,20),borderwidth=1,relief="groove")
			tkpack(frame1_imp,expand=TRUE,fill="both",side="left")
			r1_imp<-c("none","scale","quantile","Aquantile","Gquantile","Rquantile","Tquantile","cyclicloess")
			var1<-tclVar(r1_imp[1])
			sapply(r1_imp,function(i){
				r1_imp_vals<-ttkradiobutton(frame1_imp,variable=var1,text=i,value=i)
				tkpack(r1_imp_vals,side="top",anchor="w")
			})
			tkpack(ttklabel(frame1_imp,text=''))
			tkpack(ttklabel(frame1_imp,text=''))
			r_but<-ttkbutton(frame1_imp,text="Ok")
			tkpack(r_but,pady=3)
			tkconfigure(r_but,command=function(){
				tkwm.withdraw(w_imp)
				try(({foldAg2<-folder_Ag2[[ts_val]];datAgTwo<-l_datAgTwo[[ts_val]]; }),silent=TRUE)
				setwd(foldAg2)
pb_ma<-tkProgressBar(title="Normalization...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
				try(datAgTwo2<-backgroundCorrect(datAgTwo,"normexp"),silent=TRUE)
				if(length(datAgTwo2)==0)datAgTwo2<-datAgTwo
				datAgTwo2<-normalizeBetweenArrays(datAgTwo2$R,method=tclvalue(var1))
				datAgTwo2<-log(datAgTwo2)
				datAgTwo2.m<-datAgTwo2
				datAgTwo2.m<-as.matrix(datAgTwo2.m)
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
				try({
					if(length(rownames(datAgTwo2.m))==0){
						rownames(datAgTwo2.m)<-1:length(datAgTwo2.m[,1])
					} else {
						rownames(datAgTwo2.m)<-as.character(rownames(datAgTwo2.m))
					}
				},silent=TRUE)
				ta_ag2_norm=NULL
				ta_ag2_norm<-tclArray()
				for(i in 0:dim(datAgTwo2.m)[1]){ for(j in 0:dim(datAgTwo2.m)[2]){ 
					if(i==0){ ta_ag2_norm[[i,j]]<-colnames(datAgTwo2.m)[j] } else { 
					if(j==0){ ta_ag2_norm[[i,j]]<-rownames(datAgTwo2.m)[i] } else {
					tem<-datAgTwo2.m[i,j]
					ta_ag2_norm[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				datAgTwo2.m2[[ts_val]]<<-datAgTwo2.m				
				ta_ag2_norm2[[ts_val]]<<-ta_ag2_norm
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Normalization"))
				}
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			
			})
		}
		if(ts_name=="Illumina-Beadarray"){
			if (!requireNamespace("beadarray", quietly = TRUE)){
				install.packages("beadarray")
			} else {
				library(beadarray)
			}
			w_imp<-tktoplevel()
			tkwm.title(w_imp,"Methods")
			tkwm.resizable(w_imp,0,0)
			frame1_imp<-ttkframe(w_imp,padding=c(3,3,50,20),borderwidth=1,relief="groove")
			tkpack(frame1_imp,expand=TRUE,fill="both",side="left")
			r1_imp<-c("quantile","qspline","vsn","rankInvariant","median","none","neqc","rsn")
			var1<-tclVar(r1_imp[1])
			sapply(r1_imp,function(i){
				r1_imp_vals<-ttkradiobutton(frame1_imp,variable=var1,text=i,value=i)
				tkpack(r1_imp_vals,side="top",anchor="w")
			})
			tkpack(ttklabel(frame1_imp,text=''))
			tkpack(ttklabel(frame1_imp,text=''))
			r_but<-ttkbutton(frame1_imp,text="Ok")
			tkpack(r_but,pady=3)
			tkconfigure(r_but,command=function(){
				tkwm.withdraw(w_imp)
				try(({foldIl_B<-folder_Il_B[[ts_val]];datIllBA<-l_datIllBA[[ts_val]];}),silent=TRUE)
				setwd(foldIl_B)
pb_ma<-tkProgressBar(title="Normalization...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
				datIllBA2<-normaliseIllumina(datIllBA,method=tclvalue(var1))
				datIllBA2.m<-exprs(datIllBA2)
				datIllBA2.m1<-log2(datIllBA2.m)
				datIllBA2.m1<-as.matrix(datIllBA2.m1)
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
				try({
					if(length(rownames(datIllBA2.m1))==0){
						rownames(datIllBA2.m1)<-1:length(datIllBA2.m1[,1])
					} else {
						rownames(datIllBA2.m1)<-as.character(rownames(datIllBA2.m1))
					}
				},silent=TRUE)
				ta_ilb_norm<-tclArray()
				for(i in 0:dim(datIllBA2.m1)[1]){ for(j in 0:dim(datIllBA2.m1)[2]){ 
					if(i==0){ ta_ilb_norm[[i,j]]<-colnames(datIllBA2.m1)[j] } else { 
					if(j==0){ ta_ilb_norm[[i,j]]<-rownames(datIllBA2.m1)[i] } else {
					tem<-datIllBA2.m1[i,j]
					ta_ilb_norm[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				datIllBA2.m2[[ts_val]]<<-datIllBA2.m1				
				ta_ilb_norm2[[ts_val]]<<-ta_ilb_norm
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Normalization"))
				}
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			
			})
		}
		if(ts_name=="Illumina-Lumi"){
			if (!requireNamespace("lumi", quietly = TRUE)){install.packages("lumi")} else {	library(lumi) }
			try(({foldIl_L<-folder_Il_L[[ts_val]];lumi_data<-l_lumi_data[[ts_val]];}),silent=TRUE)
			setwd(foldIl_L)	
pb_ma<-tkProgressBar(title="Normalization...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
			lumi_NQ<-lumiExpresso(lumi_data,QC.evaluation=TRUE)
			summary(lumi_NQ,'QC')
			lumi_NQ.m<-lumiExpresso(lumi_data,QC.evaluation=TRUE)
			lumi_NQ.m<-as.matrix(lumi_NQ.m)
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
				try({
					if(length(rownames(lumi_NQ.m))==0){
						rownames(lumi_NQ.m)<-1:length(lumi_NQ.m[,1])
					} else {
						rownames(lumi_NQ.m)<-as.character(rownames(lumi_NQ.m))
					}
				},silent=TRUE)
			ta_ill_norm<-tclArray()
			for(i in 0:dim(lumi_NQ.m)[1]){ for(j in 0:dim(lumi_NQ.m)[2]){ 
				if(i==0){ ta_ill_norm[[i,j]]<-colnames(lumi_NQ.m)[j] } else { 
				if(j==0){ ta_ill_norm[[i,j]]<-rownames(lumi_NQ.m)[i] } else {
				tem<-lumi_NQ.m[i,j]
				ta_ill_norm[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			lumi_NQ.m2[[ts_val]]<<-lumi_NQ.m
			ta_ill_norm2[[ts_val]]<<-ta_ill_norm
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Normalization"))
			}
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
				
		}
		if(ts_name=="Nimblegen"){
			w_imp<-tktoplevel()
			tkwm.title(w_imp,"Methods")
			tkwm.resizable(w_imp,0,0)
			frame1_imp<-ttkframe(w_imp,padding=c(3,3,50,20),borderwidth=1,relief="groove")
			tkpack(frame1_imp,expand=TRUE,fill="both",side="left")
			r1_imp<-c("none","scale","quantile","cyclicloess")
			var1<-tclVar(r1_imp[1])
			sapply(r1_imp,function(i){
				r1_imp_vals<-ttkradiobutton(frame1_imp,variable=var1,text=i,value=i)
				tkpack(r1_imp_vals,side="top",anchor="w")
			})
			tkpack(ttklabel(frame1_imp,text=''))
			tkpack(ttklabel(frame1_imp,text=''))
			r_but<-ttkbutton(frame1_imp,text="Ok")
			tkpack(r_but,pady=3)
			tkconfigure(r_but,command=function(){
				tkwm.withdraw(w_imp)
				try(({foldN<-folder_N[[ts_val]];data.matrix_Nimblegen<-l_data.matrix_Nimblegen[[ts_val]]; }),silent=TRUE)
				setwd(foldN)	
pb_ma<-tkProgressBar(title="Normalization...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
				data.matrix_Nimblegen2<-normalizeBetweenArrays(data.matrix_Nimblegen,tclvalue(var1))
				data.matrix_Nimblegen2.m<-normalizeBetweenArrays(data.matrix_Nimblegen2,method=tclvalue(var1))
				data.matrix_Nimblegen2.m<-as.matrix(data.matrix_Nimblegen2.m)
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
				try({
					if(length(rownames(data.matrix_Nimblegen2.m))==0){
						rownames(data.matrix_Nimblegen2.m)<-1:length(data.matrix_Nimblegen2.m[,1])
					} else {
						rownames(data.matrix_Nimblegen2.m)<-as.character(rownames(data.matrix_Nimblegen2.m))
					}
				},silent=TRUE)
				ta_nbl_norm<-tclArray()
				for(i in 0:dim(data.matrix_Nimblegen2.m)[1]){ for(j in 0:dim(data.matrix_Nimblegen2.m)[2]){ 
					if(i==0){ ta_nbl_norm[[i,j]]<-colnames(data.matrix_Nimblegen2.m)[j] } else { 
					if(j==0){ ta_nbl_norm[[i,j]]<-rownames(data.matrix_Nimblegen2.m)[i] } else {
					tem<-data.matrix_Nimblegen2.m[i,j]
					ta_nbl_norm[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				data.matrix_Nimblegen2.m2[[ts_val]]<<-data.matrix_Nimblegen2.m
				ta_nbl_norm2[[ts_val]]<<-ta_nbl_norm
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Normalization"))
				}
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			
			})
		}
		if(ts_name=="Series-Matrix"){
			w_imp<-tktoplevel()
			tkwm.title(w_imp,"Methods")
			tkwm.resizable(w_imp,0,0)
			frame1_imp<-ttkframe(w_imp,padding=c(3,3,50,20),borderwidth=1,relief="groove")
			tkpack(frame1_imp,expand=TRUE,fill="both",side="left")
			r1_imp<-c("none","scale","quantile","cyclicloess")
			var1<-tclVar(r1_imp[1])
			sapply(r1_imp,function(i){
				r1_imp_vals<-ttkradiobutton(frame1_imp,variable=var1,text=i,value=i)
				tkpack(r1_imp_vals,side="top",anchor="w")
			})
			tkpack(ttklabel(frame1_imp,text=''))
			tkpack(ttklabel(frame1_imp,text=''))
			r_but<-ttkbutton(frame1_imp,text="Ok")
			tkpack(r_but,pady=3)
			tkconfigure(r_but,command=function(){
				tkwm.withdraw(w_imp)
				try(({foldS<-folder_S[[ts_val]];data.matrixImp<-l_data.matrixImp[[ts_val]];}),silent=TRUE)
				setwd(foldS)	
pb_ma<-tkProgressBar(title="Normalization...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
				data.matrixNorm<-normalizeBetweenArrays(data.matrixImp,method=tclvalue(var1))
				tmp<-aggregate(data.matrixNorm,list(rownames(data.matrixNorm)),median)
				rownames(tmp)<-tmp[,1]
				data.matrixNorm.m<<-as.matrix(tmp[,-1])
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
				try({
					if(length(rownames(data.matrixNorm.m))==0){
						rownames(data.matrixNorm.m)<-1:length(data.matrixNorm.m[,1])
					} else {
						rownames(data.matrixNorm.m)<-as.character(rownames(data.matrixNorm.m))
					}
				},silent=TRUE)
				ta_smt_norm<-tclArray()
				for(i in 0:dim(data.matrixNorm.m)[1]){ for(j in 0:dim(data.matrixNorm.m)[2]){ 
					if(i==0){ ta_smt_norm[[i,j]]<-colnames(data.matrixNorm.m)[j] } else { 
					if(j==0){ ta_smt_norm[[i,j]]<-rownames(data.matrixNorm.m)[i] } else {
						tem<-data.matrixNorm.m[i,j]
						ta_smt_norm[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				data.matrixNorm.m2[[ts_val]]<<-data.matrixNorm.m
				
				ta_smt_norm2[[ts_val]]<<-ta_smt_norm
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Normalization"))
				}
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			
			})
		}
		if(ts_name=="Online-Data"){
			w_imp<-tktoplevel()
			tkwm.title(w_imp,"Methods")
			tkwm.resizable(w_imp,0,0)
			frame1_imp<-ttkframe(w_imp,padding=c(3,3,50,20),borderwidth=1,relief="groove")
			tkpack(frame1_imp,expand=TRUE,fill="both",side="left")
			r1_imp<-c("none","scale","quantile","cyclicloess")
			var1<-tclVar(r1_imp[1])
			sapply(r1_imp,function(i){
				r1_imp_vals<-ttkradiobutton(frame1_imp,variable=var1,text=i,value=i)
				tkpack(r1_imp_vals,side="top",anchor="w")
			})
			tkpack(ttklabel(frame1_imp,text=''))
			tkpack(ttklabel(frame1_imp,text=''))
			r_but<-ttkbutton(frame1_imp,text="Ok")
			tkpack(r_but,pady=3)
			tkconfigure(r_but,command=function(){
				tkwm.withdraw(w_imp)
				try(({data.matrix_onlineImp<-data.matrix_onlineImp[[ts_val]];}),silent=TRUE)
				setwd(folder_O[[ts_val]])
pb_ma<-tkProgressBar(title="Normalization...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
				data.matrix_onlineNorm<-normalizeBetweenArrays(data.matrix_onlineImp,method=tclvalue(var1))
				tmp<-aggregate(data.matrix_onlineNorm,list(rownames(data.matrix_onlineNorm)),median)
				data.matrix_onlineNorm.m<<-as.matrix(tmp[,-1])
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
				try({
					if(length(rownames(data.matrix_onlineNorm.m))==0){
						rownames(data.matrix_onlineNorm.m)<-1:length(data.matrix_onlineNorm.m[,1])
					} else {
						rownames(data.matrix_onlineNorm.m)<-as.character(rownames(data.matrix_onlineNorm.m))
					}
				},silent=TRUE)
				ta_onl_norm<-tclArray()
				for(i in 0:dim(data.matrix_onlineNorm.m)[1]){ for(j in 0:dim(data.matrix_onlineNorm.m)[2]){ 
					if(i==0){ ta_onl_norm[[i,j]]<-colnames(data.matrix_onlineNorm.m)[j] } else { 
					if(j==0){ ta_onl_norm[[i,j]]<-rownames(data.matrix_onlineNorm.m)[i] } else {
						tem<-data.matrix_onlineNorm.m[i,j]
						ta_onl_norm[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				data.matrix_onlineNorm.m2[[ts_val]]<<-data.matrix_onlineNorm.m
				ta_onl_norm2[[ts_val]]<<-ta_onl_norm
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Normalization"))
				}
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			
			})
		}
	})
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("BiocManager",quietly=TRUE)){install.packages("BiocManager");library(BiocManager)} else {library(BiocManager)}
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
if(!requireNamespace("affy",quietly=TRUE)){BiocManager::install("affy",ask=FALSE,update=FALSE);library(affy)} else {library(affy)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
normlz()

prep_log<-function(h,...){
	r_choice="._."
	treeview<-treeview
	children<-as.character(tcl(treeview,"children",""))
	w_analz<-tktoplevel()
	w_analz_frame<-ttkframe(w_analz,padding=c(3,3,50,20),borderwidth=1,relief="groove")
	tkpack(w_analz_frame,expand=TRUE,fill="both",side="left")
	tree_prnts_smo=NULL
	for(i in 1:length(tree_prnts)){
		tree_slc<-strsplit(tree_prnts[i],"_")
		if(tree_slc[[1]][1]=="Series-Matrix" || tree_slc[[1]][1]=="Online-Data"){
			tree_prnts_smo<-c(tree_prnts_smo,tree_prnts[i])
		}
	}
	var<-tclVar(tree_prnts_smo[1])
	sapply(tree_prnts_smo,function(i){
		r_but_vals<-ttkradiobutton(w_analz_frame,variable=var,text=i,value=i)
		tkpack(r_but_vals,side="top",anchor="w")
	})
	tkpack(ttklabel(w_analz_frame,text=''))
	tkpack(ttklabel(w_analz_frame,text=''))
	r_but<-ttkbutton(w_analz_frame,text="Ok")
	tkpack(r_but,pady=2)
	tkconfigure(r_but,command=function(){
		r_choice<-tclvalue(var)
		tkwm.withdraw(w_analz)
		tree_slc<-strsplit(r_choice[1],"_")
		ts_name<-tree_slc[[1]][1]
		ts_val<-as.numeric(tree_slc[[1]][2])
	
		if(ts_name=="Series-Matrix"){
pb_ma<-tkProgressBar(title="Log Transformation...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			data.matrix_series<-l_data.matrix_series[[ts_val]]
			Med<-median(data.matrix_series,na.rm=T)
			if(Med>16)
			{
				data.matrixLog<-log2(data.matrix_series)
			} else {
				data.matrixLog<-data.matrix_series
			}
			l_data.matrixLog[[ts_val]]<<-data.matrixLog
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
			
		}
		if(ts_name=="Online-Data"){
pb_ma<-tkProgressBar(title="Log Transformation...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			data.matrix_online<-l_data.matrix_online[[ts_val]]
			Med<-median(data.matrix_online,na.rm=T)
			if(Med>16)
			{
				data.matrix_onlineLog<-log2(data.matrix_online)
			} else {
				data.matrix_onlineLog<-data.matrix_online
			}
			l_data.matrix_onlineLog[[ts_val]]<<-data.matrix_onlineLog
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
				
		}
	})
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
prep_log()

gsta_gocc<-function(h,...){

	gsta_goCC_params<-function(h,h2,h3,h4,h5,h6,h7,...){

		run_params<-function(h,h2,h3,h4,h5,h6,h7,h8,h9,...){
			ts_name=h;ts_val=h2;ann_pk<-h3;db<-h4;stat_sig<-h5;ctls<-h6;tsts<-h7;children=h8;r_choice=h9;
pb_ma<-tkProgressBar(title="GSTA GO Cellular Component...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			test.goCC<-gtGO(groups,t(stat_sig[,samp_gsta]),annotation=db,ontology="CC",sort=TRUE)
			res<-result(test.goCC)	
			names(res)[7]<-"Cov"
			res1<-res[which(res$Cov!=0),]
			res2<-res1
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
			for(i in 1:dim(res1)[1])
			{
				x<-c()
				for(j in 1:length(subsets(test.goCC)[[rownames(res1)[i]]]))
				{
					x<-paste(subsets(test.goCC)[[rownames(res1)[i]]][j],x,sep=",")
				}
				res2$genes[i]<-x
			}
			res2<-res2[,-1]
			if(dim(res2)[1]==0)tkmessageBox(title="Warning",message="No results met the specified criteria",icon="warning",type="ok")
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
			gsta_gocc<-tclArray()
			for(i in 0:dim(res2)[1]){ for(j in 0:dim(res2)[2]){ 
				if(i==0){ gsta_gocc[[i,j]]<-colnames(res2)[j] } else { 
				if(j==0){ gsta_gocc[[i,j]]<-rownames(res2)[i] } else {
				tem<-res2[i,j]
				gsta_gocc[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			if(ts_name=="Affymetrix"){
				GOtable.outCC_Affy[[ts_val]]<<-res2
				ta_affy_gsta_gocc[[ts_val]]<<-gsta_gocc
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOCC"))}
				}
			}
			if(ts_name=="Agilent-OneColor"){
				GOtable.outCC_Ag1[[ts_val]]<<-res2
				ta_ag1_gsta_gocc[[ts_val]]<<-gsta_gocc
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOCC"))}
				}
			}
			if(ts_name=="Agilent-TwoColor"){
				GOtable.outCC_Ag2[[ts_val]]<<-res2
				ta_ag2_gsta_gocc[[ts_val]]<<-gsta_gocc
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOCC"))}
				}
			}
			if(ts_name=="Illumina-Beadarray"){
				GOtable.outCC_Il_B[[ts_val]]<<-res2
				ta_ilb_gsta_gocc[[ts_val]]<<-gsta_gocc
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOCC"))}
				}
			}
			if(ts_name=="Illumina-Lumi"){
				GOtable.outCC_Il_L[[ts_val]]<<-res2
				ta_ill_gsta_gocc[[ts_val]]<<-gsta_gocc
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOCC"))}
				}
			}
			if(ts_name=="Nimblegen"){
				GOtable.outCC_N[[ts_val]]<<-res2
				ta_nbl_gsta_gocc[[ts_val]]<<-gsta_gocc
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOCC"))}
				}
			}
			if(ts_name=="Series-Matrix"){
				GOtable.outCC_S[[ts_val]]<<-res2
				ta_smt_gsta_gocc[[ts_val]]<<-gsta_gocc
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOCC"))}
				}
			}
			if(ts_name=="Online-Data"){
				GOtable.outCC_O[[ts_val]]<<-res2
				ta_onl_gsta_gocc[[ts_val]]<<-gsta_gocc
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSTA_GOCC"))}
				}
			}
		}

		ts_name=h;ts_val=h2;pre_rs=h3;samp_gsta=h4;groups=h5;children=h6;r_choice=h7;
		if(ts_name=="Affymetrix"){
			anAffy<-ann_Affy[[ts_val]]
			if(length(grep("GPL[0-9]",anAffy))==0){
				ann_pk<-anAffy
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anAffy),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_Affy[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				run_params(ts_name,ts_val,anAffy,db,dat2Affy.m2[[ts_val]],samp_gsta,groups,children,r_choice)
			}
		}
		if(ts_name=="Agilent-OneColor"){
			anAg1<-ann_Ag1[[ts_val]]
			if(length(grep("GPL[0-9]",anAg1))==0){
				ann_pk<-anAg1
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anAg1),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_Ag1[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				run_params(ts_name,ts_val,anAg1,db,DE_Ag1_2[[ts_val]],samp_gsta,groups,children,r_choice)
			}
		}
		if(ts_name=="Agilent-TwoColor"){
			anAg2<-ann_Ag2[[ts_val]]
			if(length(grep("GPL[0-9]",anAg2))==0){
				ann_pk<-anAg2
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anAg2),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_Ag2[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				run_params(ts_name,ts_val,anAg2,db,DE_Ag2_2[[ts_val]],samp_gsta,groups,children,r_choice)
			}
		}
		if(ts_name=="Illumina-Beadarray"){
			anIl_B<-ann_Il_B[[ts_val]]
			if(length(grep("GPL[0-9]",anIl_B))==0){
				ann_pk<-anIl_B
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anIl_B),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_Il_B[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				run_params(ts_name,ts_val,anIl_B,db,DE_Il_B_2[[ts_val]],samp_gsta,groups,children,r_choice)
			}
		}
		if(ts_name=="Illumina-Lumi"){
			anIl_L<-ann_Il_L[[ts_val]]
			if(length(grep("GPL[0-9]",anIl_L))==0){
				ann_pk<-anIl_L
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anIl_L),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_Il_L[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				run_params(ts_name,ts_val,anIl_L,db,DE_Il_L_2[[ts_val]],samp_gsta,groups,children,r_choice)
			}
		}
		if(ts_name=="Nimblegen"){
			anNbl<-ann_N[[ts_val]]
			if(length(grep("GPL[0-9]",anNbl))==0){
				ann_pk<-anNbl
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anNbl),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_N[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				run_params(ts_name,ts_val,anNbl,db,DE_N_2[[ts_val]],samp_gsta,groups,children,r_choice)
			}
		}
		if(ts_name=="Series-Matrix"){
			anSmt<-ann_S[[ts_val]]
			if(length(grep("GPL[0-9]",anSmt))==0){
				ann_pk<-anSmt
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anSmt),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_S[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				run_params(ts_name,ts_val,anSmt,db,DE_S_2[[ts_val]],samp_gsta,groups,children,r_choice)
			}
		}
		if(ts_name=="Online-Data"){
			anOnl<-ann_O[[ts_val]]
			if(length(grep("GPL[0-9]",anOnl))==0){
				ann_pk<-anOnl
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anOnl),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_O[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				run_params(ts_name,ts_val,anOnl,db,DE_O_2[[ts_val]],samp_gsta,groups,children,r_choice)
			}
		}

	}

	r_choice="._."
	children<-as.character(tcl(treeview,"children",""))
	w_analz<-tktoplevel()
	w_analz_frame<-ttkframe(w_analz,padding=c(3,3,50,20),borderwidth=1,relief="groove")
	tkpack(w_analz_frame,expand=TRUE,fill="both",side="left")
	var<-tclVar(tree_prnts[1])
	sapply(tree_prnts,function(i){
		r_but_vals<-ttkradiobutton(w_analz_frame,variable=var,text=i,value=i)
		tkpack(r_but_vals,side="top",anchor="w")
	})
	tkpack(ttklabel(w_analz_frame,text=''))
	tkpack(ttklabel(w_analz_frame,text=''))
	r_but<-ttkbutton(w_analz_frame,text="Ok")
	tkpack(r_but,pady=2)
	tkconfigure(r_but,command=function(){
		r_choice<-tclvalue(var)
		tkwm.withdraw(w_analz)
		tree_slc<-strsplit(r_choice[1],"_")
		ts_name<-tree_slc[[1]][1]
		ts_val<-as.numeric(tree_slc[[1]][2])
		w_imp<-tktoplevel()
		tkwm.title(w_imp,"Select Samples")
		tkwm.resizable(w_imp,0,0)
		frame_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		tkpack(ttklabel(frame_imp,text='Control Samples'),side="left",padx=45)
		tkpack(ttklabel(frame_imp,text='Test Samples'),side="right",padx=62)
		tkpack(frame_imp,expand=TRUE,fill="both",side="top")
		frame2_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		controls<-tclVar("")
		tkpack(ttkentry(frame2_imp,textvariable=controls,width=25),side="left",anchor="e")
		tests<-tclVar("")
		tkpack(ttkentry(frame2_imp,textvariable=tests,width=25),side="right",anchor="e")
		tkpack(frame2_imp,expand=TRUE,fill="both",side="top")
		frame3_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		r_but<-ttkbutton(frame3_imp,text="Ok")
		tkpack(r_but,side="right",padx=12)
		tkpack(frame3_imp,expand=TRUE,fill="both",side="top")
		tkconfigure(r_but,command=function(){
			tkwm.withdraw(w_imp)
			ctls<-tclvalue(controls);tsts<-tclvalue(tests);
			xf<-strsplit(ctls,",")
			yf<-strsplit(tsts,",")
			samp_gsta<-c(xf[[1]],yf[[1]])
			groups<-c(rep(0,length(xf[[1]])),rep(1,length(yf[[1]])))
			
			err<-try({
				if(!file.exists("GEOmetadb.sqlite")){
					sqlfile<-getSQLiteFile(destdir=cur_dir,destfile="GEOmetadb.sqlite.gz",type="normal")
				} else {
					sqlfile<-"GEOmetadb.sqlite"
				}
				con<-dbConnect(SQLite(),sqlfile)
				geo_tables<-dbListTables(con)
				rs<-dbGetQuery(con,'select gpl,bioc_package from gpl')
				rs2<-rs[!is.na(rs$bioc_package),]
				rs3<-rs2[!(rs2$bioc_package==""),]
				pre_rs<-rs3
			},silent=TRUE)
			if(length(grep("Error",err))!=0)
			{
				rs<-c("GPL71","GPL198","GPL2112","GPL3979","GPL3738","GPL200","GPL3213","GPL72","GPL1322","GPL199",
				"GPL3154","GPL74","GPL201","GPL96","GPL571","GPL97","GPL14877","GPL570","GPL13667","GPL8300",
				"GPL91","GPL92","GPL93","GPL94","GPL95","GPL887","GPL1708","GPL13497","GPL17897","GPL3921",
				"GPL15396","GPL80","GPL5188","GPL17556","GPL6244","GPL11532","GPL18190","GPL8490","GPL13534","GPL6102",
				"GPL6947","GPL10558","GPL32","GPL81","GPL33","GPL82","GPL34","GPL83","GPL339","GPL6246",
				"GPL340","GPL1261","GPL8321","GPL75","GPL76","GPL3533","GPL341","GPL342","GPL1355","GPL85",
				"GPL86","GPL87","GPL88","GPL1352","GPL1318","GPL2529","GPL90","GPL1319",
				"ag","ath1121501","bovine","canine","canine2","celegans","chicken","drosgenome1","drosophila2","ecoli2",
				"ecoli2","hcg110","hgfocus","hgu133a","hgu133a2","hgu133b","hgu133plus2","hgu133plus2","hgu219","hgu95av2",
				"hgu95av2","hgu95b","hgu95c","hgu95d","hgu95e","hgug4110b","hgug4112a","HsAgilentDesign026652","hthgu133a","hthgu133a",
				"hthgu133b","hu6800","huex10sttranscriptcluster","hugene10sttranscriptcluster","hugene10sttranscriptcluster",
				"hugene11sttranscriptcluster","hugene11sttranscriptcluster","IlluminaHumanMethylation27k","IlluminaHumanMethylation450k","illuminaHumanv2",
				"illuminaHumanv3","illuminaHumanv4","mgu74a","mgu74av2","mgu74b","mgu74bv2","mgu74c","mgu74cv2","moe430a","mogene10sttranscriptcluster",
				"mouse4302","mouse430a2","mouse430a2","mu11ksuba","mu11ksubb","porcine","rae230a","rae230b","rat2302","rgu34a",
				"rgu34b","rgu34c","rnu34","u133x3p","xenopuslaevis","yeast2","ygs98","zebrafish")
				rs2<-matrix(rs,ncol=2)
				colnames(rs2)<-c("gpl","bioc_package")
				pre_rs<-data.frame(rs2)
			}
			gsta_goCC_params(ts_name,ts_val,pre_rs,samp_gsta,groups,children,r_choice)
		})
	})
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.1,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
if(!requireNamespace("BiocManager",quietly=TRUE)){install.packages("BiocManager");library(BiocManager)} else {library(BiocManager)}
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
if(!requireNamespace("annotate",quietly=TRUE)){BiocManager::install("annotate",ask=FALSE,update=FALSE);library(annotate)} else {library(annotate)}
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
if(!requireNamespace("GEOmetadb",quietly=TRUE)){BiocManager::install("GEOmetadb",ask=FALSE,update=FALSE);library(GEOmetadb)} else {library(GEOmetadb)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("globaltest",quietly=TRUE)){BiocManager::install("globaltest",ask=FALSE,update=FALSE);library(globaltest)} else {library(globaltest)}
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
if(!requireNamespace("RSQLite",quietly=TRUE)){install.packages("RSQLite",ask=FALSE,update=FALSE);library(RSQLite)} else {library(RSQLite)}
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
if(!requireNamespace("DBI",quietly=TRUE)){install.packages("DBI",ask=FALSE,update=FALSE);library(DBI)} else {library(DBI)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
gsta_gocc()

illbead<-function(h,...){
	file<-tclvalue(tkgetOpenFile(title="Select the file"))
	tilb_i<<-tilb_i+1
	folder_Il_B[[tilb_i]]<<-dirname(file)
	if(file==""){
		folder_Il_B<-NULL
	} else {
		try(({
pb_ma<-tkProgressBar(title="Pre-processing...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			new_datIllBA=NULL
			setwd(folder_Il_B[[tilb_i]])
			probes<-c("ProbeID","TargetID","ProbeId","TargetId","Probe_ID","Probe_Id","Target_ID","Target_Id","ID_REF","Id_Ref")
			x<-read.table(file,sep="\t",fill=TRUE)
			y<-which(x[,4]!="")
			ToSkip<-y[1]-1
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
			x2<-read.table(file,sep="\t",header=TRUE,skip=ToSkip,fill=TRUE)
			ProbeID=probes[which(probes %in% colnames(x2))]
#			colv1<-grep("X4068838021_H.AVG_Signal",colnames(x2))
#			list(exprs = "AVG_Signal", se.exprs="BEAD_STDERR",nObservations = "Avg_NBEADS", Detection="Detection Pval"),
			new_datIllBA<-readBeadSummaryData(file,sep="\t",skip=ToSkip,ProbeID=ProbeID,columns=list(exprs="AVG_Signal"))
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
			if(length(new_datIllBA)!=0){datIllBA=NULL;datIllBA<-new_datIllBA}
			ann_Il_B[[tilb_i]]<<-annotation(datIllBA)
		}),silent=TRUE)
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
		if(length(new_datIllBA)==0)tkmessageBox(title="Error",message="Could not load this type of data! Try Series_matrix or Online_Data",icon="error",type="ok")
	 }
	if(length(datIllBA)!=0){
		if(length(new_datIllBA)!=0){

		prnt<-paste("Illumina-Beadarray",tilb_i,sep="_")
		tree_prnts<<-c(tree_prnts,prnt)
		l_datIllBA[[tilb_i]]<<-datIllBA
p_enter<-tcl(treeview,"insert","","end",values=as.tclObj(prnt))

			autopa<-tkmessageBox(title="Confirm",message="Do you want to pre-process and analyze automatically!",icon="question",type="okcancel")
			if(tclvalue(autopa)=="ok"){
pb_ma<-tkProgressBar(title="Normalization...",label="",min=0,max=1,initial=0,width=500)
				datIllBA2.m1=NULL;use.datIllBA2.m1=NULL;xf=NULL;datIllBA2.f=NULL;datIllBA2.s=NULL;
				design=NULL;design_Il_B=NULL;ttx=NULL;DE_Il_B=NULL;DE_Il_B_2=NULL;use_DE_Il_B=NULL;
				sample.dist_Il_B=NULL;
#				pca_Il_B=NULL;
#				sample.clust_Il_B=NULL;
#				clas_Il_B=NULL;
				try(({folder_Il_B[[tilb_i]]<-folder_Il_B[[tilb_i]];datIllBA<-datIllBA;heatcol<-heatcol;}),silent=TRUE)
				setwd(folder_Il_B[[tilb_i]])	
setTkProgressBar(pb_ma,0.1,title=NULL,label="")
				datIllBA2<-normaliseIllumina(datIllBA,method="quantile")
				datIllBA2.m<-exprs(datIllBA2)
				datIllBA2.m1<-log2(datIllBA2.m)
				datIllBA2.m1<-as.matrix(datIllBA2.m1)
				try({
					if(length(rownames(datIllBA2.m1))==0){
						rownames(datIllBA2.m1)<-1:length(datIllBA2.m1[,1])
					} else {
						rownames(datIllBA2.m1)<-as.character(rownames(datIllBA2.m1))
					}
				},silent=TRUE)
				ta_ilb_norm=NULL
				ta_ilb_norm<-tclArray()
				for(i in 0:dim(datIllBA2.m1)[1]){ for(j in 0:dim(datIllBA2.m1)[2]){ 
					if(i==0){ ta_ilb_norm[[i,j]]<-colnames(datIllBA2.m1)[j] } else { 
					if(j==0){ ta_ilb_norm[[i,j]]<-rownames(datIllBA2.m1)[i] } else {
					tem<-datIllBA2.m1[i,j]
					ta_ilb_norm[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }

#				datIllBA2.m1[[tilb_i]]<<-datIllBA2.m1[[tilb_i]]
				datIllBA2.m2[[tilb_i]]<<-datIllBA2.m1
				
				ta_ilb_norm2[[tilb_i]]<<-ta_ilb_norm
#				

p_enter_norm<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Normalization"))
setTkProgressBar(pb_ma,0.3,title="QC...",label="")
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){boxplot(datIllBA2.m2[[tilb_i]])},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)
				} else {
					ma_img2<<-tkrreplot(ma_img,function(...){boxplot(datIllBA2.m2[[tilb_i]])},hscale=1.7,vscale=1.07)
				}

p_enter_qc<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...QC"))
setTkProgressBar(pb_ma,0.35,title="Filtering...",label="")
				use.datIllBA2.m1<-datIllBA2.m1
				try(({
					fff<-pOverA(A=1,p=0.05)
					i<-genefilter(use.datIllBA2.m1,fff)
					dat.fo<-use.datIllBA2.m1[i,]
					i<-genefilter(-use.datIllBA2.m1,fff)
					dat.fu<-use.datIllBA2.m1[i,]
					dat.f<-unique(rbind(dat.fo,dat.fu))
					fit<-lmFit(dat.f)
					fit2<-eBayes(fit)
					fit2_Il_B[[tilb_i]]<<-fit2
					datIllBA2.f<-fit2
				}),silent=TRUE)
				if(length(datIllBA2.f)==0)
				{
					try(({
						rsd<-rowSds(use.datIllBA2.m1)
						i<-rsd>=2
						dat.f<-use.datIllBA2.m1[i,]
						fit<-lmFit(dat.f)
						fit2<-eBayes(fit)
						fit2_Il_B[[tilb_i]]<<-fit2
						datIllBA2.f<-fit2
					}),silent=TRUE)
				}
				ps1<-as.data.frame(datIllBA2.f)	
				rownames(ps1)<-rownames(datIllBA2.f)
				datIllBA2.f2=NULL
				datIllBA2.f2<-ps1
				ta_ilb_filt=NULL
				ta_ilb_filt<-tclArray()
				for(i in 0:dim(datIllBA2.f2)[1]){ for(j in 0:dim(datIllBA2.f2)[2]){ 
					if(i==0){ ta_ilb_filt[[i,j]]<-colnames(datIllBA2.f2)[j] } else { 
					if(j==0){ ta_ilb_filt[[i,j]]<-rownames(datIllBA2.f2)[i] } else {
					tem<-datIllBA2.f2[i,j]
					ta_ilb_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				
				datIllBA2.f3[[tilb_i]]<<-datIllBA2.f2
				
				ta_ilb_filt2[[tilb_i]]<<-ta_ilb_filt

p_enter_filter<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Filtering"))
setTkProgressBar(pb_ma,0.55,title="Statistical_Significant...",label="")
				if(length(datIllBA2.f)!=0){
					err<-try({
							ttx<-topTable(datIllBA2.f,number=nrow(use.datIllBA2.m1))
							rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(datIllBA2.m1)==TRUE)]
							datIllBA2.s<-use.datIllBA2.m1[rn,]
						},silent=TRUE)
					if(length(grep("Error",err))!=0)
					{
						ttx<-topTable(datIllBA2.f,number=nrow(use.datIllBA2.m1))
						rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(datIllBA2.m1)==TRUE)])
						datIllBA2.s<-datIllBA2.m1[rownames(ttx)[ttx$P.Value<=0.01],]
					}
				}
				datIllBA2.s2=NULL
				datIllBA2.s2<-datIllBA2.s
				ta_ilb_stat=NULL
				ta_ilb_stat<-tclArray()
				for(i in 0:dim(datIllBA2.s2)[1]){ for(j in 0:dim(datIllBA2.s2)[2]){ 
					if(i==0){ ta_ilb_stat[[i,j]]<-colnames(datIllBA2.s2)[j] } else { 
					if(j==0){ ta_ilb_stat[[i,j]]<-rownames(datIllBA2.s2)[i] } else {
					tem<-datIllBA2.s2[i,j]
					ta_ilb_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				
				datIllBA2.s3[[tilb_i]]<<-datIllBA2.s2
				
				ta_ilb_stat2[[tilb_i]]<<-ta_ilb_stat

p_enter_stat_sign<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Statistical_Significant"))
setTkProgressBar(pb_ma,0.75,title="DGE...",label="")
				err<-try(DE_Il_B<-topTable(datIllBA2.f),silent=TRUE)	
				err<-try(DE_Il_BAll[[tilb_i]]<<-topTable(datIllBA2.f,number=nrow(datIllBA2.f)),silent=TRUE)
				ta_ilb_dge=NULL
				ta_ilb_dge<-tclArray()
				for(i in 0:dim(DE_Il_B)[1]){ for(j in 0:dim(DE_Il_B)[2]){ 
					if(i==0){ ta_ilb_dge[[i,j]]<-colnames(DE_Il_B)[j] } else { 
					if(j==0){ ta_ilb_dge[[i,j]]<-rownames(DE_Il_B)[i] } else {
					tem<-DE_Il_B[i,j]
					ta_ilb_dge[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				
				DE_Il_B_2[[tilb_i]]<<-DE_Il_B
				
				ta_ilb_dge2[[tilb_i]]<<-ta_ilb_dge

p_enter_dge<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...DGE"))
setTkProgressBar(pb_ma,0.85,title="PCA...",label="")
				pca_Il_B[[tilb_i]]<<-prcomp(t(datIllBA2.m1))
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(pca_Il_B[[tilb_i]])},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)			
				} else {
					ma_img2<<-tkrreplot(ma_img,function(...){plot(pca_Il_B[[tilb_i]])},hscale=1.7,vscale=1.07)
				}

p_enter_pca<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...PCA"))
setTkProgressBar(pb_ma,0.9,title="Clustering...",label="")
				sample.dist_c1<-dist(t(datIllBA2.m1)) 
				sample.dist_Il_B<-as.dist(1-cor(datIllBA2.m1,method="pearson"))
				sample.clust_Il_B[[tilb_i]]<<-hclust(sample.dist_Il_B,method="complete")
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(sample.clust_Il_B[[tilb_i]])},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)			
				}else{
					ma_img2<<-tkrreplot(ma_img,function(...){plot(sample.clust_Il_B[[tilb_i]])},hscale=1.7,vscale=1.07)
				}
p_enter_clust<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Clustering"))
setTkProgressBar(pb_ma,0.95,title="Classification...",label="")
				er_x<-try(use_DE_Il_B<-as.matrix(DE_Il_B),silent=TRUE)
				if(length(grep("Error",er_x))!=0)
				{
					rownames(DE_Il_B)<-as.character(DE_Il_B)
					use_DE_Il_B<-as.matrix(DE_Il_B)
				}
				rnames<-rownames(use_DE_Il_B)
				clas_Il_B[[tilb_i]]<<-as.matrix(datIllBA2.m1[rnames,])
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){
						heatmap(clas_Il_B[[tilb_i]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
					},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)			
				}else{
					ma_img2<<-tkrreplot(ma_img,function(...){
						heatmap(clas_Il_B[[tilb_i]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
					},hscale=1.7,vscale=1.07)
				}
p_enter_class<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Classification"))
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
			}
		}
	}
	display()
	
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.1,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
if(!requireNamespace("BiocManager",quietly=TRUE)){install.packages("BiocManager");library(BiocManager)} else {library(BiocManager)}
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
if(!requireNamespace("beadarray",quietly=TRUE)){BiocManager::install("beadarray",ask=FALSE,update=FALSE);library(beadarray)} else {library(beadarray)}
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
if(!requireNamespace("genefilter",quietly=TRUE)){BiocManager::install("genefilter",ask=FALSE,update=FALSE);library(genefilter)} else {library(genefilter)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("limma",quietly=TRUE)){BiocManager::install("limma",ask=FALSE,update=FALSE);library(limma)} else {library(limma)}
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
if(!requireNamespace("stats",quietly=TRUE)){install.packages("stats",ask=FALSE,update=FALSE);library(stats)} else {library(stats)}
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
if(!requireNamespace("tcltk",quietly=TRUE)){install.packages("tcltk",ask=FALSE,update=FALSE);library(tcltk)} else {library(tcltk)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
illbead()

filter_unsp<-function(h,...){
	stdev_filt<-function(h,h2,h3,h4,h5,...){
		ts_name=h;ts_val=h2;children<-h3;r_choice=h4;std<-as.numeric(h5);
		if(ts_name=="Affymetrix"){
			dat2Affy.m<-dat2Affy.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			rsd<-rowSds(dat2Affy.m)
			i<-rsd>=std
			dat.f<-dat2Affy.m[i,]
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_Affy[[ts_val]]<<-fit2
			dat2Affy.f<-fit2
			ps1<-as.data.frame(dat2Affy.f)	
			rownames(ps1)<-rownames(fit2)
			dat2Affy.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_affy_filt<-tclArray()
			for(i in 0:dim(dat2Affy.f2)[1]){ for(j in 0:dim(dat2Affy.f2)[2]){ 
				if(i==0){ ta_affy_filt[[i,j]]<-colnames(dat2Affy.f2)[j] } else { 
				if(j==0){ ta_affy_filt[[i,j]]<-rownames(dat2Affy.f2)[i] } else {
				tem<-dat2Affy.f2[i,j]
				ta_affy_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			dat2Affy.f3[[ts_val]]<<-dat2Affy.f2
			ta_affy_filt2[[ts_val]]<<-ta_affy_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(dat2Affy.f)!=0){
				err<-try({
					ttx<-topTable(dat2Affy.f,number=nrow(dat2Affy.m))
					rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(dat2Affy.m)==TRUE)]
					dat2Affy.s<-dat2Affy.m[rn,]
				},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(dat2Affy.f,number=nrow(dat2Affy.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(dat2Affy.m)==TRUE)])
					dat2Affy.s<-dat2Affy.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			dat2Affy.s2<-dat2Affy.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_affy_stat<-tclArray()
			for(i in 0:dim(dat2Affy.s2)[1]){ for(j in 0:dim(dat2Affy.s2)[2]){ 
				if(i==0){ ta_affy_stat[[i,j]]<-colnames(dat2Affy.s2)[j] } else { 
				if(j==0){ ta_affy_stat[[i,j]]<-rownames(dat2Affy.s2)[i] } else {
				tem<-dat2Affy.s2[i,j]
				ta_affy_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			dat2Affy.s3[[ts_val]]<<-dat2Affy.s2			
			ta_affy_stat2[[ts_val]]<<-ta_affy_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Agilent-OneColor"){
			datAgOne2.m<-datAgOne2.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			rsd<-rowSds(datAgOne2.m)
			i<-rsd>=std
			dat.f<-datAgOne2.m[i,]
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_Ag1[[ts_val]]<<-fit2
			datAgOne2.f<-fit2
			ps1<-as.data.frame(datAgOne2.f)	
			rownames(ps1)<-rownames(fit2)
			datAgOne2.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_ag1_filt<-tclArray()
			for(i in 0:dim(datAgOne2.f2)[1]){ for(j in 0:dim(datAgOne2.f2)[2]){ 
				if(i==0){ ta_ag1_filt[[i,j]]<-colnames(datAgOne2.f2)[j] } else { 
				if(j==0){ ta_ag1_filt[[i,j]]<-rownames(datAgOne2.f2)[i] } else {
				tem<-datAgOne2.f2[i,j]
				ta_ag1_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			datAgOne2.f3[[ts_val]]<<-datAgOne2.f2
			ta_ag1_filt2[[ts_val]]<<-ta_ag1_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(datAgOne2.f)!=0){
				err<-try({
					ttx<-topTable(datAgOne2.f,number=nrow(datAgOne2.m))
					rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(datAgOne2.m)==TRUE)]
					datAgOne2.s<-datAgOne2.m[rn,]
				},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(datAgOne2.f,number=nrow(datAgOne2.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(datAgOne2.m)==TRUE)])
					datAgOne2.s<-datAgOne2.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			datAgOne2.s2<-datAgOne2.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_ag1_stat<-tclArray()
			for(i in 0:dim(datAgOne2.s2)[1]){ for(j in 0:dim(datAgOne2.s2)[2]){ 
				if(i==0){ ta_ag1_stat[[i,j]]<-colnames(datAgOne2.s2)[j] } else { 
				if(j==0){ ta_ag1_stat[[i,j]]<-rownames(datAgOne2.s2)[i] } else {
				tem<-datAgOne2.s2[i,j]
				ta_ag1_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			datAgOne2.s3[[ts_val]]<<-datAgOne2.s2			
			ta_ag1_stat2[[ts_val]]<<-ta_ag1_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Agilent-TwoColor"){
			datAgTwo2.m<-datAgTwo2.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			rsd<-rowSds(datAgTwo2.m)
			i<-rsd>=std
			dat.f<-datAgTwo2.m[i,]
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_Ag2[[ts_val]]<<-fit2
			datAgTwo2.f<-fit2
			ps1<-as.data.frame(datAgTwo2.f)	
			rownames(ps1)<-rownames(fit2)
			datAgTwo2.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_ag2_filt<-tclArray()
			for(i in 0:dim(datAgTwo2.f2)[1]){ for(j in 0:dim(datAgTwo2.f2)[2]){ 
				if(i==0){ ta_ag2_filt[[i,j]]<-colnames(datAgTwo2.f2)[j] } else { 
				if(j==0){ ta_ag2_filt[[i,j]]<-rownames(datAgTwo2.f2)[i] } else {
				tem<-datAgTwo2.f2[i,j]
				ta_ag2_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			datAgTwo2.f3[[ts_val]]<<-datAgTwo2.f2
			ta_ag2_filt2[[ts_val]]<<-ta_ag2_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(datAgTwo2.f)!=0){
				err<-try({
						ttx<-topTable(datAgTwo2.f,number=nrow(datAgTwo2.m))
						rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(datAgTwo2.m)==TRUE)]
						datAgTwo2.s<-datAgTwo2.m[rn,]
					},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(datAgTwo2.f,number=nrow(datAgTwo2.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(datAgTwo2.m)==TRUE)])
					datAgTwo2.s<-datAgTwo2.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			datAgTwo2.s2<-datAgTwo2.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_ag2_stat<-tclArray()
			for(i in 0:dim(datAgTwo2.s2)[1]){ for(j in 0:dim(datAgTwo2.s2)[2]){ 
				if(i==0){ ta_ag2_stat[[i,j]]<-colnames(datAgTwo2.s2)[j] } else { 
				if(j==0){ ta_ag2_stat[[i,j]]<-rownames(datAgTwo2.s2)[i] } else {
				tem<-datAgTwo2.s2[i,j]
				ta_ag2_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			datAgTwo2.s3[[ts_val]]<<-datAgTwo2.s2			
			ta_ag2_stat2[[ts_val]]<<-ta_ag2_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Illumina-Beadarray"){
			datIllBA2.m<-datIllBA2.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			rsd<-rowSds(datIllBA2.m)
			i<-rsd>=std
			dat.f<-datIllBA2.m[i,]
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_Il_B[[ts_val]]<<-fit2
			datIllBA2.f<-fit2
			ps1<-as.data.frame(datIllBA2.f)	
			rownames(ps1)<-rownames(fit2)
			datIllBA2.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_ilb_filt<-tclArray()
			for(i in 0:dim(datIllBA2.f2)[1]){ for(j in 0:dim(datIllBA2.f2)[2]){ 
				if(i==0){ ta_ilb_filt[[i,j]]<-colnames(datIllBA2.f2)[j] } else { 
				if(j==0){ ta_ilb_filt[[i,j]]<-rownames(datIllBA2.f2)[i] } else {
				tem<-datIllBA2.f2[i,j]
				ta_ilb_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			datIllBA2.f3[[ts_val]]<<-datIllBA2.f2
			ta_ilb_filt2[[ts_val]]<<-ta_ilb_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(datIllBA2.f)!=0){
				err<-try({
						ttx<-topTable(datIllBA2.f,number=nrow(datIllBA2.m))
						rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(datIllBA2.m1)==TRUE)]
						datIllBA2.s<-datIllBA2.m[rn,]
					},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(datIllBA2.f,number=nrow(datIllBA2.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(datIllBA2.m1)==TRUE)])
					datIllBA2.s<-datIllBA2.m1[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			datIllBA2.s2<-datIllBA2.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_ilb_stat<-tclArray()
			for(i in 0:dim(datIllBA2.s2)[1]){ for(j in 0:dim(datIllBA2.s2)[2]){ 
				if(i==0){ ta_ilb_stat[[i,j]]<-colnames(datIllBA2.s2)[j] } else { 
				if(j==0){ ta_ilb_stat[[i,j]]<-rownames(datIllBA2.s2)[i] } else {
				tem<-datIllBA2.s2[i,j]
				ta_ilb_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			datIllBA2.s3[[ts_val]]<<-datIllBA2.s2			
			ta_ilb_stat2[[ts_val]]<<-ta_ilb_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Illumina-Lumi"){
			lumi_NQ.m<-lumi_NQ.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			rsd<-rowSds(lumi_NQ.m)
			i<-rsd>=std
			dat.f<-lumi_NQ.m[i,]
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_Il_L[[ts_val]]<<-fit2
			lumi_NQ.f<-fit2
			ps1<-as.data.frame(lumi_NQ.f)	
			rownames(ps1)<-rownames(fit2)
			lumi_NQ.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_ill_filt<-tclArray()
			for(i in 0:dim(lumi_NQ.f2)[1]){ for(j in 0:dim(lumi_NQ.f2)[2]){ 
				if(i==0){ ta_ill_filt[[i,j]]<-colnames(lumi_NQ.f2)[j] } else { 
				if(j==0){ ta_ill_filt[[i,j]]<-rownames(lumi_NQ.f2)[i] } else {
				tem<-lumi_NQ.f2[i,j]
				ta_ill_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			lumi_NQ.f3[[ts_val]]<<-lumi_NQ.f2
			ta_ill_filt2[[ts_val]]<<-ta_ill_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(lumi_NQ.f)!=0){
				err<-try({
						ttx<-topTable(lumi_NQ.f,number=nrow(lumi_NQ.m))
						rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(lumi_NQ.m)==TRUE)]
						lumi_NQ.s<-lumi_NQ.m[rn,]
					},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(lumi_NQ.f,number=nrow(lumi_NQ.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(lumi_NQ.m)==TRUE)])
					lumi_NQ.s<-lumi_NQ.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			lumi_NQ.s2<-lumi_NQ.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_ill_stat<-tclArray()
			for(i in 0:dim(lumi_NQ.s2)[1]){ for(j in 0:dim(lumi_NQ.s2)[2]){ 
				if(i==0){ ta_ill_stat[[i,j]]<-colnames(lumi_NQ.s2)[j] } else { 
				if(j==0){ ta_ill_stat[[i,j]]<-rownames(lumi_NQ.s2)[i] } else {
				tem<-lumi_NQ.s2[i,j]
				ta_ill_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			lumi_NQ.s3[[ts_val]]<<-lumi_NQ.s2			
			ta_ill_stat2[[ts_val]]<<-ta_ill_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Nimblegen"){
			data.matrix_Nimblegen2.m<-data.matrix_Nimblegen2.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			rsd<-rowSds(data.matrix_Nimblegen2.m)
			i<-rsd>=std
			dat.f<-data.matrix_Nimblegen2.m[i,]
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_N[[ts_val]]<<-fit2
			data.matrix_Nimblegen2.f<-fit2
			ps1<-as.data.frame(data.matrix_Nimblegen2.f)	
			rownames(ps1)<-rownames(fit2)
			data.matrix_Nimblegen2.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_nbl_filt<-tclArray()
			for(i in 0:dim(data.matrix_Nimblegen2.f2)[1]){ for(j in 0:dim(data.matrix_Nimblegen2.f2)[2]){ 
				if(i==0){ ta_nbl_filt[[i,j]]<-colnames(data.matrix_Nimblegen2.f2)[j] } else { 
				if(j==0){ ta_nbl_filt[[i,j]]<-rownames(data.matrix_Nimblegen2.f2)[i] } else {
				tem<-data.matrix_Nimblegen2.f2[i,j]
				ta_nbl_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			data.matrix_Nimblegen2.f3[[ts_val]]<<-data.matrix_Nimblegen2.f2
			ta_nbl_filt2[[ts_val]]<<-ta_nbl_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(data.matrix_Nimblegen2.f)!=0){
				err<-try({
						ttx<-topTable(data.matrix_Nimblegen2.f,number=nrow(data.matrix_Nimblegen2.m))
						rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_Nimblegen2.m)==TRUE)]
						data.matrix_Nimblegen2.s<-data.matrix_Nimblegen2.m[rn,]
					},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(data.matrix_Nimblegen2.f,number=nrow(data.matrix_Nimblegen2.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_Nimblegen2.m)==TRUE)])
					data.matrix_Nimblegen2.s<-data.matrix_Nimblegen2.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			data.matrix_Nimblegen2.s2<-data.matrix_Nimblegen2.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_nbl_stat<-tclArray()
			for(i in 0:dim(data.matrix_Nimblegen2.s2)[1]){ for(j in 0:dim(data.matrix_Nimblegen2.s2)[2]){ 
				if(i==0){ ta_nbl_stat[[i,j]]<-colnames(data.matrix_Nimblegen2.s2)[j] } else { 
				if(j==0){ ta_nbl_stat[[i,j]]<-rownames(data.matrix_Nimblegen2.s2)[i] } else {
				tem<-data.matrix_Nimblegen2.s2[i,j]
				ta_nbl_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			data.matrix_Nimblegen2.s3[[ts_val]]<<-data.matrix_Nimblegen2.s2			
			ta_nbl_stat2[[ts_val]]<<-ta_nbl_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Series-Matrix"){
			data.matrixNorm.m<-data.matrixNorm.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
			rsd<-rowSds(data.matrixNorm.m)
			i<-rsd>=std
			dat.f<-data.matrixNorm.m[i,]
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_S[[ts_val]]<<-fit2
			data.matrixNorm.f<-fit2
			ps1<-as.data.frame(data.matrixNorm.f)	
			rownames(ps1)<-rownames(fit2)
			data.matrixNorm.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_smt_filt<-tclArray()
			for(i in 0:dim(data.matrixNorm.f2)[1]){ for(j in 0:dim(data.matrixNorm.f2)[2]){ 
				if(i==0){ ta_smt_filt[[i,j]]<-colnames(data.matrixNorm.f2)[j] } else { 
				if(j==0){ ta_smt_filt[[i,j]]<-rownames(data.matrixNorm.f2)[i] } else {
				tem<-data.matrixNorm.f2[i,j]
				ta_smt_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			data.matrixNorm.f3[[ts_val]]<<-data.matrixNorm.f2
			ta_smt_filt2[[ts_val]]<<-ta_smt_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(data.matrixNorm.f)!=0){
				err<-try({
					ttx<-topTable(data.matrixNorm.f,number=nrow(data.matrixNorm.m))
					rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrixNorm.m)==TRUE)]
					data.matrixNorm.s<-data.matrixNorm.m[rn,]
				},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(data.matrixNorm.f,number=nrow(data.matrixNorm.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrixNorm.m)==TRUE)])
					data.matrixNorm.s<-data.matrixNorm.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			data.matrixNorm.s2<-data.matrixNorm.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_smt_stat<-tclArray()
			for(i in 0:dim(data.matrixNorm.s2)[1]){ for(j in 0:dim(data.matrixNorm.s2)[2]){ 
				if(i==0){ ta_smt_stat[[i,j]]<-colnames(data.matrixNorm.s2)[j] } else { 
				if(j==0){ ta_smt_stat[[i,j]]<-rownames(data.matrixNorm.s2)[i] } else {
				tem<-data.matrixNorm.s2[i,j]
				ta_smt_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			data.matrixNorm.s3[[ts_val]]<<-data.matrixNorm.s2			
			ta_smt_stat2[[ts_val]]<<-ta_smt_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Online-Data"){
			data.matrix_onlineNorm.m<-data.matrix_onlineNorm.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
			rsd<-rowSds(data.matrix_onlineNorm.m)
			i<-rsd>=std
			dat.f<-data.matrix_onlineNorm.m[i,]
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_O[[ts_val]]<<-fit2
			data.matrix_onlineNorm.f<-fit2
			ps1<-as.data.frame(data.matrix_onlineNorm.f)	
			rownames(ps1)<-rownames(fit2)
			data.matrix_onlineNorm.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_onl_filt<-tclArray()
			for(i in 0:dim(data.matrix_onlineNorm.f2)[1]){ for(j in 0:dim(data.matrix_onlineNorm.f2)[2]){ 
				if(i==0){ ta_onl_filt[[i,j]]<-colnames(data.matrix_onlineNorm.f2)[j] } else { 
				if(j==0){ ta_onl_filt[[i,j]]<-rownames(data.matrix_onlineNorm.f2)[i] } else {
				tem<-data.matrix_onlineNorm.f2[i,j]
				ta_onl_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			data.matrix_onlineNorm.f3[[ts_val]]<<-data.matrix_onlineNorm.f2
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			ta_onl_filt2[[ts_val]]<<-ta_onl_filt
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(data.matrix_onlineNorm.f)!=0){
				err<-try({
					ttx<-topTable(data.matrix_onlineNorm.f,number=nrow(data.matrix_onlineNorm.m))
					rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_onlineNorm.m)==TRUE)]
					data.matrix_onlineNorm.s<-data.matrix_onlineNorm.m[rn,]
				},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(data.matrix_onlineNorm.f,number=nrow(data.matrix_onlineNorm.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_onlineNorm.m)==TRUE)])
					data.matrix_onlineNorm.s<-data.matrix_onlineNorm.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			data.matrix_onlineNorm.s2[[ts_val]]<-data.matrix_onlineNorm.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_onl_stat[[ts_val]]<-tclArray()
			for(i in 0:dim(data.matrix_onlineNorm.s2)[1]){ for(j in 0:dim(data.matrix_onlineNorm.s2)[2]){ 
				if(i==0){ ta_onl_stat[[i,j]]<-colnames(data.matrix_onlineNorm.s2)[j] } else { 
				if(j==0){ ta_onl_stat[[i,j]]<-rownames(data.matrix_onlineNorm.s2)[i] } else {
				tem<-data.matrix_onlineNorm.s2[i,j]
				ta_onl_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			data.matrix_onlineNorm.s3[[ts_val]]<<-data.matrix_onlineNorm.s2			
			ta_onl_stat2[[ts_val]]<<-ta_onl_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
	}

	exprs_filt<-function(h,h2,h3,h4,h5,h6,...){
		ts_name=h;ts_val=h2;children<-h3;r_choice=h4;ove<-as.numeric(h5);posp<-as.numeric(h6);
		if(ts_name=="Affymetrix"){
			dat2Affy.m<-dat2Affy.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			fff<-pOverA(A=ove,p=posp)
			i<-genefilter(dat2Affy.m,fff)
			dat.fo<-dat2Affy.m[i,]
			i<-genefilter(-dat2Affy.m,fff)
			dat.fu<-dat2Affy.m[i,]
			dat.f<-unique(rbind(dat.fo,dat.fu))
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_Affy[[ts_val]]<<-fit2
			dat2Affy.f<-fit2
			ps1<-as.data.frame(dat2Affy.f)	
			rownames(ps1)<-rownames(fit2)
			dat2Affy.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_affy_filt<-tclArray()
			for(i in 0:dim(dat2Affy.f2)[1]){ for(j in 0:dim(dat2Affy.f2)[2]){ 
				if(i==0){ ta_affy_filt[[i,j]]<-colnames(dat2Affy.f2)[j] } else { 
				if(j==0){ ta_affy_filt[[i,j]]<-rownames(dat2Affy.f2)[i] } else {
				tem<-dat2Affy.f2[i,j]
				ta_affy_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			dat2Affy.f3[[ts_val]]<<-dat2Affy.f2
			ta_affy_filt2[[ts_val]]<<-ta_affy_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(dat2Affy.f)!=0){
				err<-try({
					ttx<-topTable(dat2Affy.f,number=nrow(dat2Affy.m))
					rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(dat2Affy.m)==TRUE)]
					dat2Affy.s<-dat2Affy.m[rn,]
				},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(dat2Affy.f,number=nrow(dat2Affy.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(dat2Affy.m)==TRUE)])
					dat2Affy.s<-dat2Affy.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			dat2Affy.s2<-dat2Affy.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_affy_stat<-tclArray()
			for(i in 0:dim(dat2Affy.s2)[1]){ for(j in 0:dim(dat2Affy.s2)[2]){ 
				if(i==0){ ta_affy_stat[[i,j]]<-colnames(dat2Affy.s2)[j] } else { 
				if(j==0){ ta_affy_stat[[i,j]]<-rownames(dat2Affy.s2)[i] } else {
				tem<-dat2Affy.s2[i,j]
				ta_affy_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			dat2Affy.s3[[ts_val]]<<-dat2Affy.s2			
			ta_affy_stat2[[ts_val]]<<-ta_affy_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Agilent-OneColor"){
			datAgOne2.m<-datAgOne2.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
			fff<-pOverA(A=ove,p=posp)
			i<-genefilter(datAgOne2.m,fff)
			dat.fo<-datAgOne2.m[i,]
			i<-genefilter(-datAgOne2.m,fff)
			dat.fu<-datAgOne2.m[i,]
			dat.f<-unique(rbind(dat.fo,dat.fu))
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_Ag1[[ts_val]]<<-fit2
			datAgOne2.f<-fit2
			ps1<-as.data.frame(datAgOne2.f)	
			rownames(ps1)<-rownames(fit2)
			datAgOne2.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_ag1_filt<-tclArray()
			for(i in 0:dim(datAgOne2.f2)[1]){ for(j in 0:dim(datAgOne2.f2)[2]){ 
				if(i==0){ ta_ag1_filt[[i,j]]<-colnames(datAgOne2.f2)[j] } else { 
				if(j==0){ ta_ag1_filt[[i,j]]<-rownames(datAgOne2.f2)[i] } else {
				tem<-datAgOne2.f2[i,j]
				ta_ag1_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			datAgOne2.f3[[ts_val]]<<-datAgOne2.f2
			ta_ag1_filt2[[ts_val]]<<-ta_ag1_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(datAgOne2.f)!=0){
				err<-try({
					ttx<-topTable(datAgOne2.f,number=nrow(datAgOne2.m))
					rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(datAgOne2.m)==TRUE)]
					datAgOne2.s<-datAgOne2.m[rn,]
				},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(datAgOne2.f,number=nrow(datAgOne2.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(datAgOne2.m)==TRUE)])
					datAgOne2.s<-datAgOne2.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			datAgOne2.s2<-datAgOne2.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_ag1_stat<-tclArray()
			for(i in 0:dim(datAgOne2.s2)[1]){ for(j in 0:dim(datAgOne2.s2)[2]){ 
				if(i==0){ ta_ag1_stat[[i,j]]<-colnames(datAgOne2.s2)[j] } else { 
				if(j==0){ ta_ag1_stat[[i,j]]<-rownames(datAgOne2.s2)[i] } else {
				tem<-datAgOne2.s2[i,j]
				ta_ag1_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			datAgOne2.s3[[ts_val]]<<-datAgOne2.s2			
			ta_ag1_stat2[[ts_val]]<<-ta_ag1_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Agilent-TwoColor"){
			datAgTwo2.m<-datAgTwo2.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			fff<-pOverA(A=ove,p=posp)
			i<-genefilter(datAgTwo2.m,fff)
			dat.fo<-datAgTwo2.m[i,]
			i<-genefilter(-datAgTwo2.m,fff)
			dat.fu<-datAgTwo2.m[i,]
			dat.f<-unique(rbind(dat.fo,dat.fu))
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_Ag2[[ts_val]]<<-fit2
			datAgTwo2.f<-fit2
			ps1<-as.data.frame(datAgTwo2.f)	
			rownames(ps1)<-rownames(fit2)
			datAgTwo2.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_ag2_filt<-tclArray()
			for(i in 0:dim(datAgTwo2.f2)[1]){ for(j in 0:dim(datAgTwo2.f2)[2]){ 
				if(i==0){ ta_ag2_filt[[i,j]]<-colnames(datAgTwo2.f2)[j] } else { 
				if(j==0){ ta_ag2_filt[[i,j]]<-rownames(datAgTwo2.f2)[i] } else {
				tem<-datAgTwo2.f2[i,j]
				ta_ag2_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			datAgTwo2.f3[[ts_val]]<<-datAgTwo2.f2
			ta_ag2_filt2[[ts_val]]<<-ta_ag2_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(datAgTwo2.f)!=0){
				err<-try({
						ttx<-topTable(datAgTwo2.f,number=nrow(datAgTwo2.m))
						rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(datAgTwo2.m)==TRUE)]
						datAgTwo2.s<-datAgTwo2.m[rn,]
					},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(datAgTwo2.f,number=nrow(datAgTwo2.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(datAgTwo2.m)==TRUE)])
					datAgTwo2.s<-datAgTwo2.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			datAgTwo2.s2<-datAgTwo2.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_ag2_stat<-tclArray()
			for(i in 0:dim(datAgTwo2.s2)[1]){ for(j in 0:dim(datAgTwo2.s2)[2]){ 
				if(i==0){ ta_ag2_stat[[i,j]]<-colnames(datAgTwo2.s2)[j] } else { 
				if(j==0){ ta_ag2_stat[[i,j]]<-rownames(datAgTwo2.s2)[i] } else {
				tem<-datAgTwo2.s2[i,j]
				ta_ag2_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			datAgTwo2.s3[[ts_val]]<<-datAgTwo2.s2			
			ta_ag2_stat2[[ts_val]]<<-ta_ag2_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Illumina-Beadarray"){
			datIllBA2.m<-datIllBA2.m2[[ts_val]]		
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			fff<-pOverA(A=ove,p=posp)
			i<-genefilter(datIllBA2.m,fff)
			dat.fo<-datIllBA2.m[i,]
			i<-genefilter(-datIllBA2.m,fff)
			dat.fu<-datIllBA2.m[i,]
			dat.f<-unique(rbind(dat.fo,dat.fu))
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_Il_B[[ts_val]]<<-fit2
			datIllBA2.f<-fit2
			ps1<-as.data.frame(datIllBA2.f)	
			rownames(ps1)<-rownames(fit2)
			datIllBA2.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_ilb_filt<-tclArray()
			for(i in 0:dim(datIllBA2.f2)[1]){ for(j in 0:dim(datIllBA2.f2)[2]){ 
				if(i==0){ ta_ilb_filt[[i,j]]<-colnames(datIllBA2.f2)[j] } else { 
				if(j==0){ ta_ilb_filt[[i,j]]<-rownames(datIllBA2.f2)[i] } else {
				tem<-datIllBA2.f2[i,j]
				ta_ilb_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			datIllBA2.f3[[ts_val]]<<-datIllBA2.f2
			ta_ilb_filt2[[ts_val]]<<-ta_ilb_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(datIllBA2.f)!=0){
				err<-try({
						ttx<-topTable(datIllBA2.f,number=nrow(datIllBA2.m))
						rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(datIllBA2.m1)==TRUE)]
						datIllBA2.s<-datIllBA2.m[rn,]
					},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(datIllBA2.f,number=nrow(datIllBA2.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(datIllBA2.m1)==TRUE)])
					datIllBA2.s<-datIllBA2.m1[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			datIllBA2.s2<-datIllBA2.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_ilb_stat<-tclArray()
			for(i in 0:dim(datIllBA2.s2)[1]){ for(j in 0:dim(datIllBA2.s2)[2]){ 
				if(i==0){ ta_ilb_stat[[i,j]]<-colnames(datIllBA2.s2)[j] } else { 
				if(j==0){ ta_ilb_stat[[i,j]]<-rownames(datIllBA2.s2)[i] } else {
				tem<-datIllBA2.s2[i,j]
				ta_ilb_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			datIllBA2.s3[[ts_val]]<<-datIllBA2.s2			
			ta_ilb_stat2[[ts_val]]<<-ta_ilb_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Illumina-Lumi"){
			lumi_NQ.m<-lumi_NQ.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
			fff<-pOverA(A=ove,p=posp)
			i<-genefilter(lumi_NQ.m,fff)
			dat.fo<-lumi_NQ.m[i,]
			i<-genefilter(-lumi_NQ.m,fff)
			dat.fu<-lumi_NQ.m[i,]
			dat.f<-unique(rbind(dat.fo,dat.fu))
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_Il_L[[ts_val]]<<-fit2
			lumi_NQ.f<-fit2
			ps1<-as.data.frame(lumi_NQ.f)	
			rownames(ps1)<-rownames(fit2)
			lumi_NQ.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_ill_filt<-tclArray()
			for(i in 0:dim(lumi_NQ.f2)[1]){ for(j in 0:dim(lumi_NQ.f2)[2]){ 
				if(i==0){ ta_ill_filt[[i,j]]<-colnames(lumi_NQ.f2)[j] } else { 
				if(j==0){ ta_ill_filt[[i,j]]<-rownames(lumi_NQ.f2)[i] } else {
				tem<-lumi_NQ.f2[i,j]
				ta_ill_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			lumi_NQ.f3[[ts_val]]<<-lumi_NQ.f2
			ta_ill_filt2[[ts_val]]<<-ta_ill_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(lumi_NQ.f)!=0){
				err<-try({
						ttx<-topTable(lumi_NQ.f,number=nrow(lumi_NQ.m))
						rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(lumi_NQ.m)==TRUE)]
						lumi_NQ.s<-lumi_NQ.m[rn,]
					},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(lumi_NQ.f,number=nrow(lumi_NQ.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(lumi_NQ.m)==TRUE)])
					lumi_NQ.s<-lumi_NQ.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			lumi_NQ.s2<-lumi_NQ.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_ill_stat<-tclArray()
			for(i in 0:dim(lumi_NQ.s2)[1]){ for(j in 0:dim(lumi_NQ.s2)[2]){ 
				if(i==0){ ta_ill_stat[[i,j]]<-colnames(lumi_NQ.s2)[j] } else { 
				if(j==0){ ta_ill_stat[[i,j]]<-rownames(lumi_NQ.s2)[i] } else {
				tem<-lumi_NQ.s2[i,j]
				ta_ill_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			lumi_NQ.s3[[ts_val]]<<-lumi_NQ.s2			
			ta_ill_stat2[[ts_val]]<<-ta_ill_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Nimblegen"){
			data.matrix_Nimblegen2.m<-data.matrix_Nimblegen2.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
			fff<-pOverA(A=ove,p=posp)
			i<-genefilter(data.matrix_Nimblegen2.m,fff)
			dat.fo<-data.matrix_Nimblegen2.m[i,]
			i<-genefilter(-data.matrix_Nimblegen2.m,fff)
			dat.fu<-data.matrix_Nimblegen2.m[i,]
			dat.f<-unique(rbind(dat.fo,dat.fu))
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_N[[ts_val]]<<-fit2
			data.matrix_Nimblegen2.f<-fit2
			ps1<-as.data.frame(data.matrix_Nimblegen2.f)	
			rownames(ps1)<-rownames(fit2)
			data.matrix_Nimblegen2.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_nbl_filt<-tclArray()
			for(i in 0:dim(data.matrix_Nimblegen2.f2)[1]){ for(j in 0:dim(data.matrix_Nimblegen2.f2)[2]){ 
				if(i==0){ ta_nbl_filt[[i,j]]<-colnames(data.matrix_Nimblegen2.f2)[j] } else { 
				if(j==0){ ta_nbl_filt[[i,j]]<-rownames(data.matrix_Nimblegen2.f2)[i] } else {
				tem<-data.matrix_Nimblegen2.f2[i,j]
				ta_nbl_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			data.matrix_Nimblegen2.f3[[ts_val]]<<-data.matrix_Nimblegen2.f2
			ta_nbl_filt2[[ts_val]]<<-ta_nbl_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(data.matrix_Nimblegen2.f)!=0){
				err<-try({
						ttx<-topTable(data.matrix_Nimblegen2.f,number=nrow(data.matrix_Nimblegen2.m))
						rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_Nimblegen2.m)==TRUE)]
						data.matrix_Nimblegen2.s<-data.matrix_Nimblegen2.m[rn,]
					},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(data.matrix_Nimblegen2.f,number=nrow(data.matrix_Nimblegen2.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_Nimblegen2.m)==TRUE)])
					data.matrix_Nimblegen2.s<-data.matrix_Nimblegen2.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			data.matrix_Nimblegen2.s2<-data.matrix_Nimblegen2.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_nbl_stat<-tclArray()
			for(i in 0:dim(data.matrix_Nimblegen2.s2)[1]){ for(j in 0:dim(data.matrix_Nimblegen2.s2)[2]){ 
				if(i==0){ ta_nbl_stat[[i,j]]<-colnames(data.matrix_Nimblegen2.s2)[j] } else { 
				if(j==0){ ta_nbl_stat[[i,j]]<-rownames(data.matrix_Nimblegen2.s2)[i] } else {
				tem<-data.matrix_Nimblegen2.s2[i,j]
				ta_nbl_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			data.matrix_Nimblegen2.s3[[ts_val]]<<-data.matrix_Nimblegen2.s2			
			ta_nbl_stat2[[ts_val]]<<-ta_nbl_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Series-Matrix"){
			data.matrixNorm.m<-data.matrixNorm.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			fff<-pOverA(A=ove,p=posp)
			i<-genefilter(data.matrixNorm.m,fff)
			dat.fo<-data.matrixNorm.m[i,]
			i<-genefilter(-data.matrixNorm.m,fff)
			dat.fu<-data.matrixNorm.m[i,]
			dat.f<-unique(rbind(dat.fo,dat.fu))
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_S[[ts_val]]<<-fit2
			data.matrixNorm.f<-fit2
			ps1<-as.data.frame(data.matrixNorm.f)	
			rownames(ps1)<-rownames(fit2)
			data.matrixNorm.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_smt_filt<-tclArray()
			for(i in 0:dim(data.matrixNorm.f2)[1]){ for(j in 0:dim(data.matrixNorm.f2)[2]){ 
				if(i==0){ ta_smt_filt[[i,j]]<-colnames(data.matrixNorm.f2)[j] } else { 
				if(j==0){ ta_smt_filt[[i,j]]<-rownames(data.matrixNorm.f2)[i] } else {
				tem<-data.matrixNorm.f2[i,j]
				ta_smt_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			data.matrixNorm.f3[[ts_val]]<<-data.matrixNorm.f2
			ta_smt_filt2[[ts_val]]<<-ta_smt_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(data.matrixNorm.f)!=0){
				err<-try({
					ttx<-topTable(data.matrixNorm.f,number=nrow(data.matrixNorm.m))
					rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrixNorm.m)==TRUE)]
					data.matrixNorm.s<-data.matrixNorm.m[rn,]
				},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(data.matrixNorm.f,number=nrow(data.matrixNorm.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrixNorm.m)==TRUE)])
					data.matrixNorm.s<-data.matrixNorm.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			data.matrixNorm.s2<-data.matrixNorm.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_smt_stat<-tclArray()
			for(i in 0:dim(data.matrixNorm.s2)[1]){ for(j in 0:dim(data.matrixNorm.s2)[2]){ 
				if(i==0){ ta_smt_stat[[i,j]]<-colnames(data.matrixNorm.s2)[j] } else { 
				if(j==0){ ta_smt_stat[[i,j]]<-rownames(data.matrixNorm.s2)[i] } else {
				tem<-data.matrixNorm.s2[i,j]
				ta_smt_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			data.matrixNorm.s3[[ts_val]]<<-data.matrixNorm.s2			
			ta_smt_stat2[[ts_val]]<<-ta_smt_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
		if(ts_name=="Online-Data"){
			data.matrix_onlineNorm.m<-data.matrix_onlineNorm.m2[[ts_val]]
pb_ma<-tkProgressBar(title="Filtering...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			fff<-pOverA(A=ove,p=posp)
			i<-genefilter(data.matrix_onlineNorm.m,fff)
			dat.fo<-data.matrix_onlineNorm.m[i,]
			i<-genefilter(-data.matrix_onlineNorm.m,fff)
			dat.fu<-data.matrix_onlineNorm.m[i,]
			dat.f<-unique(rbind(dat.fo,dat.fu))
			fit<-lmFit(dat.f)
			fit2<-eBayes(fit)
			fit2_O[[ts_val]]<<-fit2
			data.matrix_onlineNorm.f<-fit2
			ps1<-as.data.frame(data.matrix_onlineNorm.f)	
			rownames(ps1)<-rownames(fit2)
			data.matrix_onlineNorm.f2<-ps1
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			ta_onl_filt<-tclArray()
			for(i in 0:dim(data.matrix_onlineNorm.f2)[1]){ for(j in 0:dim(data.matrix_onlineNorm.f2)[2]){ 
				if(i==0){ ta_onl_filt[[i,j]]<-colnames(data.matrix_onlineNorm.f2)[j] } else { 
				if(j==0){ ta_onl_filt[[i,j]]<-rownames(data.matrix_onlineNorm.f2)[i] } else {
				tem<-data.matrix_onlineNorm.f2[i,j]
				ta_onl_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }
			data.matrix_onlineNorm.f3[[ts_val]]<<-data.matrix_onlineNorm.f2
			ta_onl_filt2[[ts_val]]<<-ta_onl_filt
setTkProgressBar(pb_ma,0.6,title="Statistical_Significant...",label="")
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Filtering"))
			}
			if(length(data.matrix_onlineNorm.f)!=0){
				err<-try({
					ttx<-topTable(data.matrix_onlineNorm.f,number=nrow(data.matrix_onlineNorm.m))
					rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_onlineNorm.m)==TRUE)]
					data.matrix_onlineNorm.s<-data.matrix_onlineNorm.m[rn,]
				},silent=TRUE)
				if(length(grep("Error",err))!=0)
				{
					ttx<-topTable(data.matrix_onlineNorm.f,number=nrow(data.matrix_onlineNorm.m))
					rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrix_onlineNorm.m)==TRUE)])
					data.matrix_onlineNorm.s<-data.matrix_onlineNorm.m[rownames(ttx)[ttx$P.Value<=0.01],]
				}
			}
			data.matrix_onlineNorm.s2<-data.matrix_onlineNorm.s
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
			ta_onl_stat<-tclArray()
			for(i in 0:dim(data.matrix_onlineNorm.s2)[1]){ for(j in 0:dim(data.matrix_onlineNorm.s2)[2]){ 
				if(i==0){ ta_onl_stat[[i,j]]<-colnames(data.matrix_onlineNorm.s2)[j] } else { 
				if(j==0){ ta_onl_stat[[i,j]]<-rownames(data.matrix_onlineNorm.s2)[i] } else {
				tem<-data.matrix_onlineNorm.s2[i,j]
				ta_onl_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }			
			data.matrix_onlineNorm.s3[[ts_val]]<<-data.matrix_onlineNorm.s2			
			ta_onl_stat2[[ts_val]]<<-ta_onl_stat
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Statistical_Significant"))
			}
		}
	}

	filter_params<-function(h,h2,h3,h4,...){
		ts_name<-h;ts_val<-h2;children<-h3;r_choice=h4
		w_imp2<-tktoplevel()
		tkwm.title(w_imp2,"Select a filter")
		tkwm.resizable(w_imp2,0,0)
		frame1_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
		tkpack(frame1_imp2,expand=TRUE,fill="both",side="top")
		r1_imp2<-c("Standard Deviation","Expression")
		var1<-tclVar(r1_imp2[1])
		sapply(r1_imp2,function(i){
			r1_imp2_vals<-ttkradiobutton(frame1_imp2,variable=var1,text=i,value=i)
			tkpack(r1_imp2_vals,side="left",anchor="w",padx=45)
		})
		frame2_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12),height=30,width=50,borderwidth=1,relief="groove")
		tkpack(frame2_imp2,expand=TRUE,fill="both",side="left")
		frame3_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12),height=30,width=50,borderwidth=1,relief="groove")
		tkpack(frame3_imp2,expand=TRUE,fill="both",side="left")
		frame4_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12),height=30,width=50,borderwidth=1,relief="groove")
		tkpack(frame4_imp2,expand=TRUE,fill="both",side="left")
		tkpack(ttklabel(frame2_imp2,text='Standard Deviation value'),side="top",padx=0)
		std_value<-tclVar("")
		tkpack(ttkentry(frame2_imp2,textvariable=std_value,width=25),side="top",anchor="e")
		tkpack(ttklabel(frame3_imp2,text='Over Expression Value'),side="top",padx=0)
		exp_value<-tclVar("")
		tkpack(ttkentry(frame3_imp2,textvariable=exp_value,width=25),side="top",anchor="e")
		tkpack(ttklabel(frame3_imp2,text='Percentage of Samples'),side="top",padx=0)
		prcnt<-tclVar("")
		tkpack(ttkentry(frame3_imp2,textvariable=prcnt,width=25),side="top",anchor="e")
		r_but<-ttkbutton(frame4_imp2,text="Ok")
		tkpack(r_but,side="top")
		tkconfigure(r_but,command=function(){
			tkwm.withdraw(w_imp2)
			if(tclvalue(var1)=="Standard Deviation"){ stdev_filt(ts_name,ts_val,children,r_choice,tclvalue(std_value)) }
			if(tclvalue(var1)=="Expression"){ exprs_filt(ts_name,ts_val,children,r_choice,tclvalue(exp_value),tclvalue(prcnt)) }
		})
	}		

	r_choice="._."
	children<-as.character(tcl(treeview,"children",""))
	w_analz<-tktoplevel()
	w_analz_frame<-ttkframe(w_analz,padding=c(3,3,50,20),borderwidth=1,relief="groove")
	tkpack(w_analz_frame,expand=TRUE,fill="both",side="left")
	var<-tclVar(tree_prnts[1])
	sapply(tree_prnts,function(i){
		r_but_vals<-ttkradiobutton(w_analz_frame,variable=var,text=i,value=i)
		tkpack(r_but_vals,side="top",anchor="w")
	})
	tkpack(ttklabel(w_analz_frame,text=''))
	tkpack(ttklabel(w_analz_frame,text=''))
	r_but<-ttkbutton(w_analz_frame,text="Ok")
	tkpack(r_but,pady=2)
	tkconfigure(r_but,command=function(){
		r_choice<-tclvalue(var)
		tkwm.withdraw(w_analz)
		tree_slc<-strsplit(r_choice[1],"_")
		ts_name<-tree_slc[[1]][1]
		ts_val<-as.numeric(tree_slc[[1]][2])
		filter_params(ts_name,ts_val,children,r_choice)
	})
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
filter_unsp()

agtwo<-function(h,...){
	folder<-tclvalue(tkchooseDirectory(title="Select the folder"))
	tag2_i<<-tag2_i+1
	folder_Ag2[[tag2_i]]<<-folder
	if(folder_Ag2[[tag2_i]]==""){
		folder_Ag2<-NULL
	} else {
		try(({
pb_ma<-tkProgressBar(title="Pre-processing...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
			new_datAgTwo=NULL
			setwd(folder_Ag2[[tag2_i]])
			new_datAgTwo<-read.maimages(files=dir(folder_Ag2[[tag2_i]]),source="agilent")
			if(length(new_datAgTwo)!=0){datAgTwo=NULL;datAgTwo<-new_datAgTwo}
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
			z<-as(datAgTwo,"NChannelSet")
			ann_Ag2[[tag2_i]]<<-annotation(z)
		 }),silent=TRUE)
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
		if(length(new_datAgTwo)==0)tkmessageBox(title="Error",message="Could not load this type of data! Try Series_matrix or Online_Data",icon="error",type="ok")
	}
	if(length(datAgTwo)!=0){
		if(length(new_datAgTwo)!=0){

		prnt<-paste("Agilent-TwoColor",tag2_i,sep="_")
		tree_prnts<<-c(tree_prnts,prnt)
		l_datAgTwo[[tag2_i]]<<-datAgTwo
p_enter<-tcl(treeview,"insert","","end",values=as.tclObj(prnt))

			autopa<-tkmessageBox(title="Confirm",message="Do you want to pre-process and analyze automatically!",icon="question",type="okcancel")
			if(tclvalue(autopa)=="ok"){
pb_ma<-tkProgressBar(title="Normalization...",label="",min=0,max=1,initial=0,width=500)
				datAgTwo2.m=NULL;use.datAgTwo2.m=NULL;xf=NULL;datAgTwo2.f=NULL;datAgTwo2.s=NULL;
				design=NULL;design_Ag2=NULL;ttx=NULL;DE_Ag2=NULL;DE_Ag2_2=NULL;use_DE_Ag2=NULL;
				sample.dist_Ag2=NULL;
#				pca_Ag2=NULL;
#				sample.clust_Ag2=NULL;
#				clas_Ag2=NULL;
				try(({folder_Ag2[[tag2_i]]<-folder_Ag2[[tag2_i]];datAgTwo<-datAgTwo;heatcol<-heatcol; }),silent=TRUE)
				setwd(folder_Ag2[[tag2_i]])
setTkProgressBar(pb_ma,0.1,title=NULL,label="")
				try(datAgTwo2<-backgroundCorrect(datAgTwo,"normexp"),silent=TRUE)
				if(length(datAgTwo2)==0)datAgTwo2<-datAgTwo
				datAgTwo2<-normalizeBetweenArrays(datAgTwo2$R,method="quantile")
				datAgTwo2<-log(datAgTwo2)
				datAgTwo2.m<-datAgTwo2
				datAgTwo2.m<-as.matrix(datAgTwo2.m)
				try({
					if(length(rownames(datAgTwo2.m))==0){
						rownames(datAgTwo2.m)<-1:length(datAgTwo2.m[,1])
					} else {
						rownames(datAgTwo2.m)<-as.character(rownames(datAgTwo2.m))
					}
				},silent=TRUE)
				ta_ag2_norm=NULL
				ta_ag2_norm<-tclArray()
				for(i in 0:dim(datAgTwo2.m)[1]){ for(j in 0:dim(datAgTwo2.m)[2]){ 
					if(i==0){ ta_ag2_norm[[i,j]]<-colnames(datAgTwo2.m)[j] } else { 
					if(j==0){ ta_ag2_norm[[i,j]]<-rownames(datAgTwo2.m)[i] } else {
					tem<-datAgTwo2.m[i,j]
					ta_ag2_norm[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }

#				datAgTwo2.m[[tag2_i]]<<-datAgTwo2.m[[tag2_i]]
				datAgTwo2.m2[[tag2_i]]<<-datAgTwo2.m
				
				ta_ag2_norm2[[tag2_i]]<<-ta_ag2_norm
#				

p_enter_norm<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Normalization"))
setTkProgressBar(pb_ma,0.3,title="QC...",label="")
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){boxplot(datAgTwo2.m2[[tag2_i]])},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)
				} else {
					ma_img2<<-tkrreplot(ma_img,function(...){boxplot(datAgTwo2.m2[[tag2_i]])},hscale=1.7,vscale=1.07)
				}

p_enter_qc<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...QC"))
setTkProgressBar(pb_ma,0.35,title="Filtering...",label="")
				use.datAgTwo2.m<-datAgTwo2.m
				try(({
					fff<-pOverA(A=1,p=0.05)
					i<-genefilter(use.datAgTwo2.m,fff)
					dat.fo<-use.datAgTwo2.m[i,]
					i<-genefilter(-use.datAgTwo2.m,fff)
					dat.fu<-use.datAgTwo2.m[i,]
					dat.f<-unique(rbind(dat.fo,dat.fu))
					fit<-lmFit(dat.f)
					fit2<-eBayes(fit)
					fit2_Ag2[[tag2_i]]<<-fit2
					datAgTwo2.f<-fit2
				}),silent=TRUE)
				if(length(datAgTwo2.f)==0)
				{
					try(({
						rsd<-rowSds(use.datAgTwo2.m)
						i<-rsd>=2
						dat.f<-use.datAgTwo2.m[i,]
						fit<-lmFit(dat.f)
						fit2<-eBayes(fit)
						fit2_Ag2[[tag2_i]]<<-fit2
						datAgTwo2.f<-fit2
					}),silent=TRUE)
				}
				ps1<-as.data.frame(datAgTwo2.f)
				rownames(ps1)<-rownames(datAgTwo2.f)
				datAgTwo2.f2=NULL
				datAgTwo2.f2<-ps1
				ta_ag2_filt=NULL
				ta_ag2_filt<-tclArray()
				for(i in 0:dim(datAgTwo2.f2)[1]){ for(j in 0:dim(datAgTwo2.f2)[2]){ 
					if(i==0){ ta_ag2_filt[[i,j]]<-colnames(datAgTwo2.f2)[j] } else { 
					if(j==0){ ta_ag2_filt[[i,j]]<-rownames(datAgTwo2.f2)[i] } else {
					tem<-datAgTwo2.f2[i,j]
					ta_ag2_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				
				datAgTwo2.f3[[tag2_i]]<<-datAgTwo2.f2
				
				ta_ag2_filt2[[tag2_i]]<<-ta_ag2_filt

p_enter_filter<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Filtering"))
setTkProgressBar(pb_ma,0.55,title="Statistical_Significant...",label="")
				if(length(datAgTwo2.f)!=0){
					err<-try({
							ttx<-topTable(datAgTwo2.f,number=nrow(use.datAgTwo2.m))
							rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(datAgTwo2.m)==TRUE)]
							datAgTwo2.s<-use.datAgTwo2.m[rn,]
						},silent=TRUE)
					if(length(grep("Error",err))!=0)
					{
						ttx<-topTable(datAgTwo2.f,number=nrow(use.datAgTwo2.m))
						rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(datAgTwo2.m)==TRUE)])
						datAgTwo2.s<-datAgTwo2.m[rownames(ttx)[ttx$P.Value<=0.01],]
					}
				}
				datAgTwo2.s2=NULL
				datAgTwo2.s2<-datAgTwo2.s
				ta_ag2_stat=NULL
				ta_ag2_stat<-tclArray()
				for(i in 0:dim(datAgTwo2.s2)[1]){ for(j in 0:dim(datAgTwo2.s2)[2]){ 
					if(i==0){ ta_ag2_stat[[i,j]]<-colnames(datAgTwo2.s2)[j] } else { 
					if(j==0){ ta_ag2_stat[[i,j]]<-rownames(datAgTwo2.s2)[i] } else {
					tem<-datAgTwo2.s2[i,j]
					ta_ag2_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				
				datAgTwo2.s3[[tag2_i]]<<-datAgTwo2.s2
				
				ta_ag2_stat2[[tag2_i]]<<-ta_ag2_stat

p_enter_stat_sign<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Statistical_Significant"))
setTkProgressBar(pb_ma,0.75,title="DGE...",label="")
				err<-try(DE_Ag2<-topTable(datAgTwo2.f),silent=TRUE)	
				err<-try(DE_Ag2All[[tag2_i]]<<-topTable(datAgTwo2.f,number=nrow(datAgTwo2.f)),silent=TRUE)
				ta_ag2_dge=NULL
				ta_ag2_dge<-tclArray()
				for(i in 0:dim(DE_Ag2)[1]){ for(j in 0:dim(DE_Ag2)[2]){ 
					if(i==0){ ta_ag2_dge[[i,j]]<-colnames(DE_Ag2)[j] } else { 
					if(j==0){ ta_ag2_dge[[i,j]]<-rownames(DE_Ag2)[i] } else {
					tem<-DE_Ag2[i,j]
					ta_ag2_dge[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				
				DE_Ag2_2[[tag2_i]]<<-DE_Ag2
				
				ta_ag2_dge2[[tag2_i]]<<-ta_ag2_dge

p_enter_dge<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...DGE"))
setTkProgressBar(pb_ma,0.85,title="PCA...",label="")
				pca_Ag2[[tag2_i]]<<-prcomp(t(datAgTwo2.m))
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(pca_Ag2[[tag2_i]])},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)			
				} else {
					ma_img2<<-tkrreplot(ma_img,function(...){plot(pca_Ag2[[tag2_i]])},hscale=1.7,vscale=1.07)
				}

p_enter_pca<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...PCA"))
setTkProgressBar(pb_ma,0.9,title="Clustering...",label="")
				sample.dist_c1<-dist(t(datAgTwo2.m)) 
				sample.dist_Ag2<-as.dist(1-cor(datAgTwo2.m,method="pearson"))
				sample.clust_Ag2[[tag2_i]]<<-hclust(sample.dist_Ag2,method="complete")
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(sample.clust_Ag2[[tag2_i]])},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)			
				}else{
					ma_img2<<-tkrreplot(ma_img,function(...){plot(sample.clust_Ag2[[tag2_i]])},hscale=1.7,vscale=1.07)
				}
p_enter_clust<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Clustering"))
setTkProgressBar(pb_ma,0.95,title="Classification...",label="")
				er_x<-try(use_DE_Ag2<-as.matrix(DE_Ag2),silent=TRUE)
				if(length(grep("Error",er_x))!=0)
				{
					rownames(DE_Ag2)<-as.character(DE_Ag2)
					use_DE_Ag2<-as.matrix(DE_Ag2)
				}
				rnames<-rownames(use_DE_Ag2)
				clas_Ag2[[tag2_i]]<<-as.matrix(use.datAgTwo2.m[rnames,])
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){
						heatmap(clas_Ag2[[tag2_i]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
					},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)			
				}else{
					ma_img2<<-tkrreplot(ma_img,function(...){
						heatmap(clas_Ag2[[tag2_i]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
					},hscale=1.7,vscale=1.07)
				}
p_enter_class<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Classification"))
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
			}
		}
	}
	display()
	
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
if(!requireNamespace("BiocManager",quietly=TRUE)){install.packages("BiocManager");library(BiocManager)} else {library(BiocManager)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("genefilter",quietly=TRUE)){BiocManager::install("genefilter",ask=FALSE,update=FALSE);library(genefilter)} else {library(genefilter)}
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
if(!requireNamespace("limma",quietly=TRUE)){BiocManager::install("limma",ask=FALSE,update=FALSE);library(limma)} else {library(limma)}
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
if(!requireNamespace("stats",quietly=TRUE)){install.packages("stats",ask=FALSE,update=FALSE);library(stats)} else {library(stats)}
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
if(!requireNamespace("tcltk",quietly=TRUE)){install.packages("tcltk",ask=FALSE,update=FALSE);library(tcltk)} else {library(tcltk)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
agtwo()

display<-function(h,...){
#	treeview<-treeview
	tkbind(treeview,"<Double-Button-1>",function(W,x,y){
		mapapa<-tcl(treeview,"parent",tkselect(treeview))
		mapapa_name<<-as.character(tcl(treeview,"item",mapapa,"-values"))
		betabeti_name<<-as.character(tcl(treeview,"item",tkselect(treeview),"-values"))
		print(mapapa_name)
		print(betabeti_name)
		tabfun<-function(h,tnr,tnc,...){
			try(tkpack.forget(scrX,scrY,tableData,ma_img),silent=TRUE)
			scrX<<-ttkscrollbar(ma_frame2,orient="horizont",command=function(...)tcl(tableData,'xview',...))
			scrY<<-ttkscrollbar(ma_frame2,orient="vertical",command=function(...)tcl(tableData,'yview',...))
			fxscroll<-function(...){tcl(scrX,'set',...)}
			fyscroll<-function(...){tcl(scrY,'set',...)}
			tableData<<-tkwidget(ma_frame2,'table',rows=tnr+1,cols=tnc+1,height=-1,width=-1,ellipsis='...',insertofftime=0,
				flashmode=TRUE,flashtime=1,anchor='w',resizeborders='col',wrap=FALSE,font='{Times}',padx=5,pady=2,ipadx=3,ipady=1,
				rowstretchmode='unset',colstretchmode='fill',multiline=FALSE,cache=TRUE,background="white",foreground="black",selectmode="extended",
				selecttitle=TRUE,relief='groove',borderwidth=c(0,1,0,1),drawmode='compatible',#colwidth=12,
				highlightcolor="gray",highlightbackground="white",highlightthickness=1,xscrollcommand=fxscroll,yscrollcommand=fyscroll,
				rowseparator='\n',colseparator='\t',validate=TRUE,variable=h)
			tcl(tableData,"tag","celltag","ZeroZero","0,0")
			tcl(tableData,"tag","rowtag","rowtitle","0")
			tcl(tableData,"tag","coltag","coltitle","0")
			tcl(tableData,"tag","configure","rowtitle",bg='lightgray',relief='groove',anchor='w')#,borderwidth=c(1,1,1,1))
			tcl(tableData,"tag","configure","coltitle",bg='lightgray',relief='groove',anchor='w')#,borderwidth=c(1,1,1,1))
			tcl(tableData,"tag","configure","active",fg='green',bg='gray90',relief='solid',borderwidth=c(1,1,1,1))
			tcl(tableData,"width","0","12")
			tkpack(scrX,side="bottom",fill="x",expand=FALSE)	# x scrollbar
			tkpack(scrY,side="right",fill="y",expand=FALSE,pady=c(0,18)) #y scrollbar
#			tcl('pack',tableData,expand=TRUE,fill="both",side='left',anchor='e')
			tkpack(tableData,expand=TRUE,fill="both",side='left',anchor='e')
		}
		
		legend_tab<<-function(h1,h2,h3,h4,...){
			w_legend<<-tktoplevel()
			tkwm.title(w_legend,h4)
			legend_frame<-ttkframe(w_legend,padding=c(3,3,20,20),borderwidth=1,relief="groove")
			tkpack(legend_frame,expand=TRUE,fill="both",side="left")
			tabfun2<-function(h,tnr,tnc,...){
				scrX2<-ttkscrollbar(legend_frame,orient="horizont",command=function(...)tcl(tableData2,'xview',...))
				scrY2<-ttkscrollbar(legend_frame,orient="vertical",command=function(...)tcl(tableData2,'yview',...))
				fxscroll<-function(...){tcl(scrX2,'set',...)}
				fyscroll<-function(...){tcl(scrY2,'set',...)}
				tableData2<-tkwidget(legend_frame,'table',rows=tnr+1,cols=tnc+1,height=-1,width=-1,ellipsis='...',insertofftime=0,
					flashmode=TRUE,flashtime=1,anchor='w',resizeborders='col',wrap=FALSE,font='{Times}',padx=5,pady=2,ipadx=3,ipady=1,
						rowstretchmode='unset',colstretchmode='fill',multiline=FALSE,cache=TRUE,background="white",foreground="black",selectmode="extended",
					selecttitle=TRUE,relief='groove',borderwidth=c(0,1,0,1),drawmode='compatible',#colwidth=12,
					highlightcolor="gray",highlightbackground="white",highlightthickness=1,xscrollcommand=fxscroll,yscrollcommand=fyscroll,
					rowseparator='\n',colseparator='\t',validate=TRUE,variable=h)
				tcl(tableData2,"tag","celltag","ZeroZero","0,0")
				tcl(tableData2,"tag","rowtag","rowtitle","0")
				tcl(tableData2,"tag","coltag","coltitle","0")
				tcl(tableData2,"tag","configure","rowtitle",bg='lightgray',relief='groove',anchor='w')#,borderwidth=c(1,1,1,1))
				tcl(tableData2,"tag","configure","coltitle",bg='lightgray',relief='groove',anchor='w')#,borderwidth=c(1,1,1,1))
				tcl(tableData2,"tag","configure","active",fg='green',bg='gray90',relief='solid',borderwidth=c(1,1,1,1))
				tcl(tableData2,"width","0","12")
				tkpack(scrX2,side="bottom",fill="x",expand=FALSE)	# x scrollbar
				tkpack(scrY2,side="right",fill="y",expand=FALSE,pady=c(0,18)) #y scrollbar
	#			tcl('pack',tableData2,expand=TRUE,fill="both",side='left',anchor='e')
				tkpack(tableData2,expand=TRUE,fill="both",side='left',anchor='e')
			}
			tabfun2(h1,h2,h3)
		}


		tree_slc<-strsplit(mapapa_name[1],"_")
		ts_val<-as.numeric(tree_slc[[1]][2])
		if(!is.na(ts_val) && mapapa_name==paste("Affymetrix",ts_val,sep="_"))
		{
			if(betabeti_name=="...Normalization")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_affy_norm2[[ts_val]],nrow(dat2Affy.m2[[ts_val]]),ncol(dat2Affy.m2[[ts_val]]))
			} else
			if(betabeti_name=="...QC")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(dat2Affy.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...Filtering")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_affy_filt2[[ts_val]],nrow(dat2Affy.f3[[ts_val]]),ncol(dat2Affy.f3[[ts_val]]))
			} else
			if(betabeti_name=="...Statistical_Significant")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_affy_stat2[[ts_val]],nrow(dat2Affy.s3[[ts_val]]),ncol(dat2Affy.s3[[ts_val]]))
			} else
			if(betabeti_name=="...DGE")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_affy_dge2[[ts_val]],nrow(DE_Affy_2[[ts_val]]),ncol(DE_Affy_2[[ts_val]]))
			} else
			if(betabeti_name=="...PCA")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(pca_Affy[[ts_val]],main="Principle Component Analysis")},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Clustering")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(sample.clust_Affy[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Classification")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_Affy[[ts_val]],margins=c(7,7),Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...GSEA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_affy_gsea_gobp[[ts_val]],nrow(GOresultBP_Affy[[ts_val]]),ncol(GOresultBP_Affy[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_affy_gsea_gomf[[ts_val]],nrow(GOresultMF_Affy[[ts_val]]),ncol(GOresultMF_Affy[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_affy_gsea_gocc[[ts_val]],nrow(GOresultCC_Affy[[ts_val]]),ncol(GOresultCC_Affy[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_affy_gsea_kegg[[ts_val]],nrow(KEGGresult_Affy[[ts_val]]),ncol(KEGGresult_Affy[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_affy_gsta_gobp[[ts_val]],nrow(GOtable.outBP_Affy[[ts_val]]),ncol(GOtable.outBP_Affy[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_affy_gsta_gomf[[ts_val]],nrow(GOtable.outMF_Affy[[ts_val]]),ncol(GOtable.outMF_Affy[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_affy_gsta_gocc[[ts_val]],nrow(GOtable.outCC_Affy[[ts_val]]),ncol(GOtable.outCC_Affy[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_affy_gsta_kegg[[ts_val]],nrow(KEGGtable.out_Affy[[ts_val]]),ncol(KEGGtable.out_Affy[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goBP_Affy[[ts_val]]
					plot(graph_gsea_goBP_Affy[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bpplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_affy_legend_gsea_gobp[[ts_val]],nrow(legend_gsea_goBP_Affy[[ts_val]]),ncol(legend_gsea_goBP_Affy[[ts_val]]),"GSEA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goMF_Affy[[ts_val]]
					plot(graph_gsea_goMF_Affy[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_affy_legend_gsea_gomf[[ts_val]],nrow(legend_gsea_goMF_Affy[[ts_val]]),ncol(legend_gsea_goMF_Affy[[ts_val]]),"GSEA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goCC_Affy[[ts_val]]
					plot(graph_gsea_goCC_Affy[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_affy_legend_gsea_gocc[[ts_val]],nrow(legend_gsea_goCC_Affy[[ts_val]]),ncol(legend_gsea_goCC_Affy[[ts_val]]),"GSEA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsea_KEGG_Affy[[ts_val]],fillcolor=nodefill_gsea_KEGG_Affy[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsea_KEGG_Affy[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_affy_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_Affy[[ts_val]]),ncol(legend_gsea_KEGG_Affy[[ts_val]]),"GSEA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goBP_Affy[[ts_val]]
					plot(graph_gsta_goBP_Affy[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bpplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_affy_legend_gsta_gobp[[ts_val]],nrow(legend_gsta_goBP_Affy[[ts_val]]),ncol(legend_gsta_goBP_Affy[[ts_val]]),"GSTA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goMF_Affy[[ts_val]]
					plot(graph_gsta_goMF_Affy[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_affy_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_Affy[[ts_val]]),ncol(legend_gsta_goMF_Affy[[ts_val]]),"GSTA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goCC_Affy[[ts_val]]
					plot(graph_gsta_goCC_Affy[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_affy_legend_gsta_gocc[[ts_val]],nrow(legend_gsta_goCC_Affy[[ts_val]]),ncol(legend_gsta_goCC_Affy[[ts_val]]),"GSTA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsta_KEGG_Affy[[ts_val]],fillcolor=nodefill_gsta_KEGG_Affy[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsta_KEGG_Affy[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_affy_legend_gsta_kegg[[ts_val]],nrow(legend_gsta_KEGG_Affy[[ts_val]]),ncol(legend_gsta_KEGG_Affy[[ts_val]]),"GSTA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...Gene_Symbol")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_affy_genes[[ts_val]],nrow(genes_Affy[[ts_val]]),ncol(genes_Affy[[ts_val]]))
			} else 
			if(betabeti_name=="...Coexprs_Network")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					plot(myGraph_Affy[[ts_val]],nodeAttrs=makeNodeAttrs(myGraph_Affy[[ts_val]],fontsize=18,fillcolor="grey"))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...SSE")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					ssize.plot(ssize_Affy[[ts_val]],xlim=c(0,20),main=paste("Sample size to detect 2-fold change",sep=""))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else {}
		}
		if(!is.na(ts_val) && mapapa_name==paste("Agilent-OneColor",ts_val,sep="_"))
		{
			if(betabeti_name=="...Normalization")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag1_norm2[[ts_val]],nrow(datAgOne2.m2[[ts_val]]),ncol(datAgOne2.m2[[ts_val]]))
			} else
			if(betabeti_name=="...QC")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(datAgOne2.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...Filtering")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag1_filt2[[ts_val]],nrow(datAgOne2.f3[[ts_val]]),ncol(datAgOne2.f3[[ts_val]]))
			} else
			if(betabeti_name=="...Statistical_Significant")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag1_stat2[[ts_val]],nrow(datAgOne2.s3[[ts_val]]),ncol(datAgOne2.s3[[ts_val]]))
			} else
			if(betabeti_name=="...DGE")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag1_dge2[[ts_val]],nrow(DE_Ag1_2[[ts_val]]),ncol(DE_Ag1_2[[ts_val]]))
			} else
			if(betabeti_name=="...PCA")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(pca_Ag1[[ts_val]],main="Principle Component Analysis")},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Clustering")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(sample.clust_Ag1[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Classification")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_Ag1[[ts_val]],margins=c(7,7),Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...GSEA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag1_gsea_gobp[[ts_val]],nrow(GOresultBP_Ag1[[ts_val]]),ncol(GOresultBP_Ag1[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag1_gsea_gomf[[ts_val]],nrow(GOresultMF_Ag1[[ts_val]]),ncol(GOresultMF_Ag1[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag1_gsea_gocc[[ts_val]],nrow(GOresultCC_Ag1[[ts_val]]),ncol(GOresultCC_Ag1[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag1_gsea_kegg[[ts_val]],nrow(KEGGresult_Ag1[[ts_val]]),ncol(KEGGresult_Ag1[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag1_gsta_gobp[[ts_val]],nrow(GOtable.outBP_Ag1[[ts_val]]),ncol(GOtable.outBP_Ag1[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag1_gsta_gomf[[ts_val]],nrow(GOtable.outMF_Ag1[[ts_val]]),ncol(GOtable.outMF_Ag1[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag1_gsta_gocc[[ts_val]],nrow(GOtable.outCC_Ag1[[ts_val]]),ncol(GOtable.outCC_Ag1[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag1_gsta_kegg[[ts_val]],nrow(KEGGtable.out_Ag1[[ts_val]]),ncol(KEGGtable.out_Ag1[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goBP_Ag1[[ts_val]]
					plot(graph_gsea_goBP_Ag1[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bpplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag1_legend_gsea_gobp[[ts_val]],nrow(legend_gsea_goBP_Ag1[[ts_val]]),ncol(legend_gsea_goBP_Ag1[[ts_val]]),"GSEA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goMF_Ag1[[ts_val]]
					plot(graph_gsea_goMF_Ag1[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag1_legend_gsea_gomf[[ts_val]],nrow(legend_gsea_goMF_Ag1[[ts_val]]),ncol(legend_gsea_goMF_Ag1[[ts_val]]),"GSEA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goCC_Ag1[[ts_val]]
					plot(graph_gsea_goCC_Ag1[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag1_legend_gsea_gocc[[ts_val]],nrow(legend_gsea_goCC_Ag1[[ts_val]]),ncol(legend_gsea_goCC_Ag1[[ts_val]]),"GSEA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsea_KEGG_Ag1[[ts_val]],fillcolor=nodefill_gsea_KEGG_Ag1[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsea_KEGG_Ag1[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag1_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_Ag1[[ts_val]]),ncol(legend_gsea_KEGG_Ag1[[ts_val]]),"GSEA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goBP_Ag1[[ts_val]]
					plot(graph_gsta_goBP_Ag1[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bpplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag1_legend_gsta_gobp[[ts_val]],nrow(legend_gsta_goBP_Ag1[[ts_val]]),ncol(legend_gsta_goBP_Ag1[[ts_val]]),"GSTA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goMF_Ag1[[ts_val]]
					plot(graph_gsta_goMF_Ag1[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag1_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_Ag1[[ts_val]]),ncol(legend_gsta_goMF_Ag1[[ts_val]]),"GSTA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goCC_Ag1[[ts_val]]
					plot(graph_gsta_goCC_Ag1[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag1_legend_gsta_gocc[[ts_val]],nrow(legend_gsta_goCC_Ag1[[ts_val]]),ncol(legend_gsta_goCC_Ag1[[ts_val]]),"GSTA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsta_KEGG_Ag1[[ts_val]],fillcolor=nodefill_gsta_KEGG_Ag1[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsta_KEGG_Ag1[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag1_legend_gsta_kegg[[ts_val]],nrow(legend_gsta_KEGG_Ag1[[ts_val]]),ncol(legend_gsta_KEGG_Ag1[[ts_val]]),"GSTA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...Gene_Symbol")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag1_genes[[ts_val]],nrow(genes_Ag1[[ts_val]]),ncol(genes_Ag1[[ts_val]]))
			} else 
			if(betabeti_name=="...Coexprs_Network")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					plot(myGraph_Ag1[[ts_val]],nodeAttrs=makeNodeAttrs(myGraph_Ag1[[ts_val]],fontsize=18,fillcolor="grey"))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...SSE")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					ssize.plot(ssize_Ag1[[ts_val]],xlim=c(0,20),main=paste("Sample size to detect 2-fold change",sep=""))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else {}
		}
		if(!is.na(ts_val) && mapapa_name==paste("Agilent-TwoColor",ts_val,sep="_"))
		{
			if(betabeti_name=="...Normalization")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag2_norm2[[ts_val]],nrow(datAgTwo2.m2[[ts_val]]),ncol(datAgTwo2.m2[[ts_val]]))
			} else
			if(betabeti_name=="...QC")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(datAgTwo2.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...Filtering")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag2_filt2[[ts_val]],nrow(datAgTwo2.f3[[ts_val]]),ncol(datAgTwo2.f3[[ts_val]]))
			} else
			if(betabeti_name=="...Statistical_Significant")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag2_stat2[[ts_val]],nrow(datAgTwo2.s3[[ts_val]]),ncol(datAgTwo2.s3[[ts_val]]))
			} else
			if(betabeti_name=="...DGE")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag2_dge2[[ts_val]],nrow(DE_Ag2_2[[ts_val]]),ncol(DE_Ag2_2[[ts_val]]))
			} else
			if(betabeti_name=="...PCA")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(pca_Ag2[[ts_val]],main="Principle Component Analysis")},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Clustering")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(sample.clust_Ag2[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Classification")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_Ag2[[ts_val]],margins=c(7,7),Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...GSEA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag2_gsea_gobp[[ts_val]],nrow(GOresultBP_Ag2[[ts_val]]),ncol(GOresultBP_Ag2[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag2_gsea_gomf[[ts_val]],nrow(GOresultMF_Ag2[[ts_val]]),ncol(GOresultMF_Ag2[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag2_gsea_gocc[[ts_val]],nrow(GOresultCC_Ag2[[ts_val]]),ncol(GOresultCC_Ag2[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag2_gsea_kegg[[ts_val]],nrow(KEGGresult_Ag2[[ts_val]]),ncol(KEGGresult_Ag2[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag2_gsta_gobp[[ts_val]],nrow(GOtable.outBP_Ag2[[ts_val]]),ncol(GOtable.outBP_Ag2[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag2_gsta_gomf[[ts_val]],nrow(GOtable.outMF_Ag2[[ts_val]]),ncol(GOtable.outMF_Ag2[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag2_gsta_gocc[[ts_val]],nrow(GOtable.outCC_Ag2[[ts_val]]),ncol(GOtable.outCC_Ag2[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag2_gsta_kegg[[ts_val]],nrow(KEGGtable.out_Ag2[[ts_val]]),ncol(KEGGtable.out_Ag2[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goBP_Ag2[[ts_val]]
					plot(graph_gsea_goBP_Ag2[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bpplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag2_legend_gsea_gobp[[ts_val]],nrow(legend_gsea_goBP_Ag2[[ts_val]]),ncol(legend_gsea_goBP_Ag2[[ts_val]]),"GSEA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goMF_Ag2[[ts_val]]
					plot(graph_gsea_goMF_Ag2[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag2_legend_gsea_gomf[[ts_val]],nrow(legend_gsea_goMF_Ag2[[ts_val]]),ncol(legend_gsea_goMF_Ag2[[ts_val]]),"GSEA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goCC_Ag2[[ts_val]]
					plot(graph_gsea_goCC_Ag2[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag2_legend_gsea_gocc[[ts_val]],nrow(legend_gsea_goCC_Ag2[[ts_val]]),ncol(legend_gsea_goCC_Ag2[[ts_val]]),"GSEA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsea_KEGG_Ag2[[ts_val]],fillcolor=nodefill_gsea_KEGG_Ag2[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsea_KEGG_Ag2[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag2_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_Ag2[[ts_val]]),ncol(legend_gsea_KEGG_Ag2[[ts_val]]),"GSEA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goBP_Ag2[[ts_val]]
					plot(graph_gsta_goBP_Ag2[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bpplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag2_legend_gsta_gobp[[ts_val]],nrow(legend_gsta_goBP_Ag2[[ts_val]]),ncol(legend_gsta_goBP_Ag2[[ts_val]]),"GSTA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goMF_Ag2[[ts_val]]
					plot(graph_gsta_goMF_Ag2[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag2_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_Ag2[[ts_val]]),ncol(legend_gsta_goMF_Ag2[[ts_val]]),"GSTA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goCC_Ag2[[ts_val]]
					plot(graph_gsta_goCC_Ag2[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag2_legend_gsta_gocc[[ts_val]],nrow(legend_gsta_goCC_Ag2[[ts_val]]),ncol(legend_gsta_goCC_Ag2[[ts_val]]),"GSTA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsta_KEGG_Ag2[[ts_val]],fillcolor=nodefill_gsta_KEGG_Ag2[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsta_KEGG_Ag2[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ag2_legend_gsta_kegg[[ts_val]],nrow(legend_gsta_KEGG_Ag2[[ts_val]]),ncol(legend_gsta_KEGG_Ag2[[ts_val]]),"GSTA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...Gene_Symbol")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ag2_genes[[ts_val]],nrow(genes_Ag2[[ts_val]]),ncol(genes_Ag2[[ts_val]]))
			} else 
			if(betabeti_name=="...Coexprs_Network")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					plot(myGraph_Ag2[[ts_val]],nodeAttrs=makeNodeAttrs(myGraph_Ag2[[ts_val]],fontsize=18,fillcolor="grey"))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...SSE")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					ssize.plot(ssize_Ag2[[ts_val]],xlim=c(0,20),main=paste("Sample size to detect 2-fold change",sep=""))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else {}
		}
		if(!is.na(ts_val) && mapapa_name==paste("Illumina-Beadarray",ts_val,sep="_"))
		{
			if(betabeti_name=="...Normalization")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ilb_norm2[[ts_val]],nrow(datIllBA2.m2[[ts_val]]),ncol(datIllBA2.m2[[ts_val]]))
			} else
			if(betabeti_name=="...QC")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(datIllBA2.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...Filtering")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ilb_filt2[[ts_val]],nrow(datIllBA2.f3[[ts_val]]),ncol(datIllBA2.f3[[ts_val]]))
			} else
			if(betabeti_name=="...Statistical_Significant")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ilb_stat2[[ts_val]],nrow(datIllBA2.s3[[ts_val]]),ncol(datIllBA2.s3[[ts_val]]))
			} else
			if(betabeti_name=="...DGE")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ilb_dge2[[ts_val]],nrow(DE_Il_B_2[[ts_val]]),ncol(DE_Il_B_2[[ts_val]]))
			} else
			if(betabeti_name=="...PCA")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(pca_Il_B[[ts_val]],main="Principle Component Analysis")},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Clustering")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(sample.clust_Il_B[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Classification")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_Il_B[[ts_val]],margins=c(7,7),Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...GSEA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ilb_gsea_gobp[[ts_val]],nrow(GOresultBP_Il_B[[ts_val]]),ncol(GOresultBP_Il_B[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ilb_gsea_gomf[[ts_val]],nrow(GOresultMF_Il_B[[ts_val]]),ncol(GOresultMF_Il_B[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ilb_gsea_gocc[[ts_val]],nrow(GOresultCC_Il_B[[ts_val]]),ncol(GOresultCC_Il_B[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ilb_gsea_kegg[[ts_val]],nrow(KEGGresult_Il_B[[ts_val]]),ncol(KEGGresult_Il_B[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ilb_gsta_gobp[[ts_val]],nrow(GOtable.outBP_Il_B[[ts_val]]),ncol(GOtable.outBP_Il_B[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ilb_gsta_gomf[[ts_val]],nrow(GOtable.outMF_Il_B[[ts_val]]),ncol(GOtable.outMF_Il_B[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ilb_gsta_gocc[[ts_val]],nrow(GOtable.outCC_Il_B[[ts_val]]),ncol(GOtable.outCC_Il_B[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ilb_gsta_kegg[[ts_val]],nrow(KEGGtable.out_Il_B[[ts_val]]),ncol(KEGGtable.out_Il_B[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goBP_Il_B[[ts_val]]
					plot(graph_gsea_goBP_Il_B[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bpplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ilb_legend_gsea_gobp[[ts_val]],nrow(legend_gsea_goBP_Il_B[[ts_val]]),ncol(legend_gsea_goBP_Il_B[[ts_val]]),"GSEA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goMF_Il_B[[ts_val]]
					plot(graph_gsea_goMF_Il_B[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ilb_legend_gsea_gomf[[ts_val]],nrow(legend_gsea_goMF_Il_B[[ts_val]]),ncol(legend_gsea_goMF_Il_B[[ts_val]]),"GSEA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goCC_Il_B[[ts_val]]
					plot(graph_gsea_goCC_Il_B[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ilb_legend_gsea_gocc[[ts_val]],nrow(legend_gsea_goCC_Il_B[[ts_val]]),ncol(legend_gsea_goCC_Il_B[[ts_val]]),"GSEA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsea_KEGG_Il_B[[ts_val]],fillcolor=nodefill_gsea_KEGG_Il_B[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsea_KEGG_Il_B[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ilb_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_Il_B[[ts_val]]),ncol(legend_gsea_KEGG_Il_B[[ts_val]]),"GSEA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goBP_Il_B[[ts_val]]
					plot(graph_gsta_goBP_Il_B[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bpplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ilb_legend_gsta_gobp[[ts_val]],nrow(legend_gsta_goBP_Il_B[[ts_val]]),ncol(legend_gsta_goBP_Il_B[[ts_val]]),"GSTA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goMF_Il_B[[ts_val]]
					plot(graph_gsta_goMF_Il_B[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ilb_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_Il_B[[ts_val]]),ncol(legend_gsta_goMF_Il_B[[ts_val]]),"GSTA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goCC_Il_B[[ts_val]]
					plot(graph_gsta_goCC_Il_B[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ilb_legend_gsta_gocc[[ts_val]],nrow(legend_gsta_goCC_Il_B[[ts_val]]),ncol(legend_gsta_goCC_Il_B[[ts_val]]),"GSTA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsta_KEGG_Il_B[[ts_val]],fillcolor=nodefill_gsta_KEGG_Il_B[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsta_KEGG_Il_B[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ilb_legend_gsta_kegg[[ts_val]],nrow(legend_gsta_KEGG_Il_B[[ts_val]]),ncol(legend_gsta_KEGG_Il_B[[ts_val]]),"GSTA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...Gene_Symbol")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ilb_genes[[ts_val]],nrow(genes_Il_B[[ts_val]]),ncol(genes_Il_B[[ts_val]]))
			} else 
			if(betabeti_name=="...Coexprs_Network")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					plot(myGraph_Il_B[[ts_val]],nodeAttrs=makeNodeAttrs(myGraph_Il_B[[ts_val]],fontsize=18,fillcolor="grey"))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...SSE")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					ssize.plot(ssize_Il_B[[ts_val]],xlim=c(0,20),main=paste("Sample size to detect 2-fold change",sep=""))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else {}
		}
		if(!is.na(ts_val) && mapapa_name==paste("Illumina-Lumi",ts_val,sep="_"))
		{
			if(betabeti_name=="...Normalization")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ill_norm2[[ts_val]],nrow(lumi_NQ.m2[[ts_val]]),ncol(lumi_NQ.m2[[ts_val]]))
			} else
			if(betabeti_name=="...QC")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(lumi_NQ.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...Filtering")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ill_filt2[[ts_val]],nrow(lumi_NQ.f3[[ts_val]]),ncol(lumi_NQ.f3[[ts_val]]))
			} else
			if(betabeti_name=="...Statistical_Significant")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ill_stat2[[ts_val]],nrow(lumi_NQ.s3[[ts_val]]),ncol(lumi_NQ.s3[[ts_val]]))
			} else
			if(betabeti_name=="...DGE")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ill_dge2[[ts_val]],nrow(DE_Il_L_2[[ts_val]]),ncol(DE_Il_L_2[[ts_val]]))
			} else
			if(betabeti_name=="...PCA")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(pca_Il_L[[ts_val]],main="Principle Component Analysis")},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Clustering")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(sample.clust_Il_L[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Classification")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_Il_L[[ts_val]],margins=c(7,7),Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...GSEA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ill_gsea_gobp[[ts_val]],nrow(GOresultBP_Il_L[[ts_val]]),ncol(GOresultBP_Il_L[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ill_gsea_gomf[[ts_val]],nrow(GOresultMF_Il_L[[ts_val]]),ncol(GOresultMF_Il_L[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ill_gsea_gocc[[ts_val]],nrow(GOresultCC_Il_L[[ts_val]]),ncol(GOresultCC_Il_L[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ill_gsea_kegg[[ts_val]],nrow(KEGGresult_Il_L[[ts_val]]),ncol(KEGGresult_Il_L[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ill_gsta_gobp[[ts_val]],nrow(GOtable.outBP_Il_L[[ts_val]]),ncol(GOtable.outBP_Il_L[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ill_gsta_gomf[[ts_val]],nrow(GOtable.outMF_Il_L[[ts_val]]),ncol(GOtable.outMF_Il_L[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ill_gsta_gocc[[ts_val]],nrow(GOtable.outCC_Il_L[[ts_val]]),ncol(GOtable.outCC_Il_L[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ill_gsta_kegg[[ts_val]],nrow(KEGGtable.out_Il_L[[ts_val]]),ncol(KEGGtable.out_Il_L[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goBP_Il_L[[ts_val]]
					plot(graph_gsea_goBP_Il_L[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bpplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ill_legend_gsea_gobp[[ts_val]],nrow(legend_gsea_goBP_Il_L[[ts_val]]),ncol(legend_gsea_goBP_Il_L[[ts_val]]),"GSEA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goMF_Il_L[[ts_val]]
					plot(graph_gsea_goMF_Il_L[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ill_legend_gsea_gomf[[ts_val]],nrow(legend_gsea_goMF_Il_L[[ts_val]]),ncol(legend_gsea_goMF_Il_L[[ts_val]]),"GSEA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goCC_Il_L[[ts_val]]
					plot(graph_gsea_goCC_Il_L[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ill_legend_gsea_gocc[[ts_val]],nrow(legend_gsea_goCC_Il_L[[ts_val]]),ncol(legend_gsea_goCC_Il_L[[ts_val]]),"GSEA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsea_KEGG_Il_L[[ts_val]],fillcolor=nodefill_gsea_KEGG_Il_L[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsea_KEGG_Il_L[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ill_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_Il_L[[ts_val]]),ncol(legend_gsea_KEGG_Il_L[[ts_val]]),"GSEA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goBP_Il_L[[ts_val]]
					plot(graph_gsta_goBP_Il_L[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bpplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ill_legend_gsta_gobp[[ts_val]],nrow(legend_gsta_goBP_Il_L[[ts_val]]),ncol(legend_gsta_goBP_Il_L[[ts_val]]),"GSTA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goMF_Il_L[[ts_val]]
					plot(graph_gsta_goMF_Il_L[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ill_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_Il_L[[ts_val]]),ncol(legend_gsta_goMF_Il_L[[ts_val]]),"GSTA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goCC_Il_L[[ts_val]]
					plot(graph_gsta_goCC_Il_L[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ill_legend_gsta_gocc[[ts_val]],nrow(legend_gsta_goCC_Il_L[[ts_val]]),ncol(legend_gsta_goCC_Il_L[[ts_val]]),"GSTA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsta_KEGG_Il_L[[ts_val]],fillcolor=nodefill_gsta_KEGG_Il_L[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsta_KEGG_Il_L[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_ill_legend_gsta_kegg[[ts_val]],nrow(legend_gsta_KEGG_Il_L[[ts_val]]),ncol(legend_gsta_KEGG_Il_L[[ts_val]]),"GSTA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...Gene_Symbol")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_ill_genes[[ts_val]],nrow(genes_Il_L[[ts_val]]),ncol(genes_Il_L[[ts_val]]))
			} else 
			if(betabeti_name=="...Coexprs_Network")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					plot(myGraph_Il_L[[ts_val]],nodeAttrs=makeNodeAttrs(myGraph_Il_L[[ts_val]],fontsize=18,fillcolor="grey"))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...SSE")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					ssize.plot(ssize_Il_L[[ts_val]],xlim=c(0,20),main=paste("Sample size to detect 2-fold change",sep=""))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else {}
		}
		if(!is.na(ts_val) && mapapa_name==paste("Nimblegen",ts_val,sep="_"))
		{
			if(betabeti_name=="...Normalization")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_nbl_norm2[[ts_val]],nrow(data.matrix_Nimblegen2.m2[[ts_val]]),ncol(data.matrix_Nimblegen2.m2[[ts_val]]))
			} else
			if(betabeti_name=="...QC")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(data.matrix_Nimblegen2.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...Filtering")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_nbl_filt2[[ts_val]],nrow(data.matrix_Nimblegen2.f3[[ts_val]]),ncol(data.matrix_Nimblegen2.f3[[ts_val]]))
			} else
			if(betabeti_name=="...Statistical_Significant")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_nbl_stat2[[ts_val]],nrow(data.matrix_Nimblegen2.s3[[ts_val]]),ncol(data.matrix_Nimblegen2.s3[[ts_val]]))
			} else
			if(betabeti_name=="...DGE")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_nbl_dge2[[ts_val]],nrow(DE_N_2[[ts_val]]),ncol(DE_N_2[[ts_val]]))
			} else
			if(betabeti_name=="...PCA")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(pca_N[[ts_val]],main="Principle Component Analysis")},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Clustering")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(sample.clust_N[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Classification")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_N[[ts_val]],margins=c(7,7),Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...GSEA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_nbl_gsea_gobp[[ts_val]],nrow(GOresultBP_N[[ts_val]]),ncol(GOresultBP_N[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_nbl_gsea_gomf[[ts_val]],nrow(GOresultMF_N[[ts_val]]),ncol(GOresultMF_N[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_nbl_gsea_gocc[[ts_val]],nrow(GOresultCC_N[[ts_val]]),ncol(GOresultCC_N[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_nbl_gsea_kegg[[ts_val]],nrow(KEGGresult_N[[ts_val]]),ncol(KEGGresult_N[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_nbl_gsta_gobp[[ts_val]],nrow(GOtable.outBP_N[[ts_val]]),ncol(GOtable.outBP_N[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_nbl_gsta_gomf[[ts_val]],nrow(GOtable.outMF_N[[ts_val]]),ncol(GOtable.outMF_N[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_nbl_gsta_gocc[[ts_val]],nrow(GOtable.outCC_N[[ts_val]]),ncol(GOtable.outCC_N[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_nbl_gsta_kegg[[ts_val]],nrow(KEGGtable.out_N[[ts_val]]),ncol(KEGGtable.out_N[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goBP_N[[ts_val]]
					plot(graph_gsea_goBP_N[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bpplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_nbl_legend_gsea_gobp[[ts_val]],nrow(legend_gsea_goBP_N[[ts_val]]),ncol(legend_gsea_goBP_N[[ts_val]]),"GSEA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goMF_N[[ts_val]]
					plot(graph_gsea_goMF_N[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_nbl_legend_gsea_gomf[[ts_val]],nrow(legend_gsea_goMF_N[[ts_val]]),ncol(legend_gsea_goMF_N[[ts_val]]),"GSEA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goCC_N[[ts_val]]
					plot(graph_gsea_goCC_N[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_nbl_legend_gsea_gocc[[ts_val]],nrow(legend_gsea_goCC_N[[ts_val]]),ncol(legend_gsea_goCC_N[[ts_val]]),"GSEA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsea_KEGG_N[[ts_val]],fillcolor=nodefill_gsea_KEGG_N[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsea_KEGG_N[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_nbl_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_N[[ts_val]]),ncol(legend_gsea_KEGG_N[[ts_val]]),"GSEA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goBP_N[[ts_val]]
					plot(graph_gsta_goBP_N[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bpplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_nbl_legend_gsta_gobp[[ts_val]],nrow(legend_gsta_goBP_N[[ts_val]]),ncol(legend_gsta_goBP_N[[ts_val]]),"GSTA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goMF_N[[ts_val]]
					plot(graph_gsta_goMF_N[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_nbl_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_N[[ts_val]]),ncol(legend_gsta_goMF_N[[ts_val]]),"GSTA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goCC_N[[ts_val]]
					plot(graph_gsta_goCC_N[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_nbl_legend_gsta_gocc[[ts_val]],nrow(legend_gsta_goCC_N[[ts_val]]),ncol(legend_gsta_goCC_N[[ts_val]]),"GSTA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsta_KEGG_N[[ts_val]],fillcolor=nodefill_gsta_KEGG_N[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsta_KEGG_N[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_nbl_legend_gsta_kegg[[ts_val]],nrow(legend_gsta_KEGG_N[[ts_val]]),ncol(legend_gsta_KEGG_N[[ts_val]]),"GSTA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...Gene_Symbol")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_nbl_genes[[ts_val]],nrow(genes_N[[ts_val]]),ncol(genes_N[[ts_val]]))
			} else 
			if(betabeti_name=="...Coexprs_Network")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					plot(myGraph_N[[ts_val]],nodeAttrs=makeNodeAttrs(myGraph_N[[ts_val]],fontsize=18,fnblcolor="grey"))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...SSE")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					ssize.plot(ssize_N[[ts_val]],xlim=c(0,20),main=paste("Sample size to detect 2-fold change",sep=""))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else {}
		}
		if(!is.na(ts_val) && mapapa_name==paste("Series-Matrix",ts_val,sep="_"))
		{
			if(betabeti_name=="...Normalization")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_smt_norm2[[ts_val]],nrow(data.matrixNorm.m2[[ts_val]]),ncol(data.matrixNorm.m2[[ts_val]]))
			} else
			if(betabeti_name=="...QC")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(data.matrixNorm.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...Filtering")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_smt_filt2[[ts_val]],nrow(data.matrixNorm.f3[[ts_val]]),ncol(data.matrixNorm.f3[[ts_val]]))
			} else
			if(betabeti_name=="...Statistical_Significant")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_smt_stat2[[ts_val]],nrow(data.matrixNorm.s3[[ts_val]]),ncol(data.matrixNorm.s3[[ts_val]]))
			} else
			if(betabeti_name=="...DGE")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_smt_dge2[[ts_val]],nrow(DE_S_2[[ts_val]]),ncol(DE_S_2[[ts_val]]))
			} else
			if(betabeti_name=="...PCA")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(pca_S[[ts_val]],main="Principle Component Analysis")},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Clustering")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(sample.clust_S[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Classification")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_S[[ts_val]],margins=c(7,7),Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...GSEA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_smt_gsea_gobp[[ts_val]],nrow(GOresultBP_S[[ts_val]]),ncol(GOresultBP_S[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_smt_gsea_gomf[[ts_val]],nrow(GOresultMF_S[[ts_val]]),ncol(GOresultMF_S[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_smt_gsea_gocc[[ts_val]],nrow(GOresultCC_S[[ts_val]]),ncol(GOresultCC_S[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_smt_gsea_kegg[[ts_val]],nrow(KEGGresult_S[[ts_val]]),ncol(KEGGresult_S[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_smt_gsta_gobp[[ts_val]],nrow(GOtable.outBP_S[[ts_val]]),ncol(GOtable.outBP_S[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_smt_gsta_gomf[[ts_val]],nrow(GOtable.outMF_S[[ts_val]]),ncol(GOtable.outMF_S[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_smt_gsta_gocc[[ts_val]],nrow(GOtable.outCC_S[[ts_val]]),ncol(GOtable.outCC_S[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_smt_gsta_kegg[[ts_val]],nrow(KEGGtable.out_S[[ts_val]]),ncol(KEGGtable.out_S[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goBP_S[[ts_val]]
					plot(graph_gsea_goBP_S[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bbplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_smt_legend_gsea_gobp[[ts_val]],nrow(legend_gsea_goBP_S[[ts_val]]),ncol(legend_gsea_goBP_S[[ts_val]]),"GSEA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goMF_S[[ts_val]]
					plot(graph_gsea_goMF_S[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_smt_legend_gsea_gomf[[ts_val]],nrow(legend_gsea_goMF_S[[ts_val]]),ncol(legend_gsea_goMF_S[[ts_val]]),"GSEA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goCC_S[[ts_val]]
					plot(graph_gsea_goCC_S[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_smt_legend_gsea_gocc[[ts_val]],nrow(legend_gsea_goCC_S[[ts_val]]),ncol(legend_gsea_goCC_S[[ts_val]]),"GSEA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_KEGG_Graph")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsea_KEGG_S[[ts_val]],fillcolor=nodefill_gsea_KEGG_S[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsea_KEGG_S[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_smt_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_S[[ts_val]]),ncol(legend_gsea_KEGG_S[[ts_val]]),"GSEA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goBP_S[[ts_val]]
					plot(graph_gsta_goBP_S[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bbplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_smt_legend_gsta_gobp[[ts_val]],nrow(legend_gsta_goBP_S[[ts_val]]),ncol(legend_gsta_goBP_S[[ts_val]]),"GSTA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goMF_S[[ts_val]]
					plot(graph_gsta_goMF_S[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_smt_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_S[[ts_val]]),ncol(legend_gsta_goMF_S[[ts_val]]),"GSTA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goCC_S[[ts_val]]
					plot(graph_gsta_goCC_S[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_smt_legend_gsta_gocc[[ts_val]],nrow(legend_gsta_goCC_S[[ts_val]]),ncol(legend_gsta_goCC_S[[ts_val]]),"GSTA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsta_KEGG_S[[ts_val]],fillcolor=nodefill_gsta_KEGG_S[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsta_KEGG_S[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_smt_legend_gsta_kegg[[ts_val]],nrow(legend_gsta_KEGG_S[[ts_val]]),ncol(legend_gsta_KEGG_S[[ts_val]]),"GSTA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...Gene_Symbol")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_smt_genes[[ts_val]],nrow(genes_S[[ts_val]]),ncol(genes_S[[ts_val]]))
			} else 
			if(betabeti_name=="...Coexprs_Network")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					plot(myGraph_S[[ts_val]],nodeAttrs=makeNodeAttrs(myGraph_S[[ts_val]],fontsize=18,fillcolor="grey"))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...SSE")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					ssize.plot(ssize_S[[ts_val]],xlim=c(0,20),main=paste("Sample size to detect 2-fold change",sep=""))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else {}
		}
		if(!is.na(ts_val) && mapapa_name==paste("Online-Data",ts_val,sep="_"))
		{
			if(betabeti_name=="...Normalization")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_onl_norm2[[ts_val]],nrow(data.matrix_onlineNorm.m2[[ts_val]]),ncol(data.matrix_onlineNorm.m2[[ts_val]]))
			} else
			if(betabeti_name=="...QC")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(data.matrix_onlineNorm.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...Filtering")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_onl_filt2[[ts_val]],nrow(data.matrix_onlineNorm.f3[[ts_val]]),ncol(data.matrix_onlineNorm.f3[[ts_val]]))
			} else
			if(betabeti_name=="...Statistical_Significant")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_onl_stat2[[ts_val]],nrow(data.matrix_onlineNorm.s3[[ts_val]]),ncol(data.matrix_onlineNorm.s3[[ts_val]]))
			} else
			if(betabeti_name=="...DGE")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_onl_dge2[[ts_val]],nrow(DE_O_2[[ts_val]]),ncol(DE_O_2[[ts_val]]))
			} else
			if(betabeti_name=="...PCA")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(pca_O[[ts_val]],main="Principle Component Analysis")},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Clustering")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){plot(sample.clust_O[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...Classification")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_O[[ts_val]],margins=c(7,7),Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else
			if(betabeti_name=="...GSEA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_onl_gsea_gobp[[ts_val]],nrow(GOresultBP_O[[ts_val]]),ncol(GOresultBP_O[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_onl_gsea_gomf[[ts_val]],nrow(GOresultMF_O[[ts_val]]),ncol(GOresultMF_O[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_onl_gsea_gocc[[ts_val]],nrow(GOresultCC_O[[ts_val]]),ncol(GOresultCC_O[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_onl_gsea_kegg[[ts_val]],nrow(KEGGresult_O[[ts_val]]),ncol(KEGGresult_O[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOBP")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_onl_gsta_gobp[[ts_val]],nrow(GOtable.outBP_O[[ts_val]]),ncol(GOtable.outBP_O[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOMF")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_onl_gsta_gomf[[ts_val]],nrow(GOtable.outMF_O[[ts_val]]),ncol(GOtable.outMF_O[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_GOCC")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_onl_gsta_gocc[[ts_val]],nrow(GOtable.outCC_O[[ts_val]]),ncol(GOtable.outCC_O[[ts_val]]))
			} else
			if(betabeti_name=="...GSTA_KEGG")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_onl_gsta_kegg[[ts_val]],nrow(KEGGtable.out_O[[ts_val]]),ncol(KEGGtable.out_O[[ts_val]]))
			} else
			if(betabeti_name=="...GSEA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goBP_O[[ts_val]]
					plot(graph_gsea_goBP_O[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bbplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_onl_legend_gsea_gobp[[ts_val]],nrow(legend_gsea_goBP_O[[ts_val]]),ncol(legend_gsea_goBP_O[[ts_val]]),"GSEA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goMF_O[[ts_val]]
					plot(graph_gsea_goMF_O[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_onl_legend_gsea_gomf[[ts_val]],nrow(legend_gsea_goMF_O[[ts_val]]),ncol(legend_gsea_goMF_O[[ts_val]]),"GSEA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsea_goCC_O[[ts_val]]
					plot(graph_gsea_goCC_O[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_onl_legend_gsea_gocc[[ts_val]],nrow(legend_gsea_goCC_O[[ts_val]]),ncol(legend_gsea_goCC_O[[ts_val]]),"GSEA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSEA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsea_KEGG_O[[ts_val]],fillcolor=nodefill_gsea_KEGG_O[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsea_KEGG_O[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_onl_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_O[[ts_val]]),ncol(legend_gsea_KEGG_O[[ts_val]]),"GSEA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOBP_Graph")
			{
				bpplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goBP_O[[ts_val]]
					plot(graph_gsta_goBP_O[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,bpplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_onl_legend_gsta_gobp[[ts_val]],nrow(legend_gsta_goBP_O[[ts_val]]),ncol(legend_gsta_goBP_O[[ts_val]]),"GSTA_GOBP_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOMF_Graph")
			{
				mfplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goMF_O[[ts_val]]
					plot(graph_gsta_goMF_O[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,mfplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_onl_legend_gsta_gomf[[ts_val]],nrow(legend_gsta_goMF_O[[ts_val]]),ncol(legend_gsta_goMF_O[[ts_val]]),"GSTA_GOMF_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_GOCC_Graph")
			{
				ccplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nAttrs<-list()
					nAttrs$fillcolor<-nodefill_gsta_goCC_O[[ts_val]]
					plot(graph_gsta_goCC_O[[ts_val]],nodeAttrs=nAttrs)
				}
				ma_img2<<-tkrreplot(ma_img,ccplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_onl_legend_gsta_gocc[[ts_val]],nrow(legend_gsta_goCC_O[[ts_val]]),ncol(legend_gsta_goCC_O[[ts_val]]),"GSTA_GOCC_Graph_Legend")
			} else
			if(betabeti_name=="...GSTA_KEGG_Graph")
			{
				keggplot<-function(){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					nA<-makeNodeAttrs(graph_gsta_KEGG_O[[ts_val]],fillcolor=nodefill_gsta_KEGG_O[[ts_val]],width=10,height=1.2)
					oldpar<-par(no.readonly=TRUE)
					on.exit(par(oldpar))
					par(mar=c(3,5,0,5),mgp=c(0,0,0))
					layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
					plot(graph_gsta_KEGG_O[[ts_val]],"dot",nodeAttrs=nA)
					ar<-18
					cols<-colorRampPalette(c("Green", "Red"))(ar)
					image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
					mtext("down-regulation",side=1,at=0,line=1)
					mtext("up-regulation",side=1,at=1,line=1)
				}
				ma_img2<<-tkrreplot(ma_img,keggplot,hscale=1.7,vscale=1.07)
				tkpack(ma_img)
				legend_tab(ta_onl_legend_gsta_kegg[[ts_val]],nrow(legend_gsta_KEGG_O[[ts_val]]),ncol(legend_gsta_KEGG_O[[ts_val]]),"GSTA_KEGG_Graph_Legend")
			} else
			if(betabeti_name=="...Gene_Symbol")
			{
				try(tkpack.forget(ma_img),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				tabfun(ta_onl_genes[[ts_val]],nrow(genes_O[[ts_val]]),ncol(genes_O[[ts_val]]))
			} else 
			if(betabeti_name=="...Coexprs_Network")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					plot(myGraph_O[[ts_val]],nodeAttrs=makeNodeAttrs(myGraph_O[[ts_val]],fontsize=18,fillcolor="grey"))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else 
			if(betabeti_name=="...SSE")
			{
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img2<<-tkrreplot(ma_img,function(...){
					ssize.plot(ssize_O[[ts_val]],xlim=c(0,20),main=paste("Sample size to detect 2-fold change",sep=""))
				},hscale=1.7,vscale=1.07)
				tkpack(ma_img)
			} else {}
		}
	})
}
if(!requireNamespace("tcltk",quietly=TRUE)){install.packages("tcltk");library(tcltk)} else {library(tcltk)}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
display()

dmsm<-function(h,...){
	tkmessageBox(title="Loading",message="Select Platform Soft file",icon="info",type="ok")
	file<-tclvalue(tkgetOpenFile(title="Select the file"))
	tsmt_i<<-tsmt_i+1
	file_soft<<-file
	if(file_soft==""){
		file_soft<-NULL
	} else { 
		try(({
pb_ma<-tkProgressBar(title="Pre-processing...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
			folder_S[[tsmt_i]]<<-dirname(file_soft)
			setwd(folder_S[[tsmt_i]])	
			a2=readLines(file_soft)
			b2=length(a2)
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
			begin2<-which(gsub("\t","",a2)=="!platform_table_begin")
			end2<-which(gsub("\t","",a2)=="!platform_table_end")-1
			size2=end2-begin2-1
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
			new_y=NULL
			new_y<-read.table(file_soft,skip=begin2,nrows=size2,header=TRUE,sep="\t",row.names=NULL)
			if(length(new_y)!=0){y=NULL;y<-new_y}
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
			if(length(new_y)==0)tkmessageBox(title="Error",message="Could not load this type of data!",icon="error",type="ok")
		}),silent=TRUE)
	}
	tkmessageBox(title="Loading",message="Select Series Matrix file",icon="info",type="ok")
	file<-tclvalue(tkgetOpenFile(title="Select the file"))
	file_series_mat<-file
	if(file_series_mat==""){
		file_series_mat<-NULL
	} else { 
		try(({
pb_ma<-tkProgressBar(title="Pre-processing...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
			directory1<-dirname(file_series_mat)
			setwd(directory1)
			new_data.matrix=NULL;
			data.matrix_series=NULL
			a=readLines(file_series_mat)
			b=length(a)
			begin<-which(gsub("\t","",a)=='!series_matrix_table_begin')
			end<-which(gsub("\t","",a)=='series_matrix_ends!')-1
			size=end-begin-1
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
			x=read.table(file_series_mat,skip=begin,nrows=size,header=TRUE,sep="\t",row.names=NULL)
			row.names(x)=x[,1]
			x=x[,-1]
			new_gse<-NULL
			new_gse<-new("ExpressionSet",exprs=as.matrix(x))
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
			if(length(new_gse)!=0){
				gse<-new_gse
				ann_S[[tsmt_i]]<<-annotation(gse)
			}
			table=exprs(gse)
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
			orf_ids<-cbind(y$ID,as.character(y$ORF))
			orf_ids2<-orf_ids[which(orf_ids[,2]!=""),]
			table2<-table[orf_ids2[,1],]
			rownames(table2)<-orf_ids2[,2]
			table3<-table2
			new_data.matrix<-table3
			
			data.matrix_series<-table3
			if(length(new_data.matrix)!=0){data.matrix_series=NULL;data.matrix_series<-new_data.matrix}
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
			if(length(new_data.matrix)==0)tkmessageBox(title="Error",message="Could not load this type of data!",icon="error",type="ok")
		}),silent=TRUE)
	}
	if(length(data.matrix_series)!=0){
		if(length(data.matrix_series)!=0){

		prnt<-paste("Series-Matrix",tsmt_i,sep="_")
		tree_prnts<<-c(tree_prnts,prnt)
		l_data.matrix_series[[tsmt_i]]<<-data.matrix_series
p_enter<-tcl(treeview,"insert","","end",values=as.tclObj(prnt))

		autopa<-tkmessageBox(title="Confirm",message="Do you want to pre-process and analyze automatically!",icon="question",type="okcancel")
		if(tclvalue(autopa)=="ok"){
pb_ma<-tkProgressBar(title="Log Transformation...",label="",min=0,max=1,initial=0,width=500)
			Med<-median(data.matrix_series,na.rm=TRUE)
			if(Med>16)
			{
				data.matrixLog<-log2(data.matrix_series)
			} else {
				data.matrixLog<-data.matrix_series
			}
setTkProgressBar(pb_ma,0.1,title="KNN Imputation...",label="")
			na.length<-length(which(is.na(data.matrixLog)==TRUE))
			if(na.length > 0)data.matrixImp<-impute.knn(data.matrixLog,k=10,rowmax=0.5,colmax=0.3)$data
			if(na.length <= 0)data.matrixImp<-data.matrixLog
			data.matrixNorm=NULL;
			data.matrixNorm.m=NULL;use.data.matrixNorm.m=NULL;xf=NULL;data.matrixNorm.f=NULL;data.matrixNorm.s=NULL;
			design=NULL;design_S=NULL;ttx=NULL;DE_S=NULL;DE_S_2=NULL;use_DE_S=NULL;
			sample.dist_S=NULL;
#			pca_S=NULL;
#			sample.clust_S=NULL;
#			clas_S=NULL;
			try(({folder_S[[tsmt_i]]<-folder_S[[tsmt_i]];data.matrixImp<-data.matrixImp;heatcol<-heatcol;}),silent=TRUE)
			setwd(folder_S[[tsmt_i]])	
			if(length(data.matrixImp)!=0){
setTkProgressBar(pb_ma,0.2,title="Normalization...",label="")
				data.matrixNorm<-normalizeBetweenArrays(data.matrixImp,method="quantile")
				tmp<-aggregate(data.matrixNorm,list(rownames(data.matrixNorm)),median)
				rownames(tmp)<-tmp[,1]
				data.matrixNorm.m<-as.matrix(tmp[,-1])
				try({
					if(length(rownames(data.matrixNorm.m))==0){
						rownames(data.matrixNorm.m)<-1:length(data.matrixNorm.m[,1])
					} else {
						rownames(data.matrixNorm.m)<-as.character(rownames(data.matrixNorm.m))
					}
				},silent=TRUE)
			}
			ta_smt_norm<-tclArray()
			for(i in 0:dim(data.matrixNorm.m)[1]){ for(j in 0:dim(data.matrixNorm.m)[2]){ 
				if(i==0){ ta_smt_norm[[i,j]]<-colnames(data.matrixNorm.m)[j] } else { 
				if(j==0){ ta_smt_norm[[i,j]]<-rownames(data.matrixNorm.m)[i] } else {
					tem<-data.matrixNorm.m[i,j]
					ta_smt_norm[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
				} }
			} }

#			data.matrixNorm.m<<-data.matrixNorm.m
			data.matrixNorm.m2[[tsmt_i]]<<-data.matrixNorm.m

			ta_smt_norm2[[tsmt_i]]<<-ta_smt_norm
#				

p_enter_norm<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Normalization"))
setTkProgressBar(pb_ma,0.3,title="QC...",label="")
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){boxplot(data.matrixNorm.m2[[tsmt_i]])},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)
				} else {
					ma_img2<<-tkrreplot(ma_img,function(...){boxplot(data.matrixNorm.m2[[tsmt_i]])},hscale=1.7,vscale=1.07)
				}
p_enter_qc<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...QC"))
setTkProgressBar(pb_ma,0.35,title="Filtering...",label="")
				use.data.matrixNorm.m<-data.matrixNorm.m
				try(({
					fff<-pOverA(A=1,p=0.05)
					i<-genefilter(use.data.matrixNorm.m,fff)
					dat.fo<-use.data.matrixNorm.m[i,]
					i<-genefilter(-use.data.matrixNorm.m,fff)
					dat.fu<-use.data.matrixNorm.m[i,]
					dat.f<-unique(rbind(dat.fo,dat.fu))
					fit<-lmFit(dat.f)
					fit2<-eBayes(fit)
					fit2_S[[tsmt_i]]<<-fit2
					data.matrixNorm.f<-fit2
				}),silent=TRUE)
				if(length(data.matrixNorm.f)==0)
				{
					try(({
						rsd<-rowSds(use.data.matrixNorm.m)
						i<-rsd>=2
						dat.f<-use.data.matrixNorm.m[i,]
						fit<-lmFit(dat.f)
						fit2<-eBayes(fit)
						fit2_S[[tsmt_i]]<<-fit2
						data.matrixNorm.f<-fit2
					}),silent=TRUE)
				}
				ps1<-as.data.frame(data.matrixNorm.f)	
				rownames(ps1)<-rownames(data.matrixNorm.f)
				data.matrixNorm.f2=NULL
				data.matrixNorm.f2<-ps1
				ta_smt_filt=NULL
				ta_smt_filt<-tclArray()
				for(i in 0:dim(data.matrixNorm.f2)[1]){ for(j in 0:dim(data.matrixNorm.f2)[2]){ 
					if(i==0){ ta_smt_filt[[i,j]]<-colnames(data.matrixNorm.f2)[j] } else { 
					if(j==0){ ta_smt_filt[[i,j]]<-rownames(data.matrixNorm.f2)[i] } else {
					tem<-data.matrixNorm.f2[i,j]
					ta_smt_filt[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				
				data.matrixNorm.f3[[tsmt_i]]<<-data.matrixNorm.f2
				
				ta_smt_filt2[[tsmt_i]]<<-ta_smt_filt

p_enter_filter<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Filtering"))
setTkProgressBar(pb_ma,0.55,title="Statistical_Significant...",label="")
				if(length(data.matrixNorm.f)!=0){
					err<-try({
						ttx<-topTable(data.matrixNorm.f,number=nrow(use.data.matrixNorm.m))
						rn<-rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrixNorm.m)==TRUE)]
						data.matrixNorm.s<-use.data.matrixNorm.m[rn,]
					},silent=TRUE)
					if(length(grep("Error",err))!=0)
					{
						ttx<-topTable(data.matrixNorm.f,number=nrow(use.data.matrixNorm.m))
						rn<-as.numeric(rownames(ttx)[which(rownames(ttx)%in%rownames(data.matrixNorm.m)==TRUE)])
						data.matrixNorm.s<-data.matrixNorm.m[rownames(ttx)[ttx$P.Value<=0.01],]
					}
				}
				data.matrixNorm.s2=NULL
				data.matrixNorm.s2<-data.matrixNorm.s
				ta_smt_stat=NULL
				ta_smt_stat<-tclArray()
				for(i in 0:dim(data.matrixNorm.s2)[1]){ for(j in 0:dim(data.matrixNorm.s2)[2]){ 
					if(i==0){ ta_smt_stat[[i,j]]<-colnames(data.matrixNorm.s2)[j] } else { 
					if(j==0){ ta_smt_stat[[i,j]]<-rownames(data.matrixNorm.s2)[i] } else {
					tem<-data.matrixNorm.s2[i,j]
					ta_smt_stat[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				
				data.matrixNorm.s3[[tsmt_i]]<<-data.matrixNorm.s2
				
				ta_smt_stat2[[tsmt_i]]<<-ta_smt_stat

p_enter_stat_sign<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Statistical_Significant"))
setTkProgressBar(pb_ma,0.75,title="DGE...",label="")
				err<-try(DE_S<-topTable(data.matrixNorm.f),silent=TRUE)	
				err<-try(DE_SAll[[tsmt_i]]<<-topTable(data.matrixNorm.f,number=nrow(data.matrixNorm.f)),silent=TRUE)
				ta_smt_dge=NULL
				ta_smt_dge<-tclArray()
				for(i in 0:dim(DE_S)[1]){ for(j in 0:dim(DE_S)[2]){ 
					if(i==0){ ta_smt_dge[[i,j]]<-colnames(DE_S)[j] } else { 
					if(j==0){ ta_smt_dge[[i,j]]<-rownames(DE_S)[i] } else {
					tem<-DE_S[i,j]
					ta_smt_dge[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				
				DE_S_2[[tsmt_i]]<<-DE_S
				
				ta_smt_dge2[[tsmt_i]]<<-ta_smt_dge

p_enter_dge<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...DGE"))
setTkProgressBar(pb_ma,0.85,title="PCA...",label="")
				pca_S[[tsmt_i]]<<-prcomp(t(data.matrixNorm.m[[tsmt_i]]))
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(pca_S[[tsmt_i]])},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)			
				} else {
					ma_img2<<-tkrreplot(ma_img,function(...){plot(pca_S[[tsmt_i]])},hscale=1.7,vscale=1.07)
				}

p_enter_pca<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...PCA"))
setTkProgressBar(pb_ma,0.9,title="Clustering...",label="")
				sample.dist_c1<-dist(t(data.matrixNorm.m)) 
				sample.dist_S<-as.dist(1-cor(data.matrixNorm.m,method="pearson"))
				sample.clust_S[[tsmt_i]]<<-hclust(sample.dist_S,method="complete")
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(sample.clust_S[[tsmt_i]])},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)			
				}else{
					ma_img2<<-tkrreplot(ma_img,function(...){plot(sample.clust_S[[tsmt_i]])},hscale=1.7,vscale=1.07)
				}
p_enter_clust<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Clustering"))
setTkProgressBar(pb_ma,0.95,title="Classification...",label="")
				er_x<-try(use_DE_S<-as.matrix(DE_S),silent=TRUE)
				if(length(grep("Error",er_x))!=0)
				{
					rownames(DE_S)<-as.character(DE_S)
					use_DE_S<-as.matrix(DE_S)
				}
				rnames<-rownames(use_DE_S)
				clas_S[[tsmt_i]]<<-as.matrix(data.matrixNorm.m[rnames,])
				if(is.null(ma_img)==TRUE){
					try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
					try(tkwm.withdraw(w_legend),silent=TRUE)
					ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){
						heatmap(clas_S[[tsmt_i]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
					},hscale=1.7,vscale=1.07)
					ma_img2<<-ma_img
					tkpack(ma_img2)			
				}else{
					ma_img2<<-tkrreplot(ma_img,function(...){
						heatmap(clas_S[[tsmt_i]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
					},hscale=1.7,vscale=1.07)
				}
p_enter_class<-tcl(treeview,"insert",p_enter,"end",values=as.tclObj("...Classification"))
setTkProgressBar(pb_ma,1,title="Completed...",label="")				
close(pb_ma)
			}
		}
	}
	display()
	
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.1,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
if(!requireNamespace("BiocManager",quietly=TRUE)){install.packages("BiocManager");library(BiocManager)} else {library(BiocManager)}
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
if(!requireNamespace("genefilter",quietly=TRUE)){BiocManager::install("genefilter",ask=FALSE,update=FALSE);library(genefilter)} else {library(genefilter)}
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
if(!requireNamespace("impute",quietly=TRUE)){BiocManager::install("impute",ask=FALSE,update=FALSE);library(impute)} else {library(impute)}
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
if(!requireNamespace("limma",quietly=TRUE)){BiocManager::install("limma",ask=FALSE,update=FALSE);library(limma)} else {library(limma)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("Biobase",quietly=TRUE)){BiocManager::install("Biobase",ask=FALSE,update=FALSE);library(Biobase)} else {library(Biobase)}
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
if(!requireNamespace("stats",quietly=TRUE)){install.packages("stats",ask=FALSE,update=FALSE);library(stats)} else {library(stats)}
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
if(!requireNamespace("tcltk",quietly=TRUE)){install.packages("tcltk",ask=FALSE,update=FALSE);library(tcltk)} else {library(tcltk)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
dmsm()

symbol<-function(h,...){
	r_choice="._."
	children<-as.character(tcl(treeview,"children",""))
	w_analz<-tktoplevel()
	w_analz_frame<-ttkframe(w_analz,padding=c(3,3,50,20),borderwidth=1,relief="groove")
	tkpack(w_analz_frame,expand=TRUE,fill="both",side="left")
	var<-tclVar(tree_prnts[1])
	sapply(tree_prnts,function(i){
		r_but_vals<-ttkradiobutton(w_analz_frame,variable=var,text=i,value=i)
		tkpack(r_but_vals,side="top",anchor="w")
	})
	tkpack(ttklabel(w_analz_frame,text=''))
	tkpack(ttklabel(w_analz_frame,text=''))
	r_but<-ttkbutton(w_analz_frame,text="Ok")
	tkpack(r_but,pady=2)
	tkconfigure(r_but,command=function(){
		r_choice<-tclvalue(var)
		tkwm.withdraw(w_analz)
		err<-try({
			if(!file.exists("GEOmetadb.sqlite")){
				sqlfile<-getSQLiteFile(destdir=cur_dir,destfile="GEOmetadb.sqlite.gz",type="normal")
			} else {
				sqlfile<-"GEOmetadb.sqlite"
			}
			con<-dbConnect(SQLite(),sqlfile)
			geo_tables<-dbListTables(con)
			rs<-dbGetQuery(con,'select gpl,bioc_package from gpl')
			rs2<-rs[!is.na(rs$bioc_package),]
			rs3<-rs2[!(rs2$bioc_package==""),]
			pre_rs<-rs3
		},silent=TRUE)
		if(length(grep("Error",err))!=0)
		{
			rs<-c("GPL71","GPL198","GPL2112","GPL3979","GPL3738","GPL200","GPL3213","GPL72","GPL1322","GPL199",
			"GPL3154","GPL74","GPL201","GPL96","GPL571","GPL97","GPL14877","GPL570","GPL13667","GPL8300",
			"GPL91","GPL92","GPL93","GPL94","GPL95","GPL887","GPL1708","GPL13497","GPL17897","GPL3921",
			"GPL15396","GPL80","GPL5188","GPL17556","GPL6244","GPL11532","GPL18190","GPL8490","GPL13534","GPL6102",
			"GPL6947","GPL10558","GPL32","GPL81","GPL33","GPL82","GPL34","GPL83","GPL339","GPL6246",
			"GPL340","GPL1261","GPL8321","GPL75","GPL76","GPL3533","GPL341","GPL342","GPL1355","GPL85",
			"GPL86","GPL87","GPL88","GPL1352","GPL1318","GPL2529","GPL90","GPL1319",
			"ag","ath1121501","bovine","canine","canine2","celegans","chicken","drosgenome1","drosophila2","ecoli2",
			"ecoli2","hcg110","hgfocus","hgu133a","hgu133a2","hgu133b","hgu133plus2","hgu133plus2","hgu219","hgu95av2",
			"hgu95av2","hgu95b","hgu95c","hgu95d","hgu95e","hgug4110b","hgug4112a","HsAgilentDesign026652","hthgu133a","hthgu133a",
			"hthgu133b","hu6800","huex10sttranscriptcluster","hugene10sttranscriptcluster","hugene10sttranscriptcluster",
			"hugene11sttranscriptcluster","hugene11sttranscriptcluster","IlluminaHumanMethylation27k","IlluminaHumanMethylation450k","illuminaHumanv2",
			"illuminaHumanv3","illuminaHumanv4","mgu74a","mgu74av2","mgu74b","mgu74bv2","mgu74c","mgu74cv2","moe430a","mogene10sttranscriptcluster",
			"mouse4302","mouse430a2","mouse430a2","mu11ksuba","mu11ksubb","porcine","rae230a","rae230b","rat2302","rgu34a",
			"rgu34b","rgu34c","rnu34","u133x3p","xenopuslaevis","yeast2","ygs98","zebrafish")
			rs2<-matrix(rs,ncol=2)
			colnames(rs2)<-c("gpl","bioc_package")
			pre_rs<-data.frame(rs2)
		}
		tree_slc<-strsplit(r_choice[1],"_")
		ts_name<-tree_slc[[1]][1]
		ts_val<-as.numeric(tree_slc[[1]][2])
		if(ts_name=="Affymetrix"){
			anAffy<-ann_Affy[[ts_val]];print(anAffy)
			if(length(grep("GPL[0-9]",anAffy))==0){
				ann_pk<-anAffy
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anAffy),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_Affy[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				Identifier<-rownames(dat2Affy.m2[[ts_val]])
				Symbol<-getSYMBOL(rownames(dat2Affy.m2[[ts_val]]),db)
				genes<-as.data.frame(Symbol)
				x<-as.data.frame(cbind(rownames(genes),genes))
				y<-x[which(is.na(x$Symbol)==FALSE),]
				genes_t<-as.data.frame(y$Symbol,rownames(y))
				colnames(genes_t)<-"Symbol"
				gn_sy<-tclArray()
				for(i in 0:dim(genes_t)[1]){ for(j in 0:dim(genes_t)[2]){ 
					if(i==0){ gn_sy[[i,j]]<-colnames(genes_t)[j] } else { 
					if(j==0){ gn_sy[[i,j]]<-rownames(genes_t)[i] } else {
					tem<-genes_t[i,j]
					gn_sy[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				genes_Affy[[ts_val]]<<-genes_t
				ta_affy_genes[[ts_val]]<<-gn_sy
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Gene_Symbol"))}
				}
			}		
		}
		if(ts_name=="Agilent-OneColor"){
			anAg1<-ann_Ag1[[ts_val]]
			if(length(grep("GPL[0-9]",anAg1))==0){
				ann_pk<-anAg1
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anAg1),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_Ag1[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				Identifier<-rownames(datAgOne2.m2[[ts_val]])
				Symbol<-getSYMBOL(rownames(datAgOne2.m2[[ts_val]]),db)
				genes<-as.data.frame(Symbol)
				x<-as.data.frame(cbind(rownames(genes),genes))
				y<-x[which(is.na(x$Symbol)==FALSE),]
				genes_t<-as.data.frame(y$Symbol,rownames(y))
				colnames(genes_t)<-"Symbol"
				gn_sy<-tclArray()
				for(i in 0:dim(genes_t)[1]){ for(j in 0:dim(genes_t)[2]){ 
					if(i==0){ gn_sy[[i,j]]<-colnames(genes_t)[j] } else { 
					if(j==0){ gn_sy[[i,j]]<-rownames(genes_t)[i] } else {
					tem<-genes_t[i,j]
					gn_sy[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				genes_Ag1[[ts_val]]<<-genes_t
				ta_ag1_genes[[ts_val]]<<-gn_sy
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Gene_Symbol"))}
				}
			}		
		}
		if(ts_name=="Agilent-TwoColor"){
			anAg2<-ann_Ag2[[ts_val]]
			if(length(grep("GPL[0-9]",anAg2))==0){
				ann_pk<-anAg2
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anAg2),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_Ag2[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				Identifier<-rownames(datAgTwo2.m2[[ts_val]])
				Symbol<-getSYMBOL(rownames(datAgTwo2.m2[[ts_val]]),db)
				genes<-as.data.frame(Symbol)
				x<-as.data.frame(cbind(rownames(genes),genes))
				y<-x[which(is.na(x$Symbol)==FALSE),]
				genes_t<-as.data.frame(y$Symbol,rownames(y))
				colnames(genes_t)<-"Symbol"
				gn_sy<-tclArray()
				for(i in 0:dim(genes_t)[1]){ for(j in 0:dim(genes_t)[2]){ 
					if(i==0){ gn_sy[[i,j]]<-colnames(genes_t)[j] } else { 
					if(j==0){ gn_sy[[i,j]]<-rownames(genes_t)[i] } else {
					tem<-genes_t[i,j]
					gn_sy[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				genes_Ag2[[ts_val]]<<-genes_t
				ta_ag2_genes[[ts_val]]<<-gn_sy
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Gene_Symbol"))}
				}
			}		
		}
		if(ts_name=="Illumina-Beadarray"){
			anIl_B<-ann_Il_B[[ts_val]]
			if(length(grep("GPL[0-9]",anIl_B))==0){
				ann_pk<-anIl_B
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anIl_B),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_Il_B[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				Identifier<-rownames(datIllBA2.m2[[ts_val]])
				Symbol<-getSYMBOL(rownames(datIllBA2.m2[[ts_val]]),db)
				genes<-as.data.frame(Symbol)
				x<-as.data.frame(cbind(rownames(genes),genes))
				y<-x[which(is.na(x$Symbol)==FALSE),]
				genes_t<-as.data.frame(y$Symbol,rownames(y))
				colnames(genes_t)<-"Symbol"
				gn_sy<-tclArray()
				for(i in 0:dim(genes_t)[1]){ for(j in 0:dim(genes_t)[2]){ 
					if(i==0){ gn_sy[[i,j]]<-colnames(genes_t)[j] } else { 
					if(j==0){ gn_sy[[i,j]]<-rownames(genes_t)[i] } else {
					tem<-genes_t[i,j]
					gn_sy[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				genes_Il_B[[ts_val]]<<-genes_t
				ta_ilb_genes[[ts_val]]<<-gn_sy
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Gene_Symbol"))}
				}
			}		
		}
		if(ts_name=="Illumina-Lumi"){
			anIl_L<-ann_Il_L[[ts_val]]
			if(length(grep("GPL[0-9]",anIl_L))==0){
				ann_pk<-anIl_L
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anIl_L),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_Il_L[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				Identifier<-rownames(lumi_NQ.m2[[ts_val]])
				Symbol<-getSYMBOL(rownames(lumi_NQ.m2[[ts_val]]),db)
				genes<-as.data.frame(Symbol)
				x<-as.data.frame(cbind(rownames(genes),genes))
				y<-x[which(is.na(x$Symbol)==FALSE),]
				genes_t<-as.data.frame(y$Symbol,rownames(y))
				colnames(genes_t)<-"Symbol"
				gn_sy<-tclArray()
				for(i in 0:dim(genes_t)[1]){ for(j in 0:dim(genes_t)[2]){ 
					if(i==0){ gn_sy[[i,j]]<-colnames(genes_t)[j] } else { 
					if(j==0){ gn_sy[[i,j]]<-rownames(genes_t)[i] } else {
					tem<-genes_t[i,j]
					gn_sy[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				genes_Il_L[[ts_val]]<<-genes_t
				ta_ill_genes[[ts_val]]<<-gn_sy
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Gene_Symbol"))}
				}
			}		
		}
		if(ts_name=="Nimblegen"){
			anN<-ann_N[[ts_val]]
			if(length(grep("GPL[0-9]",anN))==0){
				ann_pk<-anN
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anN),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_N[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				Identifier<-rownames(data.matrix_Nimblegen2.m2[[ts_val]])
				Symbol<-getSYMBOL(rownames(data.matrix_Nimblegen2.m2[[ts_val]]),db)
				genes<-as.data.frame(Symbol)
				x<-as.data.frame(cbind(rownames(genes),genes))
				y<-x[which(is.na(x$Symbol)==FALSE),]
				genes_t<-as.data.frame(y$Symbol,rownames(y))
				colnames(genes_t)<-"Symbol"
				gn_sy<-tclArray()
				for(i in 0:dim(genes_t)[1]){ for(j in 0:dim(genes_t)[2]){ 
					if(i==0){ gn_sy[[i,j]]<-colnames(genes_t)[j] } else { 
					if(j==0){ gn_sy[[i,j]]<-rownames(genes_t)[i] } else {
					tem<-genes_t[i,j]
					gn_sy[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				genes_N[[ts_val]]<<-genes_t
				ta_nbl_genes[[ts_val]]<<-gn_sy
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Gene_Symbol"))}
				}
			}		
		}
		if(ts_name=="Series-Matrix"){
			anS<-ann_S[[ts_val]]
			if(length(grep("GPL[0-9]",anS))==0){
				ann_pk<-anS
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anS),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_S[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				Identifier<-rownames(data.matrixNorm.m2[[ts_val]])
				Symbol<-getSYMBOL(rownames(data.matrixNorm.m2[[ts_val]]),db)
				genes<-as.data.frame(Symbol)
				x<-as.data.frame(cbind(rownames(genes),genes))
				y<-x[which(is.na(x$Symbol)==FALSE),]
				genes_t<-as.data.frame(y$Symbol,rownames(y))
				colnames(genes_t)<-"Symbol"
				gn_sy<-tclArray()
				for(i in 0:dim(genes_t)[1]){ for(j in 0:dim(genes_t)[2]){ 
					if(i==0){ gn_sy[[i,j]]<-colnames(genes_t)[j] } else { 
					if(j==0){ gn_sy[[i,j]]<-rownames(genes_t)[i] } else {
					tem<-genes_t[i,j]
					gn_sy[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				genes_S[[ts_val]]<<-genes_t
				ta_smt_genes[[ts_val]]<<-gn_sy
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Gene_Symbol"))}
				}
			}		
		}
		if(ts_name=="Online-Data"){
			anO<-ann_O[[ts_val]]
			if(length(grep("GPL[0-9]",anO))==0){
				ann_pk<-anO
			} else {
				ann_pk<-pre_rs[which(pre_rs[,1]==anO),2]
				if(length(ann_pk)==0){
					tkmessageBox(title="Error",message="Annotation package not available for this platform",icon="warning",type="ok")
				} else {
					ann_O[[ts_val]]<<-ann_pk
				}
			}
			if(ann_pk!=""){
				db<-annPkgName(ann_pk)
				if(!requireNamespace(db,quietly=TRUE)){
					BiocManager::install(db,ask=FALSE,update=FALSE)
				} else {
					library(db,character.only=TRUE)
				}
				Identifier<-rownames(data.matrix_onlineNorm.m2[[ts_val]])
				Symbol<-getSYMBOL(rownames(data.matrix_onlineNorm.m2[[ts_val]]),db)
				genes<-as.data.frame(Symbol)
				x<-as.data.frame(cbind(rownames(genes),genes))
				y<-x[which(is.na(x$Symbol)==FALSE),]
				genes_t<-as.data.frame(y$Symbol,rownames(y))
				colnames(genes_t)<-"Symbol"
				gn_sy<-tclArray()
				for(i in 0:dim(genes_t)[1]){ for(j in 0:dim(genes_t)[2]){ 
					if(i==0){ gn_sy[[i,j]]<-colnames(genes_t)[j] } else { 
					if(j==0){ gn_sy[[i,j]]<-rownames(genes_t)[i] } else {
					tem<-genes_t[i,j]
					gn_sy[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
					} }
				} }
				genes_O[[ts_val]]<<-genes_t
				ta_onl_genes[[ts_val]]<<-gn_sy
				for(i in 1:length(children)){
					x<-as.character(tcl(treeview,"item",children[i],"-values"))
					if(x==r_choice[1]){p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Gene_Symbol"))}
				}
			}		
		}
	})
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.1,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,0.3,title=NULL,label="")
if(!requireNamespace("BiocManager",quietly=TRUE)){install.packages("BiocManager");library(BiocManager)} else {library(BiocManager)}
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
if(!requireNamespace("GEOmetadb",quietly=TRUE)){BiocManager::install("GEOmetadb",ask=FALSE,update=FALSE);library(GEOmetadb)} else {library(GEOmetadb)}
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
if(!requireNamespace("annotate",quietly=TRUE)){BiocManager::install("annotate",ask=FALSE,update=FALSE);library(annotate)} else {library(annotate)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("DBI",quietly=TRUE)){BiocManager::install("DBI",ask=FALSE,update=FALSE);library(DBI)} else {library(DBI)}
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
if(!requireNamespace("RSQLite",quietly=TRUE)){BiocManager::install("RSQLite",ask=FALSE,update=FALSE);library(RSQLite)} else {library(RSQLite)}
setTkProgressBar(pb_ma,1,title="Done...",label="")		
close(pb_ma)
symbol()

qlchk<-function(h,...){
	r_choice="._."
	children<-as.character(tcl(treeview,"children",""))
	w_analz<-tktoplevel()
	w_analz_frame<-ttkframe(w_analz,padding=c(3,3,50,20),borderwidth=1,relief="groove")
	tkpack(w_analz_frame,expand=TRUE,fill="both",side="left")
	var<-tclVar(tree_prnts[1])
	sapply(tree_prnts,function(i){
		r_but_vals<-ttkradiobutton(w_analz_frame,variable=var,text=i,value=i)
		tkpack(r_but_vals,side="top",anchor="w")
	})
	tkpack(ttklabel(w_analz_frame,text=''))
	tkpack(ttklabel(w_analz_frame,text=''))
	r_but<-ttkbutton(w_analz_frame,text="Ok")
	tkpack(r_but,pady=2)
	tkconfigure(r_but,command=function(){
		r_choice<-tclvalue(var)
		tkwm.withdraw(w_analz)
		tree_slc<-strsplit(r_choice[1],"_")
		ts_name<-tree_slc[[1]][1]
		ts_val<-as.numeric(tree_slc[[1]][2])
	
		if(ts_name=="Affymetrix"){
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){boxplot(dat2Affy.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			} else {
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(dat2Affy.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				tkpack(ma_frame2)			
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...QC"))
			}
		}
		if(ts_name=="Agilent-OneColor"){
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){boxplot(datAgOne2.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)
			} else {
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(datAgOne2.m2[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...QC"))
			}
		}
		if(ts_name=="Agilent-TwoColor"){
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){boxplot(datAgTwo2.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)
			} else {
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(datAgTwo2.m2[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...QC"))
			}
		}
		if(ts_name=="Illumina-Beadarray"){
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){boxplot(datIllBA2.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)
			} else {
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(datIllBA2.m2[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...QC"))
			}
		}
		if(ts_name=="Illumina-Lumi"){
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){boxplot(lumi_NQ.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)
			} else {
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(lumi_NQ.m2[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...QC"))
			}
		}
		if(ts_name=="Nimblegen"){
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){boxplot(data.matrix_Nimblegen2.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)
			} else {
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(data.matrix_Nimblegen2.m2[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...QC"))
			}
		}
		if(ts_name=="Series-Matrix"){
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){boxplot(data.matrixNorm.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)
			} else {
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(data.matrixNorm.m2[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...QC"))
			}
		}
		if(ts_name=="Online-Data"){
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){boxplot(data.matrix_onlineNorm.m2[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)
			} else {
				ma_img2<<-tkrreplot(ma_img,function(...){boxplot(data.matrix_onlineNorm.m2[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...QC"))
			}
		}
	})
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
qlchk()

graph_gsea_kegg<-function(h,...){

	graph_gsea_kegg_params<-function(h,h2,h3,h4,h5,h6,h7,...){
		ts_name=h;ts_val=h2;ann_pk=h3;kegg_id=h4;DE=h5;children=h6;r_choice=h7;
pb_ma<-tkProgressBar(title="Graph GSEA KEGG Pathway...",label="",min=0,max=1,initial=0.1,width=500)
setTkProgressBar(pb_ma,0.1,title=NULL,label="")
		ar<-18
		cols<-colorRampPalette(c("Green", "Red"))(ar)
		db<-"graph"
		try(library(db,character.only=TRUE),silent=TRUE)
		org_name<-db_bioc_org[which(db_bioc_org$db_bioc==ann_pk),]$db_org
		org_code<-db_code[grep(org_name,db_code$"Organism Name"),]$"Organism Code"
		tmp_kegg<-paste(tempfile(),"xml",sep=".")
		tmp_kegg2<-retrieveKGML(kegg_id,organism=org_code,destfile=tmp_kegg,method="wget",quiet=TRUE)
		err<-try(mapkG<-parseKGML2Graph(tmp_kegg,expandGenes=TRUE,genesOnly=TRUE),silent=TRUE)
		try({
			if(length(grep("Error",err))!=0){
				mapkG<-parseKGML2Graph(tmp_kegg2,expandGenes=TRUE,genesOnly=TRUE)
			}
		},silent=TRUE)
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
		ids<-rownames(DE)
		entrez_id<-paste(ann_pk,"ENTREZID",sep="")
		allg<-get(entrez_id)
		allg<-as.data.frame(unlist(as.list(allg)))
		myids<-allg[ids,]
		ENTREZ<-data.frame(cbind(ids,myids))
		colnames(ENTREZ)<-c("PROBEID","ENTREZID")
		top.Cell<-cbind(DE,ENTREZ=ENTREZ$ENTREZID)
		top.Cell<-top.Cell[which(!(is.na(top.Cell$ENTREZ))==TRUE),]
		BT_all<-as.character(top.Cell$ENTREZ)
		tg<-top.Cell[top.Cell$adj.P.Val<0.05,]
		BT_sig<-tg$logFC
		names(BT_sig)<-as.vector(tg$ENTREZ)
		isDiffExp<-gsub(paste(org_code,":",sep=""),"",nodes(mapkG)) %in% names(BT_sig)
		logfcs<-BT_sig[match(gsub(paste(org_code,":",sep=""),"",nodes(mapkG)),names(BT_sig))]
		names(logfcs)<-nodes(mapkG)
		logfcs[is.na(logfcs)]<-0
		incol<-round((logfcs+5)*3)
		incol[incol>ar]<-ar
		undetected<-!gsub(paste(org_code,":",sep=""),"",nodes(mapkG)) %in% BT_all
		logcol<-cols[incol]
		logcol[logfcs==0]<-"darkgrey"
		logcol[undetected]<-"white"
		names(logcol)<-names(logfcs)
		mapkG_gsea_kegg<-mapkG
		logcol_gsea_kegg<-logcol
		nA<-makeNodeAttrs(mapkG,fillcolor=logcol,width=10,height=1.2)
		oldpar<-par(no.readonly=TRUE)
		on.exit(par(oldpar))
		par(mar=c(3,5,0,5),mgp=c(0,0,0))
		layout(mat=matrix(c(rep(1,8),2),ncol=1,byrow=TRUE))
		graph_gsea_kegg<-plot(mapkG,"dot",nodeAttrs=nA)
setTkProgressBar(pb_ma,0.8,title=NULL,label="")
		image(as.matrix(seq(1,ar)),col=cols,yaxt="n",xaxt="n")
		mtext("down-regulation",side=1,at=0,line=1)
		mtext("up-regulation",side=1,at=1,line=1)
		legend<-data.frame(cbind(logcol,logfcs))
		legend_gsea_kegg<-legend
		colnames(legend_gsea_kegg)<-c("Node_Color","logFC")		
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
		ta_legend_gsea_kegg<-tclArray()
		for(i in 0:dim(legend_gsea_kegg)[1]){ for(j in 0:dim(legend_gsea_kegg)[2]){ 
			if(i==0){ ta_legend_gsea_kegg[[i,j]]<-colnames(legend_gsea_kegg)[j] } else { 
			if(j==0){ ta_legend_gsea_kegg[[i,j]]<-rownames(legend_gsea_kegg)[i] } else {
			tem<-legend_gsea_kegg[i,j]
			ta_legend_gsea_kegg[[i,j]]<-ifelse(is.na(tem),".",ifelse(is.numeric(tem),round(tem,digits=5),as.character(tem)))
			} }
		} }
setTkProgressBar(pb_ma,1,title="Completed...",label="")	
close(pb_ma)
		if(ts_name=="Affymetrix"){
			graph_gsea_KEGG_Affy[[ts_val]]<<-mapkG
			nodefill_gsea_KEGG_Affy[[ts_val]]<<-logcol
			legend_gsea_KEGG_Affy[[ts_val]]<<-legend_gsea_kegg
			ta_affy_legend_gsea_kegg[[ts_val]]<<-ta_legend_gsea_kegg
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsea_KEGG_Affy[[ts_val]],nodeAttrs=nA)},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsea_KEGG_Affy[[ts_val]],nodeAttrs=nA)},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSEA_KEGG_Graph"))
			}
			legend_tab(ta_affy_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_Affy[[ts_val]]),ncol(legend_gsea_KEGG_Affy[[ts_val]]),"GSEA_KEGG_Graph_Legend")

		}
		if(ts_name=="Agilent-OneColor"){
			graph_gsea_KEGG_Ag1[[ts_val]]<<-mapkG
			nodefill_gsea_KEGG_Ag1[[ts_val]]<<-logcol
			legend_gsea_KEGG_Ag1[[ts_val]]<<-legend_gsea_kegg
			ta_ag1_legend_gsea_kegg[[ts_val]]<<-ta_legend_gsea_kegg
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsea_KEGG_Ag1[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsea_KEGG_Ag1[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSEA_KEGG_Graph"))
			}
			legend_tab(ta_ag1_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_Ag1[[ts_val]]),ncol(legend_gsea_KEGG_Ag1[[ts_val]]),"GSEA_KEGG_Graph_Legend")

		}
		if(ts_name=="Agilent-TwoColor"){
			graph_gsea_KEGG_Ag2[[ts_val]]<<-mapkG
			nodefill_gsea_KEGG_Ag2[[ts_val]]<<-logcol
			legend_gsea_KEGG_Ag2[[ts_val]]<<-legend_gsea_kegg
			ta_ag2_legend_gsea_kegg[[ts_val]]<<-ta_legend_gsea_kegg
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsea_KEGG_Ag2[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsea_KEGG_Ag2[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSEA_KEGG_Graph"))
			}
			legend_tab(ta_ag2_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_Ag2[[ts_val]]),ncol(legend_gsea_KEGG_Ag2[[ts_val]]),"GSEA_KEGG_Graph_Legend")

		}
		if(ts_name=="Illumina-Beadarray"){
			graph_gsea_KEGG_Il_B[[ts_val]]<<-mapkG
			nodefill_gsea_KEGG_Il_B[[ts_val]]<<-logcol
			legend_gsea_KEGG_Il_B[[ts_val]]<<-legend_gsea_kegg
			ta_ilb_legend_gsea_kegg[[ts_val]]<<-ta_legend_gsea_kegg
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsea_KEGG_Il_B[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsea_KEGG_Il_B[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSEA_KEGG_Graph"))
			}
			legend_tab(ta_ilb_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_Il_B[[ts_val]]),ncol(legend_gsea_KEGG_Il_B[[ts_val]]),"GSEA_KEGG_Graph_Legend")

		}
		if(ts_name=="Illumina-Lumi"){
			graph_gsea_KEGG_Il_L[[ts_val]]<<-mapkG
			nodefill_gsea_KEGG_Il_L[[ts_val]]<<-logcol
			legend_gsea_KEGG_Il_L[[ts_val]]<<-legend_gsea_kegg
			ta_ill_legend_gsea_kegg[[ts_val]]<<-ta_legend_gsea_kegg
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsea_KEGG_Il_L[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsea_KEGG_Il_L[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSEA_KEGG_Graph"))
			}
			legend_tab(ta_ill_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_Il_L[[ts_val]]),ncol(legend_gsea_KEGG_Il_L[[ts_val]]),"GSEA_KEGG_Graph_Legend")

		}
		if(ts_name=="Nimblegen"){
			graph_gsea_KEGG_N[[ts_val]]<<-mapkG
			nodefill_gsea_KEGG_N[[ts_val]]<<-logcol
			legend_gsea_KEGG_N[[ts_val]]<<-legend_gsea_kegg
			ta_nbl_legend_gsea_kegg[[ts_val]]<<-ta_legend_gsea_kegg
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsea_KEGG_N[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsea_KEGG_N[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSEA_KEGG_Graph"))
			}
			legend_tab(ta_nbl_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_N[[ts_val]]),ncol(legend_gsea_KEGG_N[[ts_val]]),"GSEA_KEGG_Graph_Legend")

		}
		if(ts_name=="Series-Matrix"){
			graph_gsea_KEGG_S[[ts_val]]<<-mapkG
			nodefill_gsea_KEGG_S[[ts_val]]<<-logcol
			legend_gsea_KEGG_S[[ts_val]]<<-legend_gsea_kegg
			ta_smt_legend_gsea_kegg[[ts_val]]<<-ta_legend_gsea_kegg
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsea_KEGG_S[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsea_KEGG_S[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSEA_KEGG_Graph"))
			}
			legend_tab(ta_smt_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_S[[ts_val]]),ncol(legend_gsea_KEGG_S[[ts_val]]),"GSEA_KEGG_Graph_Legend")

		}
		if(ts_name=="Online-Data"){
			graph_gsea_KEGG_O[[ts_val]]<<-mapkG
			nodefill_gsea_KEGG_O[[ts_val]]<<-logcol
			legend_gsea_KEGG_O[[ts_val]]<<-legend_gsea_kegg
			ta_onl_legend_gsea_kegg[[ts_val]]<<-ta_legend_gsea_kegg
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){plot(graph_gsea_KEGG_O[[ts_val]])},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){plot(graph_gsea_KEGG_O[[ts_val]])},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...GSEA_KEGG_Graph"))
			}
			legend_tab(ta_onl_legend_gsea_kegg[[ts_val]],nrow(legend_gsea_KEGG_O[[ts_val]]),ncol(legend_gsea_KEGG_O[[ts_val]]),"GSEA_KEGG_Graph_Legend")

		}
	}
		
	db_bioc<-c("mgu74a","mgu74b","mgu74c","ag","drosgenome1","hcg110","mu11ksuba","mu11ksubb","mu19ksuba","mu19ksubb","mu19ksubc","hu6800","mgu74av2","mgu74bv2","mgu74cv2","rgu34a","rgu34b","rgu34c","rnu34","rtu34","ygs98","hgu95av2","hgu95b","hgu95c","hgu95d","hgu95e","hgu133a","hgu133b","hu35ksuba","hu35ksubb","hu35ksubc","hu35ksubd","ath1121501","ecoli2","celegans","hgfocus","moe430a","mouse4302","rae230a","rae230b","hgu133plus2","hgu133a2","hgug4111a","hgug4110b","mouse430a2","xenopuslaevis","zebrafish","drosophila2","u133x3p","rat2302","hgug4112a","bovine","yeast2","yeast2","h20kcod","adme16cod","ecoli2","chicken","porcine","canine2","hthgu133a","canine","h10kcod","hgug4100a","illuminaHumanv1","illuminaHumanv2","hugene10sttranscriptcluster","illuminaHumanv3","hgu95av2","IlluminaHumanMethylation27k","illuminaHumanv4","hugene11sttranscriptcluster","HsAgilentDesign026652","IlluminaHumanMethylation450k","hgu219","GGHumanMethCancerPanelv1","hthgu133b","hthgu133a")
	db_org<-c("Mus musculus","Mus musculus","Mus musculus","Arabidopsis thaliana","Drosophila melanogaster","Homo sapiens","Mus musculus","Mus musculus","Mus musculus","Mus musculus","Mus musculus","Homo sapiens","Mus musculus","Mus musculus","Mus musculus","Rattus norvegicus","Rattus norvegicus","Rattus norvegicus","Rattus norvegicus","Rattus norvegicus","Saccharomyces cerevisiae","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Arabidopsis thaliana","Escherichia coli K-12","Caenorhabditis elegans","Homo sapiens","Mus musculus","Mus musculus","Rattus norvegicus","Rattus norvegicus","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Mus musculus","Xenopus laevis","Danio rerio","Drosophila melanogaster","Homo sapiens","Rattus norvegicus","Homo sapiens","Bos taurus","Schizosaccharomyces pombe","Saccharomyces cerevisiae","Homo sapiens","Rattus norvegicus","Escherichia coli","Gallus gallus","Sus scrofa","Canis lupus familiaris","Homo sapiens","Canis lupus familiaris","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens","Homo sapiens")
	kegg_info<-c("Mus musculus (mouse)","Arabidopsis thaliana (thale cress)","Drosophila melanogaster (fruit fly)","Wolbachia wMel (Drosophila melanogaster)","Homo sapiens (human)","Rattus norvegicus (rat)","Saccharomyces cerevisiae (budding yeast)","Escherichia coli K-12 MG1655","Escherichia coli K-12 W3110","Escherichia coli K-12 DH10B","Escherichia coli K-12 MDS42","Caenorhabditis elegans (nematode)","Xenopus laevis (African clawed frog)","Danio rerio (zebrafish)","Bos taurus (cow)","Schizosaccharomyces pombe (fission yeast)","Escherichia coli BW2952","Escherichia coli O157:H7 EDL933 (EHEC)","Escherichia coli O157:H7 Sakai (EHEC)","Escherichia coli O157:H7 EC4115 (EHEC)","Escherichia coli O157:H7 TW14359 (EHEC)","Escherichia coli O157:H7 Xuzhou21 (EHEC)","Escherichia coli O26:H11 11368 (EHEC)","Escherichia coli O111:H- 11128 (EHEC)","Escherichia coli O103:H2 12009 (EHEC)","Escherichia coli O127:H6 E2348/69 (EPEC)","Escherichia coli O55:H7 CB9615 (EPEC)","Escherichia coli O55:H7 RM12579 (EPEC)","Escherichia coli O6:K2:H1 CFT073 (UPEC)","Escherichia coli O6:K15:H31 536 (UPEC)","Escherichia coli O18:K1:H7 UTI89 (UPEC)","Escherichia coli APEC O1 (APEC)","Escherichia coli O9 HS (commensal)","Escherichia coli E24377A (ETEC)","Escherichia coli SMS-3-5 (environmental)","Escherichia coli O152:H28 SE11 (commensal)","Escherichia coli O8 IAI1 (commensal)","Escherichia coli O81 ED1a (commensal)","Escherichia coli 55989 (EAEC)","Escherichia coli O7:K1 IAI39 (ExPEC)","Escherichia coli O7:K1 CE10","Escherichia coli O17:K52:H18 UMN026 (ExPEC)","Escherichia coli O45:K1:H7 S88 (ExPEC)","Escherichia coli O44:H18 042 (EAEC)","Escherichia coli O83:H1 NRG 857C","Escherichia coli O78:H11:K80 H10407 (ETEC)","Escherichia coli O150:H5 SE15 (commensal)","Escherichia coli O104:H4 2009EL-2071","Escherichia coli O104:H4 2009EL-2050","Escherichia coli O104:H4 2011C-3493","Escherichia coli ATCC 8739","Escherichia coli B REL606","Escherichia coli BL21-Gold(DE3)pLysS AG","Escherichia coli KO11FL","Escherichia coli KO11FL","Escherichia coli ABU 83972","Escherichia coli DH1","Escherichia coli DH1","Escherichia coli IHE3034","Escherichia coli NA114 (UPEC)","Escherichia coli UM146","Escherichia coli UMNK88","Escherichia coli W","Escherichia coli W","Escherichia coli clone D i14","Escherichia coli clone D i2","Escherichia coli P12b","Escherichia coli BL21(DE3)","Escherichia coli BL21(DE3)","Escherichia coli LF82","Escherichia coli APEC O78","Escherichia coli LY180","Escherichia coli PMV-1","Escherichia coli JJ1886","Escherichia coli O145:H28 RM13514 (EHEC)","Escherichia coli O145:H28 RM13516 (EHEC)","Escherichia coli O25b:K100:H4-ST131 EC958 (UPEC)","Gallus gallus (chicken)","Sus scrofa (pig)","mmu","ath","dme","wol","hsa","rno","sce","eco","ecj","ecd","ecok","cel","xla","dre","bta","spo","ebw","ece","ecs",
"ecf","etw","elx","eoj","eoi","eoh","ecg","eok","elr","ecc","ecp","eci","ecv","ecx","ecw","ecm","ecy","ecr","ecq","eck","ect","eoc","eum","ecz","elo","eln",
"elh","ese","eso","esm","esl","ecl","ebr","ebd","eko","ekf","eab","edh","edj","eih","ena","elu","eun","elw","ell","elc","eld","elp","ebl","ebe","elf","ecoa",
"ecol","ecoi","ecoj","ecoo","ecoh","ecos","gga","ssc")
	db_code<-data.frame(kegg_info[1:79],kegg_info[80:158])
	colnames(db_code)<-c("Organism Name","Organism Code")	
	db_bioc_org<-data.frame(cbind(db_bioc,db_org))
	ar<-18
	cols<-colorRampPalette(c("Green", "Red"))(ar)

	r_choice="._."
	children<-as.character(tcl(treeview,"children",""))
	w_analz<-tktoplevel()
	w_analz_frame<-ttkframe(w_analz,padding=c(3,3,50,20),borderwidth=1,relief="groove")
	tkpack(w_analz_frame,expand=TRUE,fill="both",side="left")
	var<-tclVar(tree_prnts[1])
	sapply(tree_prnts,function(i){
		r_but_vals<-ttkradiobutton(w_analz_frame,variable=var,text=i,value=i)
		tkpack(r_but_vals,side="top",anchor="w")
	})
	tkpack(ttklabel(w_analz_frame,text=''))
	tkpack(ttklabel(w_analz_frame,text=''))
	r_but<-ttkbutton(w_analz_frame,text="Ok")
	tkpack(r_but,pady=2)
	tkconfigure(r_but,command=function(){
		r_choice<-tclvalue(var)
		tkwm.withdraw(w_analz)
		tree_slc<-strsplit(r_choice[1],"_")
		ts_name<-tree_slc[[1]][1]
		ts_val<-as.numeric(tree_slc[[1]][2])
		w_imp<-tktoplevel()
		tkwm.title(w_imp,"Select P-value")
		tkwm.resizable(w_imp,0,0)
		frame_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		tkpack(ttklabel(frame_imp,text='P-value'),side="left",padx=12)
		p_list<-c(1,0.5,0.1,0.05,0.01,0.001,0.0001,0.00001,0.0000000001,0)
		p_value<-tclVar(p_list[4])
		p_comb<-ttkcombobox(frame_imp,values=p_list,textvariable=p_value,state="normal",justify="left",width=7)
		tkpack(p_comb,side="left",padx=33)
		tkpack(frame_imp,expand=TRUE,fill="both",side="top")
		frame2_imp<-ttkframe(w_imp,padding=c(3,3,12,12))
		r_but1<-ttkbutton(frame2_imp,text="Ok")
		tkpack(r_but1,side="right",padx=12)
		tkpack(frame2_imp,expand=TRUE,fill="both",side="top")
		tkconfigure(r_but1,command=function(){
			tkwm.withdraw(w_imp)
			p_v<-as.numeric(tclvalue(p_value))
			if(ts_name=="Affymetrix"){
				KEGG.vec<-rownames(KEGGresult_Affy[[ts_val]])[KEGGresult_Affy[[ts_val]]$Pvalue<=p_v]
				w_imp2<-tktoplevel()
				tkwm.title(w_imp2,"Select KEGG ID")
				tkwm.resizable(w_imp2,0,0)
				frame_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				tkpack(ttklabel(frame_imp2,text='KEGG ID'),side="left",padx=12)
				kids<-tclVar(KEGG.vec[1])
				k_comb<-ttkcombobox(frame_imp2,values=KEGG.vec,textvariable=kids,state="normal",justify="left",width=7)
				tkpack(k_comb,side="left",padx=33)
				tkpack(frame_imp2,expand=TRUE,fill="both",side="top")
				frame2_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				r_but2<-ttkbutton(frame2_imp2,text="Ok")
				tkpack(r_but2,side="right",padx=12)
				tkpack(frame2_imp2,expand=TRUE,fill="both",side="top")
				tkconfigure(r_but2,command=function(){
					tkwm.withdraw(w_imp2)
					kegg_id<-tclvalue(kids)
					graph_gsea_kegg_params(ts_name,ts_val,ann_Affy[[ts_val]],kegg_id,DE_Affy_2[[ts_val]],children,r_choice)
				})
			}
			if(ts_name=="Agilent-OneColor"){
				KEGG.vec<-rownames(KEGGresult_Ag1[[ts_val]])[KEGGresult_Ag1[[ts_val]]$Pvalue<=p_v]
				w_imp2<-tktoplevel()
				tkwm.title(w_imp2,"Select KEGG ID")
				tkwm.resizable(w_imp2,0,0)
				frame_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				tkpack(ttklabel(frame_imp2,text='KEGG ID'),side="left",padx=12)
				kids<-tclVar(KEGG.vec[1])
				k_comb<-ttkcombobox(frame_imp2,values=KEGG.vec,textvariable=kids,state="normal",justify="left",width=7)
				tkpack(k_comb,side="left",padx=33)
				tkpack(frame_imp2,expand=TRUE,fill="both",side="top")
				frame2_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				r_but2<-ttkbutton(frame2_imp2,text="Ok")
				tkpack(r_but2,side="right",padx=12)
				tkpack(frame2_imp2,expand=TRUE,fill="both",side="top")
				tkconfigure(r_but2,command=function(){
					tkwm.withdraw(w_imp2)
					kegg_id<-tclvalue(kids)
					graph_gsea_kegg_params(ts_name,ts_val,ann_Ag1[[ts_val]],kegg_id,DE_Ag1_2[[ts_val]],children,r_choice)
				})
			}
			if(ts_name=="Agilent-TwoColor"){
				KEGG.vec<-rownames(KEGGresult_Ag2[[ts_val]])[KEGGresult_Ag2[[ts_val]]$Pvalue<=p_v]
				w_imp2<-tktoplevel()
				tkwm.title(w_imp2,"Select KEGG ID")
				tkwm.resizable(w_imp2,0,0)
				frame_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				tkpack(ttklabel(frame_imp2,text='KEGG ID'),side="left",padx=12)
				kids<-tclVar(KEGG.vec[1])
				k_comb<-ttkcombobox(frame_imp2,values=KEGG.vec,textvariable=kids,state="normal",justify="left",width=7)
				tkpack(k_comb,side="left",padx=33)
				tkpack(frame_imp2,expand=TRUE,fill="both",side="top")
				frame2_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				r_but2<-ttkbutton(frame2_imp2,text="Ok")
				tkpack(r_but2,side="right",padx=12)
				tkpack(frame2_imp2,expand=TRUE,fill="both",side="top")
				tkconfigure(r_but2,command=function(){
					tkwm.withdraw(w_imp2)
					kegg_id<-tclvalue(kids)
					graph_gsea_kegg_params(ts_name,ts_val,ann_Ag2[[ts_val]],kegg_id,DE_Ag2_2[[ts_val]],children,r_choice)
				})
			}
			if(ts_name=="Illumina-Beadarray"){
				KEGG.vec<-rownames(KEGGresult_Il_B[[ts_val]])[KEGGresult_Il_B[[ts_val]]$Pvalue<=p_v]
				w_imp2<-tktoplevel()
				tkwm.title(w_imp2,"Select KEGG ID")
				tkwm.resizable(w_imp2,0,0)
				frame_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				tkpack(ttklabel(frame_imp2,text='KEGG ID'),side="left",padx=12)
				kids<-tclVar(KEGG.vec[1])
				k_comb<-ttkcombobox(frame_imp2,values=KEGG.vec,textvariable=kids,state="normal",justify="left",width=7)
				tkpack(k_comb,side="left",padx=33)
				tkpack(frame_imp2,expand=TRUE,fill="both",side="top")
				frame2_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				r_but2<-ttkbutton(frame2_imp2,text="Ok")
				tkpack(r_but2,side="right",padx=12)
				tkpack(frame2_imp2,expand=TRUE,fill="both",side="top")
				tkconfigure(r_but2,command=function(){
					tkwm.withdraw(w_imp2)
					kegg_id<-tclvalue(kids)
					graph_gsea_kegg_params(ts_name,ts_val,ann_Il_B[[ts_val]],kegg_id,DE_Il_B_2[[ts_val]],children,r_choice)
				})
			}
			if(ts_name=="Illumina-Lumi"){
				KEGG.vec<-rownames(KEGGresult_Il_L[[ts_val]])[KEGGresult_Il_L[[ts_val]]$Pvalue<=p_v]
				w_imp2<-tktoplevel()
				tkwm.title(w_imp2,"Select KEGG ID")
				tkwm.resizable(w_imp2,0,0)
				frame_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				tkpack(ttklabel(frame_imp2,text='KEGG ID'),side="left",padx=12)
				kids<-tclVar(KEGG.vec[1])
				k_comb<-ttkcombobox(frame_imp2,values=KEGG.vec,textvariable=kids,state="normal",justify="left",width=7)
				tkpack(k_comb,side="left",padx=33)
				tkpack(frame_imp2,expand=TRUE,fill="both",side="top")
				frame2_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				r_but2<-ttkbutton(frame2_imp2,text="Ok")
				tkpack(r_but2,side="right",padx=12)
				tkpack(frame2_imp2,expand=TRUE,fill="both",side="top")
				tkconfigure(r_but2,command=function(){
					tkwm.withdraw(w_imp2)
					kegg_id<-tclvalue(kids)
					graph_gsea_kegg_params(ts_name,ts_val,ann_Il_L[[ts_val]],kegg_id,DE_Il_L_2[[ts_val]],children,r_choice)
				})
			}
			if(ts_name=="Nimblegen"){
				KEGG.vec<-rownames(KEGGresult_N[[ts_val]])[KEGGresult_N[[ts_val]]$Pvalue<=p_v]
				w_imp2<-tktoplevel()
				tkwm.title(w_imp2,"Select KEGG ID")
				tkwm.resizable(w_imp2,0,0)
				frame_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				tkpack(ttklabel(frame_imp2,text='KEGG ID'),side="left",padx=12)
				kids<-tclVar(KEGG.vec[1])
				k_comb<-ttkcombobox(frame_imp2,values=KEGG.vec,textvariable=kids,state="normal",justify="left",width=7)
				tkpack(k_comb,side="left",padx=33)
				tkpack(frame_imp2,expand=TRUE,fill="both",side="top")
				frame2_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				r_but2<-ttkbutton(frame2_imp2,text="Ok")
				tkpack(r_but2,side="right",padx=12)
				tkpack(frame2_imp2,expand=TRUE,fill="both",side="top")
				tkconfigure(r_but2,command=function(){
					tkwm.withdraw(w_imp2)
					kegg_id<-tclvalue(kids)
					graph_gsea_kegg_params(ts_name,ts_val,ann_N[[ts_val]],kegg_id,DE_N_2[[ts_val]],children,r_choice)
				})
			}
			if(ts_name=="Series-Matrix"){
				KEGG.vec<-rownames(KEGGresult_S[[ts_val]])[KEGGresult_S[[ts_val]]$Pvalue<=p_v]
				w_imp2<-tktoplevel()
				tkwm.title(w_imp2,"Select KEGG ID")
				tkwm.resizable(w_imp2,0,0)
				frame_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				tkpack(ttklabel(frame_imp2,text='KEGG ID'),side="left",padx=12)
				kids<-tclVar(KEGG.vec[1])
				k_comb<-ttkcombobox(frame_imp2,values=KEGG.vec,textvariable=kids,state="normal",justify="left",width=7)
				tkpack(k_comb,side="left",padx=33)
				tkpack(frame_imp2,expand=TRUE,fill="both",side="top")
				frame2_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				r_but2<-ttkbutton(frame2_imp2,text="Ok")
				tkpack(r_but2,side="right",padx=12)
				tkpack(frame2_imp2,expand=TRUE,fill="both",side="top")
				tkconfigure(r_but2,command=function(){
					tkwm.withdraw(w_imp2)
					kegg_id<-tclvalue(kids)
					graph_gsea_kegg_params(ts_name,ts_val,ann_S[[ts_val]],kegg_id,DE_S_2[[ts_val]],children,r_choice)
				})
			}
			if(ts_name=="Online-Data"){
				KEGG.vec<-rownames(KEGGresult_O[[ts_val]])[KEGGresult_O[[ts_val]]$Pvalue<=p_v]
				w_imp2<-tktoplevel()
				tkwm.title(w_imp2,"Select KEGG ID")
				tkwm.resizable(w_imp2,0,0)
				frame_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				tkpack(ttklabel(frame_imp2,text='KEGG ID'),side="left",padx=12)
				kids<-tclVar(KEGG.vec[1])
				k_comb<-ttkcombobox(frame_imp2,values=KEGG.vec,textvariable=kids,state="normal",justify="left",width=7)
				tkpack(k_comb,side="left",padx=33)
				tkpack(frame_imp2,expand=TRUE,fill="both",side="top")
				frame2_imp2<-ttkframe(w_imp2,padding=c(3,3,12,12))
				r_but2<-ttkbutton(frame2_imp2,text="Ok")
				tkpack(r_but2,side="right",padx=12)
				tkpack(frame2_imp2,expand=TRUE,fill="both",side="top")
				tkconfigure(r_but2,command=function(){
					tkwm.withdraw(w_imp2)
					kegg_id<-tclvalue(kids)
					graph_gsea_kegg_params(ts_name,ts_val,ann_O[[ts_val]],kegg_id,DE_O_2[[ts_val]],children,r_choice)
				})
			}	
		})
	})
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.4,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,0.5,title=NULL,label="")
if(!requireNamespace("BiocManager",quietly=TRUE)){install.packages("BiocManager");library(BiocManager)} else {library(BiocManager)}
setTkProgressBar(pb_ma,0.7,title=NULL,label="")
if(!requireNamespace("graph",quietly=TRUE)){ BiocManager::install("graph",ask=FALSE,update=FALSE);library(graph) }else{ library(graph) }
setTkProgressBar(pb_ma,0.9,title=NULL,label="")
if(!requireNamespace("KEGGgraph",quietly=TRUE)){ BiocManager::install("KEGGgraph",ask=FALSE,update=FALSE);library(KEGGgraph) }else{ library(KEGGgraph) }
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
graph_gsea_kegg()

clas<-function(h,...){
	r_choice="._."
	children<-as.character(tcl(treeview,"children",""))
	w_analz<-tktoplevel()
	w_analz_frame<-ttkframe(w_analz,padding=c(3,3,50,20),borderwidth=1,relief="groove")
	tkpack(w_analz_frame,expand=TRUE,fill="both",side="left")
	var<-tclVar(tree_prnts[1])
	sapply(tree_prnts,function(i){
		r_but_vals<-ttkradiobutton(w_analz_frame,variable=var,text=i,value=i)
		tkpack(r_but_vals,side="top",anchor="w")
	})
	tkpack(ttklabel(w_analz_frame,text=''))
	tkpack(ttklabel(w_analz_frame,text=''))
	r_but<-ttkbutton(w_analz_frame,text="Ok")
	tkpack(r_but,pady=2)
	tkconfigure(r_but,command=function(){
		r_choice<-tclvalue(var)
		tkwm.withdraw(w_analz)
		tree_slc<-strsplit(r_choice[1],"_")
		ts_name<-tree_slc[[1]][1]
		ts_val<-as.numeric(tree_slc[[1]][2])
	
		if(ts_name=="Affymetrix"){
			DE_Affy<-DE_Affy_2[[ts_val]]
			er_x<-try(DE_Affy<-as.matrix(DE_Affy),silent=TRUE)
			if(length(grep("Error",er_x))!=0)
			{
				rownames(DE_Affy)<-as.character(DE_Affy)
				DE_Affy<-as.matrix(DE_Affy)
			}
			rnames<-rownames(DE_Affy)
			if(length(samp_Affy[[ts_val]]!=0)){
				clas_Affy[[ts_val]]<<-as.matrix(dat2Affy.m2[[ts_val]][rnames,samp_Affy[[ts_val]]])
			} else {
				clas_Affy[[ts_val]]<<-as.matrix(dat2Affy.m2[[ts_val]][rnames,])
			}
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){
					heatmap(clas_Affy[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_Affy[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Classification"))
			}
		}
		if(ts_name=="Agilent-OneColor"){
			DE_Ag1<-DE_Ag1_2[[ts_val]]
			er_x<-try(DE_Ag1<-as.matrix(DE_Ag1),silent=TRUE)
			if(length(grep("Error",er_x))!=0)
			{
				rownames(DE_Ag1)<-as.character(DE_Ag1)
				DE_Ag1<-as.matrix(DE_Ag1)
			}
			rnames<-rownames(DE_Ag1)
			if(length(samp_Ag1[[ts_val]]!=0)){
				clas_Ag1[[ts_val]]<<-as.matrix(datAgOne2.m2[[ts_val]][rnames,samp_Ag1[[ts_val]]])
			} else {
				clas_Ag1[[ts_val]]<<-as.matrix(datAgOne2.m2[[ts_val]][rnames,])				
			}
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){
					heatmap(clas_Ag1[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_Ag1[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Classification"))
			}
		}
		if(ts_name=="Agilent-TwoColor"){
			DE_Ag2<-DE_Ag2_2[[ts_val]]
			er_x<-try(DE_Ag2<-as.matrix(DE_Ag2),silent=TRUE)
			if(length(grep("Error",er_x))!=0)
			{
				rownames(DE_Ag2)<-as.character(DE_Ag2)
				DE_Ag2<-as.matrix(DE_Ag2)
			}
			rnames<-rownames(DE_Ag2)
			if(length(samp_Ag2[[ts_val]]!=0)){
				clas_Ag2[[ts_val]]<<-as.matrix(datAgTwo2.m2[[ts_val]][rnames,samp_Ag2[[ts_val]]])
			} else {
				clas_Ag2[[ts_val]]<<-as.matrix(datAgTwo2.m2[[ts_val]][rnames,])
			}
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){
					heatmap(clas_Ag2[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_Ag2[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Classification"))
			}
		}
		if(ts_name=="Illumina-Beadarray"){
			DE_Il_B<-DE_Il_B_2[[ts_val]]
			er_x<-try(DE_Il_B<-as.matrix(DE_Il_B),silent=TRUE)
			if(length(grep("Error",er_x))!=0)
			{
				rownames(DE_Il_B)<-as.character(DE_Il_B)
				DE_Il_B<-as.matrix(DE_Il_B)
			}
			rnames<-rownames(DE_Il_B)
			if(length(samp_Il_B[[ts_val]]!=0)){
				clas_Il_B[[ts_val]]<<-as.matrix(datIllBA2.m2[[ts_val]][rnames,samp_Il_B[[ts_val]]])
			} else {
				clas_Il_B[[ts_val]]<<-as.matrix(datIllBA2.m2[[ts_val]][rnames,])
			}
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){
					heatmap(clas_Il_B[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_Il_B[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Classification"))
			}
		}
		if(ts_name=="Illumina-Lumi"){
			DE_Il_L<-DE_Il_L_2[[ts_val]]
			er_x<-try(DE_Il_L<-as.matrix(DE_Il_L),silent=TRUE)
			if(length(grep("Error",er_x))!=0)
			{
				rownames(DE_Il_L)<-as.character(DE_Il_L)
				DE_Il_L<-as.matrix(DE_Il_L)
			}
			rnames<-rownames(DE_Il_L)
			if(length(samp_Il_L[[ts_val]]!=0)){
				clas_Il_L[[ts_val]]<<-as.matrix(lumi_NQ.m2[[ts_val]][rnames,samp_Il_L[[ts_val]]])
			} else {
				clas_Il_L[[ts_val]]<<-as.matrix(lumi_NQ.m2[[ts_val]][rnames,])
			}
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){
					heatmap(clas_Il_L[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_Il_L[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Classification"))
			}
		}
		if(ts_name=="Nimblegen"){
			DE_N<-DE_N_2[[ts_val]]
			er_x<-try(DE_N<-as.matrix(DE_N),silent=TRUE)
			if(length(grep("Error",er_x))!=0)
			{
				rownames(DE_N)<-as.character(DE_N)
				DE_N<-as.matrix(DE_N)
			}
			rnames<-rownames(DE_N)
			if(length(samp_N[[ts_val]]!=0)){
				clas_N[[ts_val]]<<-as.matrix(data.matrix_Nimblegen2.m2[[ts_val]][rnames,samp_N[[ts_val]]])
			} else {
				clas_N[[ts_val]]<<-as.matrix(data.matrix_Nimblegen2.m2[[ts_val]][rnames,])
			}
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){
					heatmap(clas_N[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_N[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Classification"))
			}
		}
		if(ts_name=="Series-Matrix"){
			DE_S<-DE_S_2[[ts_val]]
			er_x<-try(DE_S<-as.matrix(DE_S),silent=TRUE)
			if(length(grep("Error",er_x))!=0)
			{
				rownames(DE_S)<-as.character(DE_S)
				DE_S<-as.matrix(DE_S)
			}
			rnames<-rownames(DE_S)
			if(length(samp_S[[ts_val]]!=0)){
				clas_S[[ts_val]]<<-as.matrix(data.matrixNorm.m2[[ts_val]][rnames,samp_S[[ts_val]]])
			} else {
				clas_S[[ts_val]]<<-as.matrix(data.matrixNorm.m2[[ts_val]][rnames,])
			}
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){
					heatmap(clas_S[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_S[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Classification"))
			}
		}
		if(ts_name=="Online-Data"){
			DE_O<-DE_O_2[[ts_val]]
			er_x<-try(DE_O<-as.matrix(DE_O),silent=TRUE)
			if(length(grep("Error",er_x))!=0)
			{
				rownames(DE_O)<-as.character(DE_O)
				DE_O<-as.matrix(DE_O)
			}
			rnames<-rownames(DE_O)
			if(length(samp_O[[ts_val]]!=0)){
				clas_O[[ts_val]]<<-as.matrix(data.matrix_onlineNorm.m2[[ts_val]][rnames,samp_O[[ts_val]]])
			} else {
				clas_O[[ts_val]]<<-as.matrix(data.matrix_onlineNorm.m2[[ts_val]][rnames,])
			}
			if(is.null(ma_img)==TRUE){
				try(tkpack.forget(tableData,scrX,scrY),silent=TRUE)
				try(tkwm.withdraw(w_legend),silent=TRUE)
				ma_img<<-tkrplot(getToolkitWidget(ma_frame2),function(...){
					heatmap(clas_O[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
				ma_img2<<-ma_img
				tkpack(ma_img2)			
			}else{
				ma_img2<<-tkrreplot(ma_img,function(...){
					heatmap(clas_O[[ts_val]],Rowv=NA,Colv=NA,cexCol=0.8,cexRow=0.8,col=heatcol)
				},hscale=1.7,vscale=1.07)
			}
			for(i in 1:length(children)){
				x<-as.character(tcl(treeview,"item",children[i],"-values"))
				if(x==r_choice[1])p_enter_class<-tcl(treeview,"insert",children[i],"end",values=as.tclObj("...Classification"))
			}
		}
	})
}
pb_ma<-tkProgressBar(title="Loading packages...",label="",min=0,max=1,initial=0,width=500)
setTkProgressBar(pb_ma,0.2,title=NULL,label="")
if(!requireNamespace("gWidgets2tcltk",quietly=TRUE)){install.packages("gWidgets2tcltk");library(gWidgets2tcltk)} else {library(gWidgets2tcltk)}
setTkProgressBar(pb_ma,0.6,title=NULL,label="")
if(!requireNamespace("tkrplot",quietly=TRUE)){install.packages("tkrplot");library(tkrplot)} else {library(tkrplot)}
setTkProgressBar(pb_ma,1,title="Done...",label="")				
close(pb_ma)
clas()
